/* Copyright (c) 2001, Stanford University
	All rights reserved.

	See the file LICENSE.txt for information on redistributing this software. */
	

/* DO NOT EDIT - THIS FILE AUTOMATICALLY GENERATED BY server_dispatch.py SCRIPT */
#include "cr_spu.h"
#include "chromium.h"
#include "cr_error.h"
#include "server_dispatch.h"
#include "server.h"
#include "cr_unpack.h"

CRCurrentStatePointers crServerCurrent;

#if defined(CR_EXT_stencil_two_side)
void SERVER_DISPATCH_APIENTRY crServerDispatchActiveStencilFaceEXT(GLenum face)
{
	crStateActiveStencilFaceEXT(&cr_server.StateTracker, face);
	cr_server.head_spu->dispatch_table.ActiveStencilFaceEXT(face);
}
#endif
#if defined(CR_ARB_multitexture)
void SERVER_DISPATCH_APIENTRY crServerDispatchActiveTextureARB(GLenum texture)
{
	crStateActiveTextureARB(&cr_server.StateTracker, texture);
	cr_server.head_spu->dispatch_table.ActiveTextureARB(texture);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchAlphaFunc(GLenum func, GLclampf ref)
{
	crStateAlphaFunc(&cr_server.StateTracker, func, ref);
	cr_server.head_spu->dispatch_table.AlphaFunc(func, ref);
}
#if defined(CR_ARB_occlusion_query)
void SERVER_DISPATCH_APIENTRY crServerDispatchBeginQueryARB(GLenum target, GLuint id)
{
	crStateBeginQueryARB(&cr_server.StateTracker, target, id);
	cr_server.head_spu->dispatch_table.BeginQueryARB(target, id);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchBitmap(GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, const GLubyte * bitmap)
{
	crStateBitmap(&cr_server.StateTracker, width, height, xorig, yorig, xmove, ymove, bitmap);
	cr_server.head_spu->dispatch_table.Bitmap(width, height, xorig, yorig, xmove, ymove, bitmap);
}
#if defined(CR_EXT_blend_color)
void SERVER_DISPATCH_APIENTRY crServerDispatchBlendColorEXT(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
	crStateBlendColorEXT(&cr_server.StateTracker, red, green, blue, alpha);
	cr_server.head_spu->dispatch_table.BlendColorEXT(red, green, blue, alpha);
}
#endif
#if defined(CR_EXT_blend_minmax)
void SERVER_DISPATCH_APIENTRY crServerDispatchBlendEquationEXT(GLenum mode)
{
	crStateBlendEquationEXT(&cr_server.StateTracker, mode);
	cr_server.head_spu->dispatch_table.BlendEquationEXT(mode);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchBlendFunc(GLenum sfactor, GLenum dfactor)
{
	crStateBlendFunc(&cr_server.StateTracker, sfactor, dfactor);
	cr_server.head_spu->dispatch_table.BlendFunc(sfactor, dfactor);
}
#if defined(CR_EXT_blend_func_separate)
void SERVER_DISPATCH_APIENTRY crServerDispatchBlendFuncSeparateEXT(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorA, GLenum dfactorA)
{
	crStateBlendFuncSeparateEXT(&cr_server.StateTracker, sfactorRGB, dfactorRGB, sfactorA, dfactorA);
	cr_server.head_spu->dispatch_table.BlendFuncSeparateEXT(sfactorRGB, dfactorRGB, sfactorA, dfactorA);
}
#endif
#if defined(CR_ARB_vertex_buffer_object)
void SERVER_DISPATCH_APIENTRY crServerDispatchBufferDataARB(GLenum target, GLsizeiptrARB size, const GLvoid * data, GLenum usage)
{
	crStateBufferDataARB(&cr_server.StateTracker, target, size, data, usage);
	cr_server.head_spu->dispatch_table.BufferDataARB(target, size, data, usage);
}
#endif
#if defined(CR_ARB_vertex_buffer_object)
void SERVER_DISPATCH_APIENTRY crServerDispatchBufferSubDataARB(GLenum target, GLintptrARB offset, GLsizeiptrARB size, const GLvoid * data)
{
	crStateBufferSubDataARB(&cr_server.StateTracker, target, offset, size, data);
	cr_server.head_spu->dispatch_table.BufferSubDataARB(target, offset, size, data);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchClearAccum(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
	crStateClearAccum(&cr_server.StateTracker, red, green, blue, alpha);
	cr_server.head_spu->dispatch_table.ClearAccum(red, green, blue, alpha);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchClearColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
	crStateClearColor(&cr_server.StateTracker, red, green, blue, alpha);
	cr_server.head_spu->dispatch_table.ClearColor(red, green, blue, alpha);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchClearDepth(GLclampd depth)
{
	crStateClearDepth(&cr_server.StateTracker, depth);
	cr_server.head_spu->dispatch_table.ClearDepth(depth);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchClearIndex(GLfloat c)
{
	crStateClearIndex(&cr_server.StateTracker, c);
	cr_server.head_spu->dispatch_table.ClearIndex(c);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchClearStencil(GLint s)
{
	crStateClearStencil(&cr_server.StateTracker, s);
	cr_server.head_spu->dispatch_table.ClearStencil(s);
}
#if defined(CR_ARB_multitexture)
void SERVER_DISPATCH_APIENTRY crServerDispatchClientActiveTextureARB(GLenum texture)
{
	crStateClientActiveTextureARB(&cr_server.StateTracker, texture);
	cr_server.head_spu->dispatch_table.ClientActiveTextureARB(texture);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchClipPlane(GLenum plane, const GLdouble * equation)
{
	crStateClipPlane(&cr_server.StateTracker, plane, equation);
	cr_server.head_spu->dispatch_table.ClipPlane(plane, equation);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchColor3fv(const GLfloat * v)
{
	crStateColor3fv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.Color3fv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchColor4fv(const GLfloat * v)
{
	crStateColor4fv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.Color4fv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchColorMask(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha)
{
	crStateColorMask(&cr_server.StateTracker, red, green, blue, alpha);
	cr_server.head_spu->dispatch_table.ColorMask(red, green, blue, alpha);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchColorMaterial(GLenum face, GLenum mode)
{
	crStateColorMaterial(&cr_server.StateTracker, face, mode);
	cr_server.head_spu->dispatch_table.ColorMaterial(face, mode);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchColorPointer(GLint size, GLenum type, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateColorPointer(&cr_server.StateTracker, size, type, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.ColorPointer(size, type, stride, pointer, fRealPtr);
}
#if defined(CR_NV_register_combiners)
void SERVER_DISPATCH_APIENTRY crServerDispatchCombinerInputNV(GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
{
	crStateCombinerInputNV(&cr_server.StateTracker, stage, portion, variable, input, mapping, componentUsage);
	cr_server.head_spu->dispatch_table.CombinerInputNV(stage, portion, variable, input, mapping, componentUsage);
}
#endif
#if defined(CR_NV_register_combiners)
void SERVER_DISPATCH_APIENTRY crServerDispatchCombinerOutputNV(GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum)
{
	crStateCombinerOutputNV(&cr_server.StateTracker, stage, portion, abOutput, cdOutput, sumOutput, scale, bias, abDotProduct, cdDotProduct, muxSum);
	cr_server.head_spu->dispatch_table.CombinerOutputNV(stage, portion, abOutput, cdOutput, sumOutput, scale, bias, abDotProduct, cdDotProduct, muxSum);
}
#endif
#if defined(CR_NV_register_combiners)
void SERVER_DISPATCH_APIENTRY crServerDispatchCombinerParameterfNV(GLenum pname, GLfloat param)
{
	crStateCombinerParameterfNV(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.CombinerParameterfNV(pname, param);
}
#endif
#if defined(CR_NV_register_combiners)
void SERVER_DISPATCH_APIENTRY crServerDispatchCombinerParameterfvNV(GLenum pname, const GLfloat * params)
{
	crStateCombinerParameterfvNV(&cr_server.StateTracker, pname, params);
	cr_server.head_spu->dispatch_table.CombinerParameterfvNV(pname, params);
}
#endif
#if defined(CR_NV_register_combiners)
void SERVER_DISPATCH_APIENTRY crServerDispatchCombinerParameteriNV(GLenum pname, GLint param)
{
	crStateCombinerParameteriNV(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.CombinerParameteriNV(pname, param);
}
#endif
#if defined(CR_NV_register_combiners)
void SERVER_DISPATCH_APIENTRY crServerDispatchCombinerParameterivNV(GLenum pname, const GLint * params)
{
	crStateCombinerParameterivNV(&cr_server.StateTracker, pname, params);
	cr_server.head_spu->dispatch_table.CombinerParameterivNV(pname, params);
}
#endif
#if defined(CR_NV_register_combiners2)
void SERVER_DISPATCH_APIENTRY crServerDispatchCombinerStageParameterfvNV(GLenum stage, GLenum pname, const GLfloat * params)
{
	crStateCombinerStageParameterfvNV(&cr_server.StateTracker, stage, pname, params);
	cr_server.head_spu->dispatch_table.CombinerStageParameterfvNV(stage, pname, params);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchCullFace(GLenum mode)
{
	crStateCullFace(&cr_server.StateTracker, mode);
	cr_server.head_spu->dispatch_table.CullFace(mode);
}
#if defined(CR_NV_fence)
void SERVER_DISPATCH_APIENTRY crServerDispatchDeleteFencesNV(GLsizei n, const GLuint * fences)
{
	crStateDeleteFencesNV(&cr_server.StateTracker, n, fences);
	cr_server.head_spu->dispatch_table.DeleteFencesNV(n, fences);
}
#endif
#if defined(CR_ARB_occlusion_query)
void SERVER_DISPATCH_APIENTRY crServerDispatchDeleteQueriesARB(GLsizei n, const GLuint * ids)
{
	crStateDeleteQueriesARB(&cr_server.StateTracker, n, ids);
	cr_server.head_spu->dispatch_table.DeleteQueriesARB(n, ids);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchDepthFunc(GLenum func)
{
	crStateDepthFunc(&cr_server.StateTracker, func);
	cr_server.head_spu->dispatch_table.DepthFunc(func);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchDepthMask(GLboolean flag)
{
	crStateDepthMask(&cr_server.StateTracker, flag);
	cr_server.head_spu->dispatch_table.DepthMask(flag);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchDepthRange(GLclampd zNear, GLclampd zFar)
{
	crStateDepthRange(&cr_server.StateTracker, zNear, zFar);
	cr_server.head_spu->dispatch_table.DepthRange(zNear, zFar);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchDisable(GLenum cap)
{
	crStateDisable(&cr_server.StateTracker, cap);
	cr_server.head_spu->dispatch_table.Disable(cap);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchDisableClientState(GLenum array)
{
	crStateDisableClientState(&cr_server.StateTracker, array);
	cr_server.head_spu->dispatch_table.DisableClientState(array);
}
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchDisableVertexAttribArrayARB(GLuint index)
{
	crStateDisableVertexAttribArrayARB(&cr_server.StateTracker, index);
	cr_server.head_spu->dispatch_table.DisableVertexAttribArrayARB(index);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchEdgeFlagPointer(GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateEdgeFlagPointer(&cr_server.StateTracker, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.EdgeFlagPointer(stride, pointer, fRealPtr);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchEnable(GLenum cap)
{
	crStateEnable(&cr_server.StateTracker, cap);
	cr_server.head_spu->dispatch_table.Enable(cap);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchEnableClientState(GLenum array)
{
	crStateEnableClientState(&cr_server.StateTracker, array);
	cr_server.head_spu->dispatch_table.EnableClientState(array);
}
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchEnableVertexAttribArrayARB(GLuint index)
{
	crStateEnableVertexAttribArrayARB(&cr_server.StateTracker, index);
	cr_server.head_spu->dispatch_table.EnableVertexAttribArrayARB(index);
}
#endif
#if defined(CR_ARB_occlusion_query)
void SERVER_DISPATCH_APIENTRY crServerDispatchEndQueryARB(GLenum target)
{
	crStateEndQueryARB(&cr_server.StateTracker, target);
	cr_server.head_spu->dispatch_table.EndQueryARB(target);
}
#endif
#if defined(CR_NV_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchExecuteProgramNV(GLenum target, GLuint id, const GLfloat * params)
{
	crStateExecuteProgramNV(&cr_server.StateTracker, target, id, params);
	cr_server.head_spu->dispatch_table.ExecuteProgramNV(target, id, params);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchFeedbackBuffer(GLsizei size, GLenum type, GLfloat * buffer)
{
	crStateFeedbackBuffer(&cr_server.StateTracker, size, type, buffer);
	cr_server.head_spu->dispatch_table.FeedbackBuffer(size, type, buffer);
}
#if defined(CR_NV_register_combiners)
void SERVER_DISPATCH_APIENTRY crServerDispatchFinalCombinerInputNV(GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
{
	crStateFinalCombinerInputNV(&cr_server.StateTracker, variable, input, mapping, componentUsage);
	cr_server.head_spu->dispatch_table.FinalCombinerInputNV(variable, input, mapping, componentUsage);
}
#endif
#if defined(CR_NV_fence)
void SERVER_DISPATCH_APIENTRY crServerDispatchFinishFenceNV(GLuint fence)
{
	crStateFinishFenceNV(&cr_server.StateTracker, fence);
	cr_server.head_spu->dispatch_table.FinishFenceNV(fence);
}
#endif
#if defined(CR_NV_vertex_array_range)
void SERVER_DISPATCH_APIENTRY crServerDispatchFlushVertexArrayRangeNV(void)
{
	crStateFlushVertexArrayRangeNV(&cr_server.StateTracker);
	cr_server.head_spu->dispatch_table.FlushVertexArrayRangeNV();
}
#endif
#if defined(CR_EXT_fog_coord)
void SERVER_DISPATCH_APIENTRY crServerDispatchFogCoordPointerEXT(GLenum type, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateFogCoordPointerEXT(&cr_server.StateTracker, type, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.FogCoordPointerEXT(type, stride, pointer, fRealPtr);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchFogf(GLenum pname, GLfloat param)
{
	crStateFogf(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.Fogf(pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchFogfv(GLenum pname, const GLfloat * params)
{
	crStateFogfv(&cr_server.StateTracker, pname, params);
	cr_server.head_spu->dispatch_table.Fogfv(pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchFogi(GLenum pname, GLint param)
{
	crStateFogi(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.Fogi(pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchFogiv(GLenum pname, const GLint * params)
{
	crStateFogiv(&cr_server.StateTracker, pname, params);
	cr_server.head_spu->dispatch_table.Fogiv(pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchFrontFace(GLenum mode)
{
	crStateFrontFace(&cr_server.StateTracker, mode);
	cr_server.head_spu->dispatch_table.FrontFace(mode);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchFrustum(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
	crStateFrustum(&cr_server.StateTracker, left, right, bottom, top, zNear, zFar);
	cr_server.head_spu->dispatch_table.Frustum(left, right, bottom, top, zNear, zFar);
}
#if defined(CR_EXT_framebuffer_object)
void SERVER_DISPATCH_APIENTRY crServerDispatchGenerateMipmapEXT(GLenum target)
{
	crStateGenerateMipmapEXT(&cr_server.StateTracker, target);
	cr_server.head_spu->dispatch_table.GenerateMipmapEXT(target);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchHint(GLenum target, GLenum mode)
{
	crStateHint(&cr_server.StateTracker, target, mode);
	cr_server.head_spu->dispatch_table.Hint(target, mode);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchIndexMask(GLuint mask)
{
	crStateIndexMask(&cr_server.StateTracker, mask);
	cr_server.head_spu->dispatch_table.IndexMask(mask);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchIndexPointer(GLenum type, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateIndexPointer(&cr_server.StateTracker, type, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.IndexPointer(type, stride, pointer, fRealPtr);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchInitNames(void)
{
	crStateInitNames(&cr_server.StateTracker);
	cr_server.head_spu->dispatch_table.InitNames();
}
void SERVER_DISPATCH_APIENTRY crServerDispatchInterleavedArrays(GLenum format, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateInterleavedArrays(&cr_server.StateTracker, format, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.InterleavedArrays(format, stride, pointer, fRealPtr);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLightModelf(GLenum pname, GLfloat param)
{
	crStateLightModelf(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.LightModelf(pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLightModelfv(GLenum pname, const GLfloat * params)
{
	crStateLightModelfv(&cr_server.StateTracker, pname, params);
	cr_server.head_spu->dispatch_table.LightModelfv(pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLightModeli(GLenum pname, GLint param)
{
	crStateLightModeli(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.LightModeli(pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLightModeliv(GLenum pname, const GLint * params)
{
	crStateLightModeliv(&cr_server.StateTracker, pname, params);
	cr_server.head_spu->dispatch_table.LightModeliv(pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLightf(GLenum light, GLenum pname, GLfloat param)
{
	crStateLightf(&cr_server.StateTracker, light, pname, param);
	cr_server.head_spu->dispatch_table.Lightf(light, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLightfv(GLenum light, GLenum pname, const GLfloat * params)
{
	crStateLightfv(&cr_server.StateTracker, light, pname, params);
	cr_server.head_spu->dispatch_table.Lightfv(light, pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLighti(GLenum light, GLenum pname, GLint param)
{
	crStateLighti(&cr_server.StateTracker, light, pname, param);
	cr_server.head_spu->dispatch_table.Lighti(light, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLightiv(GLenum light, GLenum pname, const GLint * params)
{
	crStateLightiv(&cr_server.StateTracker, light, pname, params);
	cr_server.head_spu->dispatch_table.Lightiv(light, pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLineStipple(GLint factor, GLushort pattern)
{
	crStateLineStipple(&cr_server.StateTracker, factor, pattern);
	cr_server.head_spu->dispatch_table.LineStipple(factor, pattern);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLineWidth(GLfloat width)
{
	crStateLineWidth(&cr_server.StateTracker, width);
	cr_server.head_spu->dispatch_table.LineWidth(width);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchListBase(GLuint base)
{
	crStateListBase(&cr_server.StateTracker, base);
	cr_server.head_spu->dispatch_table.ListBase(base);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchLoadName(GLuint name)
{
	crStateLoadName(&cr_server.StateTracker, name);
	cr_server.head_spu->dispatch_table.LoadName(name);
}
#if defined(CR_ARB_transpose_matrix)
void SERVER_DISPATCH_APIENTRY crServerDispatchLoadTransposeMatrixdARB(const GLdouble * m)
{
	crStateLoadTransposeMatrixdARB(&cr_server.StateTracker, m);
	cr_server.head_spu->dispatch_table.LoadTransposeMatrixdARB(m);
}
#endif
#if defined(CR_ARB_transpose_matrix)
void SERVER_DISPATCH_APIENTRY crServerDispatchLoadTransposeMatrixfARB(const GLfloat * m)
{
	crStateLoadTransposeMatrixfARB(&cr_server.StateTracker, m);
	cr_server.head_spu->dispatch_table.LoadTransposeMatrixfARB(m);
}
#endif
#if defined(CR_EXT_compiled_vertex_array)
void SERVER_DISPATCH_APIENTRY crServerDispatchLockArraysEXT(GLint first, GLint count)
{
	crStateLockArraysEXT(&cr_server.StateTracker, first, count);
	cr_server.head_spu->dispatch_table.LockArraysEXT(first, count);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchLogicOp(GLenum opcode)
{
	crStateLogicOp(&cr_server.StateTracker, opcode);
	cr_server.head_spu->dispatch_table.LogicOp(opcode);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMap1d(GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble * points)
{
	crStateMap1d(&cr_server.StateTracker, target, u1, u2, stride, order, points);
	cr_server.head_spu->dispatch_table.Map1d(target, u1, u2, stride, order, points);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMap1f(GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat * points)
{
	crStateMap1f(&cr_server.StateTracker, target, u1, u2, stride, order, points);
	cr_server.head_spu->dispatch_table.Map1f(target, u1, u2, stride, order, points);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMap2d(GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble * points)
{
	crStateMap2d(&cr_server.StateTracker, target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
	cr_server.head_spu->dispatch_table.Map2d(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMap2f(GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat * points)
{
	crStateMap2f(&cr_server.StateTracker, target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
	cr_server.head_spu->dispatch_table.Map2f(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMapGrid1d(GLint un, GLdouble u1, GLdouble u2)
{
	crStateMapGrid1d(&cr_server.StateTracker, un, u1, u2);
	cr_server.head_spu->dispatch_table.MapGrid1d(un, u1, u2);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMapGrid1f(GLint un, GLfloat u1, GLfloat u2)
{
	crStateMapGrid1f(&cr_server.StateTracker, un, u1, u2);
	cr_server.head_spu->dispatch_table.MapGrid1f(un, u1, u2);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMapGrid2d(GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2)
{
	crStateMapGrid2d(&cr_server.StateTracker, un, u1, u2, vn, v1, v2);
	cr_server.head_spu->dispatch_table.MapGrid2d(un, u1, u2, vn, v1, v2);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMapGrid2f(GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2)
{
	crStateMapGrid2f(&cr_server.StateTracker, un, u1, u2, vn, v1, v2);
	cr_server.head_spu->dispatch_table.MapGrid2f(un, u1, u2, vn, v1, v2);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMaterialf(GLenum face, GLenum pname, GLfloat param)
{
	crStateMaterialf(&cr_server.StateTracker, face, pname, param);
	cr_server.head_spu->dispatch_table.Materialf(face, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMaterialfv(GLenum face, GLenum pname, const GLfloat * params)
{
	crStateMaterialfv(&cr_server.StateTracker, face, pname, params);
	cr_server.head_spu->dispatch_table.Materialfv(face, pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMateriali(GLenum face, GLenum pname, GLint param)
{
	crStateMateriali(&cr_server.StateTracker, face, pname, param);
	cr_server.head_spu->dispatch_table.Materiali(face, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMaterialiv(GLenum face, GLenum pname, const GLint * params)
{
	crStateMaterialiv(&cr_server.StateTracker, face, pname, params);
	cr_server.head_spu->dispatch_table.Materialiv(face, pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchMatrixMode(GLenum mode)
{
	crStateMatrixMode(&cr_server.StateTracker, mode);
	cr_server.head_spu->dispatch_table.MatrixMode(mode);
}
#if defined(CR_ARB_transpose_matrix)
void SERVER_DISPATCH_APIENTRY crServerDispatchMultTransposeMatrixdARB(const GLdouble * m)
{
	crStateMultTransposeMatrixdARB(&cr_server.StateTracker, m);
	cr_server.head_spu->dispatch_table.MultTransposeMatrixdARB(m);
}
#endif
#if defined(CR_ARB_transpose_matrix)
void SERVER_DISPATCH_APIENTRY crServerDispatchMultTransposeMatrixfARB(const GLfloat * m)
{
	crStateMultTransposeMatrixfARB(&cr_server.StateTracker, m);
	cr_server.head_spu->dispatch_table.MultTransposeMatrixfARB(m);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchNormalPointer(GLenum type, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateNormalPointer(&cr_server.StateTracker, type, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.NormalPointer(type, stride, pointer, fRealPtr);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchOrtho(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
	crStateOrtho(&cr_server.StateTracker, left, right, bottom, top, zNear, zFar);
	cr_server.head_spu->dispatch_table.Ortho(left, right, bottom, top, zNear, zFar);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPassThrough(GLfloat token)
{
	crStatePassThrough(&cr_server.StateTracker, token);
	cr_server.head_spu->dispatch_table.PassThrough(token);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPixelMapfv(GLenum map, GLsizei mapsize, const GLfloat * values)
{
	crStatePixelMapfv(&cr_server.StateTracker, map, mapsize, values);
	cr_server.head_spu->dispatch_table.PixelMapfv(map, mapsize, values);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPixelMapuiv(GLenum map, GLsizei mapsize, const GLuint * values)
{
	crStatePixelMapuiv(&cr_server.StateTracker, map, mapsize, values);
	cr_server.head_spu->dispatch_table.PixelMapuiv(map, mapsize, values);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPixelMapusv(GLenum map, GLsizei mapsize, const GLushort * values)
{
	crStatePixelMapusv(&cr_server.StateTracker, map, mapsize, values);
	cr_server.head_spu->dispatch_table.PixelMapusv(map, mapsize, values);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPixelStoref(GLenum pname, GLfloat param)
{
	crStatePixelStoref(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.PixelStoref(pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPixelStorei(GLenum pname, GLint param)
{
	crStatePixelStorei(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.PixelStorei(pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPixelTransferf(GLenum pname, GLfloat param)
{
	crStatePixelTransferf(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.PixelTransferf(pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPixelTransferi(GLenum pname, GLint param)
{
	crStatePixelTransferi(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.PixelTransferi(pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPixelZoom(GLfloat xfactor, GLfloat yfactor)
{
	crStatePixelZoom(&cr_server.StateTracker, xfactor, yfactor);
	cr_server.head_spu->dispatch_table.PixelZoom(xfactor, yfactor);
}
#if defined(CR_ARB_point_parameters)
void SERVER_DISPATCH_APIENTRY crServerDispatchPointParameterfARB(GLenum pname, GLfloat param)
{
	crStatePointParameterfARB(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.PointParameterfARB(pname, param);
}
#endif
#if defined(CR_ARB_point_parameters)
void SERVER_DISPATCH_APIENTRY crServerDispatchPointParameterfvARB(GLenum pname, const GLfloat * params)
{
	crStatePointParameterfvARB(&cr_server.StateTracker, pname, params);
	cr_server.head_spu->dispatch_table.PointParameterfvARB(pname, params);
}
#endif
#if defined(CR_OPENGL_VERSION_1_4)
void SERVER_DISPATCH_APIENTRY crServerDispatchPointParameteri(GLenum pname, GLint param)
{
	crStatePointParameteri(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.PointParameteri(pname, param);
}
#endif
#if defined(CR_OPENGL_VERSION_1_4)
void SERVER_DISPATCH_APIENTRY crServerDispatchPointParameteriv(GLenum pname, const GLint * param)
{
	crStatePointParameteriv(&cr_server.StateTracker, pname, param);
	cr_server.head_spu->dispatch_table.PointParameteriv(pname, param);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchPointSize(GLfloat size)
{
	crStatePointSize(&cr_server.StateTracker, size);
	cr_server.head_spu->dispatch_table.PointSize(size);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPolygonMode(GLenum face, GLenum mode)
{
	crStatePolygonMode(&cr_server.StateTracker, face, mode);
	cr_server.head_spu->dispatch_table.PolygonMode(face, mode);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPolygonOffset(GLfloat factor, GLfloat units)
{
	crStatePolygonOffset(&cr_server.StateTracker, factor, units);
	cr_server.head_spu->dispatch_table.PolygonOffset(factor, units);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPolygonStipple(const GLubyte * mask)
{
	crStatePolygonStipple(&cr_server.StateTracker, mask);
	cr_server.head_spu->dispatch_table.PolygonStipple(mask);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPopAttrib(void)
{
	crStatePopAttrib(&cr_server.StateTracker);
	cr_server.head_spu->dispatch_table.PopAttrib();
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPopClientAttrib(void)
{
	crStatePopClientAttrib(&cr_server.StateTracker);
	cr_server.head_spu->dispatch_table.PopClientAttrib();
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPopMatrix(void)
{
	crStatePopMatrix(&cr_server.StateTracker);
	cr_server.head_spu->dispatch_table.PopMatrix();
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPopName(void)
{
	crStatePopName(&cr_server.StateTracker);
	cr_server.head_spu->dispatch_table.PopName();
}
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramEnvParameter4dARB(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	crStateProgramEnvParameter4dARB(&cr_server.StateTracker, target, index, x, y, z, w);
	cr_server.head_spu->dispatch_table.ProgramEnvParameter4dARB(target, index, x, y, z, w);
}
#endif
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramEnvParameter4dvARB(GLenum target, GLuint index, const GLdouble * params)
{
	crStateProgramEnvParameter4dvARB(&cr_server.StateTracker, target, index, params);
	cr_server.head_spu->dispatch_table.ProgramEnvParameter4dvARB(target, index, params);
}
#endif
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramEnvParameter4fARB(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	crStateProgramEnvParameter4fARB(&cr_server.StateTracker, target, index, x, y, z, w);
	cr_server.head_spu->dispatch_table.ProgramEnvParameter4fARB(target, index, x, y, z, w);
}
#endif
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramEnvParameter4fvARB(GLenum target, GLuint index, const GLfloat * params)
{
	crStateProgramEnvParameter4fvARB(&cr_server.StateTracker, target, index, params);
	cr_server.head_spu->dispatch_table.ProgramEnvParameter4fvARB(target, index, params);
}
#endif
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramLocalParameter4dvARB(GLenum target, GLuint index, const GLdouble * params)
{
	crStateProgramLocalParameter4dvARB(&cr_server.StateTracker, target, index, params);
	cr_server.head_spu->dispatch_table.ProgramLocalParameter4dvARB(target, index, params);
}
#endif
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramLocalParameter4fvARB(GLenum target, GLuint index, const GLfloat * params)
{
	crStateProgramLocalParameter4fvARB(&cr_server.StateTracker, target, index, params);
	cr_server.head_spu->dispatch_table.ProgramLocalParameter4fvARB(target, index, params);
}
#endif
#if defined(CR_NV_fragment_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramNamedParameter4dNV(GLuint id, GLsizei len, const GLubyte * name, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	crStateProgramNamedParameter4dNV(&cr_server.StateTracker, id, len, name, x, y, z, w);
	cr_server.head_spu->dispatch_table.ProgramNamedParameter4dNV(id, len, name, x, y, z, w);
}
#endif
#if defined(CR_NV_fragment_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramNamedParameter4dvNV(GLuint id, GLsizei len, const GLubyte * name, const GLdouble * v)
{
	crStateProgramNamedParameter4dvNV(&cr_server.StateTracker, id, len, name, v);
	cr_server.head_spu->dispatch_table.ProgramNamedParameter4dvNV(id, len, name, v);
}
#endif
#if defined(CR_NV_fragment_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramNamedParameter4fNV(GLuint id, GLsizei len, const GLubyte * name, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	crStateProgramNamedParameter4fNV(&cr_server.StateTracker, id, len, name, x, y, z, w);
	cr_server.head_spu->dispatch_table.ProgramNamedParameter4fNV(id, len, name, x, y, z, w);
}
#endif
#if defined(CR_NV_fragment_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramNamedParameter4fvNV(GLuint id, GLsizei len, const GLubyte * name, const GLfloat * v)
{
	crStateProgramNamedParameter4fvNV(&cr_server.StateTracker, id, len, name, v);
	cr_server.head_spu->dispatch_table.ProgramNamedParameter4fvNV(id, len, name, v);
}
#endif
#if defined(CR_NV_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramParameter4dvNV(GLenum target, GLuint index, const GLdouble * params)
{
	crStateProgramParameter4dvNV(&cr_server.StateTracker, target, index, params);
	cr_server.head_spu->dispatch_table.ProgramParameter4dvNV(target, index, params);
}
#endif
#if defined(CR_NV_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramParameter4fvNV(GLenum target, GLuint index, const GLfloat * params)
{
	crStateProgramParameter4fvNV(&cr_server.StateTracker, target, index, params);
	cr_server.head_spu->dispatch_table.ProgramParameter4fvNV(target, index, params);
}
#endif
#if defined(CR_NV_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramParameters4dvNV(GLenum target, GLuint index, GLuint num, const GLdouble * params)
{
	crStateProgramParameters4dvNV(&cr_server.StateTracker, target, index, num, params);
	cr_server.head_spu->dispatch_table.ProgramParameters4dvNV(target, index, num, params);
}
#endif
#if defined(CR_NV_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchProgramParameters4fvNV(GLenum target, GLuint index, GLuint num, const GLfloat * params)
{
	crStateProgramParameters4fvNV(&cr_server.StateTracker, target, index, num, params);
	cr_server.head_spu->dispatch_table.ProgramParameters4fvNV(target, index, num, params);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchPushAttrib(GLbitfield mask)
{
	crStatePushAttrib(&cr_server.StateTracker, mask);
	cr_server.head_spu->dispatch_table.PushAttrib(mask);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPushClientAttrib(GLbitfield mask)
{
	crStatePushClientAttrib(&cr_server.StateTracker, mask);
	cr_server.head_spu->dispatch_table.PushClientAttrib(mask);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPushMatrix(void)
{
	crStatePushMatrix(&cr_server.StateTracker);
	cr_server.head_spu->dispatch_table.PushMatrix();
}
void SERVER_DISPATCH_APIENTRY crServerDispatchPushName(GLuint name)
{
	crStatePushName(&cr_server.StateTracker, name);
	cr_server.head_spu->dispatch_table.PushName(name);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos2d(GLdouble x, GLdouble y)
{
	crStateRasterPos2d(&cr_server.StateTracker, x, y);
	cr_server.head_spu->dispatch_table.RasterPos2d(x, y);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos2dv(const GLdouble * v)
{
	crStateRasterPos2dv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos2dv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos2f(GLfloat x, GLfloat y)
{
	crStateRasterPos2f(&cr_server.StateTracker, x, y);
	cr_server.head_spu->dispatch_table.RasterPos2f(x, y);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos2fv(const GLfloat * v)
{
	crStateRasterPos2fv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos2fv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos2i(GLint x, GLint y)
{
	crStateRasterPos2i(&cr_server.StateTracker, x, y);
	cr_server.head_spu->dispatch_table.RasterPos2i(x, y);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos2iv(const GLint * v)
{
	crStateRasterPos2iv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos2iv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos2s(GLshort x, GLshort y)
{
	crStateRasterPos2s(&cr_server.StateTracker, x, y);
	cr_server.head_spu->dispatch_table.RasterPos2s(x, y);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos2sv(const GLshort * v)
{
	crStateRasterPos2sv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos2sv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos3d(GLdouble x, GLdouble y, GLdouble z)
{
	crStateRasterPos3d(&cr_server.StateTracker, x, y, z);
	cr_server.head_spu->dispatch_table.RasterPos3d(x, y, z);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos3dv(const GLdouble * v)
{
	crStateRasterPos3dv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos3dv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos3f(GLfloat x, GLfloat y, GLfloat z)
{
	crStateRasterPos3f(&cr_server.StateTracker, x, y, z);
	cr_server.head_spu->dispatch_table.RasterPos3f(x, y, z);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos3fv(const GLfloat * v)
{
	crStateRasterPos3fv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos3fv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos3i(GLint x, GLint y, GLint z)
{
	crStateRasterPos3i(&cr_server.StateTracker, x, y, z);
	cr_server.head_spu->dispatch_table.RasterPos3i(x, y, z);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos3iv(const GLint * v)
{
	crStateRasterPos3iv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos3iv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos3s(GLshort x, GLshort y, GLshort z)
{
	crStateRasterPos3s(&cr_server.StateTracker, x, y, z);
	cr_server.head_spu->dispatch_table.RasterPos3s(x, y, z);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos3sv(const GLshort * v)
{
	crStateRasterPos3sv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos3sv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos4d(GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	crStateRasterPos4d(&cr_server.StateTracker, x, y, z, w);
	cr_server.head_spu->dispatch_table.RasterPos4d(x, y, z, w);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos4dv(const GLdouble * v)
{
	crStateRasterPos4dv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos4dv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos4f(GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	crStateRasterPos4f(&cr_server.StateTracker, x, y, z, w);
	cr_server.head_spu->dispatch_table.RasterPos4f(x, y, z, w);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos4fv(const GLfloat * v)
{
	crStateRasterPos4fv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos4fv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos4i(GLint x, GLint y, GLint z, GLint w)
{
	crStateRasterPos4i(&cr_server.StateTracker, x, y, z, w);
	cr_server.head_spu->dispatch_table.RasterPos4i(x, y, z, w);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos4iv(const GLint * v)
{
	crStateRasterPos4iv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos4iv(v);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos4s(GLshort x, GLshort y, GLshort z, GLshort w)
{
	crStateRasterPos4s(&cr_server.StateTracker, x, y, z, w);
	cr_server.head_spu->dispatch_table.RasterPos4s(x, y, z, w);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRasterPos4sv(const GLshort * v)
{
	crStateRasterPos4sv(&cr_server.StateTracker, v);
	cr_server.head_spu->dispatch_table.RasterPos4sv(v);
}
#if defined(CR_EXT_framebuffer_object)
void SERVER_DISPATCH_APIENTRY crServerDispatchRenderbufferStorageEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
{
	crStateRenderbufferStorageEXT(&cr_server.StateTracker, target, internalformat, width, height);
	cr_server.head_spu->dispatch_table.RenderbufferStorageEXT(target, internalformat, width, height);
}
#endif
#if defined(CR_NV_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchRequestResidentProgramsNV(GLsizei n, const GLuint * ids)
{
	crStateRequestResidentProgramsNV(&cr_server.StateTracker, n, ids);
	cr_server.head_spu->dispatch_table.RequestResidentProgramsNV(n, ids);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchRotated(GLdouble angle, GLdouble x, GLdouble y, GLdouble z)
{
	crStateRotated(&cr_server.StateTracker, angle, x, y, z);
	cr_server.head_spu->dispatch_table.Rotated(angle, x, y, z);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchRotatef(GLfloat angle, GLfloat x, GLfloat y, GLfloat z)
{
	crStateRotatef(&cr_server.StateTracker, angle, x, y, z);
	cr_server.head_spu->dispatch_table.Rotatef(angle, x, y, z);
}
#if defined(CR_ARB_multisample)
void SERVER_DISPATCH_APIENTRY crServerDispatchSampleCoverageARB(GLclampf value, GLboolean invert)
{
	crStateSampleCoverageARB(&cr_server.StateTracker, value, invert);
	cr_server.head_spu->dispatch_table.SampleCoverageARB(value, invert);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchScaled(GLdouble x, GLdouble y, GLdouble z)
{
	crStateScaled(&cr_server.StateTracker, x, y, z);
	cr_server.head_spu->dispatch_table.Scaled(x, y, z);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchScalef(GLfloat x, GLfloat y, GLfloat z)
{
	crStateScalef(&cr_server.StateTracker, x, y, z);
	cr_server.head_spu->dispatch_table.Scalef(x, y, z);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchScissor(GLint x, GLint y, GLsizei width, GLsizei height)
{
	crStateScissor(&cr_server.StateTracker, x, y, width, height);
	cr_server.head_spu->dispatch_table.Scissor(x, y, width, height);
}
#if defined(CR_EXT_secondary_color)
void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColorPointerEXT(GLint size, GLenum type, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateSecondaryColorPointerEXT(&cr_server.StateTracker, size, type, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.SecondaryColorPointerEXT(size, type, stride, pointer, fRealPtr);
}
#endif
#if defined(CR_NV_fence)
void SERVER_DISPATCH_APIENTRY crServerDispatchSetFenceNV(GLuint fence, GLenum condition)
{
	crStateSetFenceNV(&cr_server.StateTracker, fence, condition);
	cr_server.head_spu->dispatch_table.SetFenceNV(fence, condition);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchShadeModel(GLenum mode)
{
	crStateShadeModel(&cr_server.StateTracker, mode);
	cr_server.head_spu->dispatch_table.ShadeModel(mode);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchStencilFunc(GLenum func, GLint ref, GLuint mask)
{
	crStateStencilFunc(&cr_server.StateTracker, func, ref, mask);
	cr_server.head_spu->dispatch_table.StencilFunc(func, ref, mask);
}
#if defined(CR_OPENGL_VERSION_2_0)
void SERVER_DISPATCH_APIENTRY crServerDispatchStencilFuncSeparate(GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask)
{
	crStateStencilFuncSeparate(&cr_server.StateTracker, frontfunc, backfunc, ref, mask);
	cr_server.head_spu->dispatch_table.StencilFuncSeparate(frontfunc, backfunc, ref, mask);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchStencilMask(GLuint mask)
{
	crStateStencilMask(&cr_server.StateTracker, mask);
	cr_server.head_spu->dispatch_table.StencilMask(mask);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchStencilOp(GLenum fail, GLenum zfail, GLenum zpass)
{
	crStateStencilOp(&cr_server.StateTracker, fail, zfail, zpass);
	cr_server.head_spu->dispatch_table.StencilOp(fail, zfail, zpass);
}
#if defined(CR_OPENGL_VERSION_2_0)
void SERVER_DISPATCH_APIENTRY crServerDispatchStencilOpSeparate(GLenum face, GLenum fail, GLenum zfail, GLenum zpass)
{
	crStateStencilOpSeparate(&cr_server.StateTracker, face, fail, zfail, zpass);
	cr_server.head_spu->dispatch_table.StencilOpSeparate(face, fail, zfail, zpass);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoordPointer(GLint size, GLenum type, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateTexCoordPointer(&cr_server.StateTracker, size, type, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.TexCoordPointer(size, type, stride, pointer, fRealPtr);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexGend(GLenum coord, GLenum pname, GLdouble param)
{
	crStateTexGend(&cr_server.StateTracker, coord, pname, param);
	cr_server.head_spu->dispatch_table.TexGend(coord, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexGendv(GLenum coord, GLenum pname, const GLdouble * params)
{
	crStateTexGendv(&cr_server.StateTracker, coord, pname, params);
	cr_server.head_spu->dispatch_table.TexGendv(coord, pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexGenf(GLenum coord, GLenum pname, GLfloat param)
{
	crStateTexGenf(&cr_server.StateTracker, coord, pname, param);
	cr_server.head_spu->dispatch_table.TexGenf(coord, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexGenfv(GLenum coord, GLenum pname, const GLfloat * params)
{
	crStateTexGenfv(&cr_server.StateTracker, coord, pname, params);
	cr_server.head_spu->dispatch_table.TexGenfv(coord, pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexGeni(GLenum coord, GLenum pname, GLint param)
{
	crStateTexGeni(&cr_server.StateTracker, coord, pname, param);
	cr_server.head_spu->dispatch_table.TexGeni(coord, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexGeniv(GLenum coord, GLenum pname, const GLint * params)
{
	crStateTexGeniv(&cr_server.StateTracker, coord, pname, params);
	cr_server.head_spu->dispatch_table.TexGeniv(coord, pname, params);
}
#if defined(CR_EXT_texture3D)
void SERVER_DISPATCH_APIENTRY crServerDispatchTexImage3DEXT(GLenum target, GLint level, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid * pixels)
{
	crStateTexImage3DEXT(&cr_server.StateTracker, target, level, internalFormat, width, height, depth, border, format, type, pixels);
	cr_server.head_spu->dispatch_table.TexImage3DEXT(target, level, internalFormat, width, height, depth, border, format, type, pixels);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchTexParameterf(GLenum target, GLenum pname, GLfloat param)
{
	crStateTexParameterf(&cr_server.StateTracker, target, pname, param);
	cr_server.head_spu->dispatch_table.TexParameterf(target, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexParameterfv(GLenum target, GLenum pname, const GLfloat * params)
{
	crStateTexParameterfv(&cr_server.StateTracker, target, pname, params);
	cr_server.head_spu->dispatch_table.TexParameterfv(target, pname, params);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexParameteri(GLenum target, GLenum pname, GLint param)
{
	crStateTexParameteri(&cr_server.StateTracker, target, pname, param);
	cr_server.head_spu->dispatch_table.TexParameteri(target, pname, param);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTexParameteriv(GLenum target, GLenum pname, const GLint * params)
{
	crStateTexParameteriv(&cr_server.StateTracker, target, pname, params);
	cr_server.head_spu->dispatch_table.TexParameteriv(target, pname, params);
}
#if defined(CR_NV_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchTrackMatrixNV(GLenum target, GLuint address, GLenum matrix, GLenum transform)
{
	crStateTrackMatrixNV(&cr_server.StateTracker, target, address, matrix, transform);
	cr_server.head_spu->dispatch_table.TrackMatrixNV(target, address, matrix, transform);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchTranslated(GLdouble x, GLdouble y, GLdouble z)
{
	crStateTranslated(&cr_server.StateTracker, x, y, z);
	cr_server.head_spu->dispatch_table.Translated(x, y, z);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchTranslatef(GLfloat x, GLfloat y, GLfloat z)
{
	crStateTranslatef(&cr_server.StateTracker, x, y, z);
	cr_server.head_spu->dispatch_table.Translatef(x, y, z);
}
#if defined(CR_EXT_compiled_vertex_array)
void SERVER_DISPATCH_APIENTRY crServerDispatchUnlockArraysEXT(void)
{
	crStateUnlockArraysEXT(&cr_server.StateTracker);
	cr_server.head_spu->dispatch_table.UnlockArraysEXT();
}
#endif
#if defined(CR_NV_vertex_array_range)
void SERVER_DISPATCH_APIENTRY crServerDispatchVertexArrayRangeNV(GLsizei length, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateVertexArrayRangeNV(&cr_server.StateTracker, length, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.VertexArrayRangeNV(length, pointer, fRealPtr);
}
#endif
#if defined(CR_ARB_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttribPointerARB(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateVertexAttribPointerARB(&cr_server.StateTracker, index, size, type, normalized, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.VertexAttribPointerARB(index, size, type, normalized, stride, pointer, fRealPtr);
}
#endif
#if defined(CR_NV_vertex_program)
void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttribPointerNV(GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateVertexAttribPointerNV(&cr_server.StateTracker, index, size, type, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.VertexAttribPointerNV(index, size, type, stride, pointer, fRealPtr);
}
#endif
void SERVER_DISPATCH_APIENTRY crServerDispatchVertexPointer(GLint size, GLenum type, GLsizei stride, const GLvoid * pointer CRVBOX_HOST_ONLY_PARAM(int fRealPtr))
{
	crStateVertexPointer(&cr_server.StateTracker, size, type, stride, pointer, fRealPtr);
	cr_server.head_spu->dispatch_table.VertexPointer(size, type, stride, pointer, fRealPtr);
}
void SERVER_DISPATCH_APIENTRY crServerDispatchColor3b(GLbyte red, GLbyte green, GLbyte blue)
{
	
	{
		cr_server.head_spu->dispatch_table.Color3b(red, green, blue);
		cr_server.current.c.color.b3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor3d(GLdouble red, GLdouble green, GLdouble blue)
{
	
	{
		cr_server.head_spu->dispatch_table.Color3d(red, green, blue);
		cr_server.current.c.color.d3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor3f(GLfloat red, GLfloat green, GLfloat blue)
{
	
	{
		cr_server.head_spu->dispatch_table.Color3f(red, green, blue);
		cr_server.current.c.color.f3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor3i(GLint red, GLint green, GLint blue)
{
	
	{
		cr_server.head_spu->dispatch_table.Color3i(red, green, blue);
		cr_server.current.c.color.i3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor3s(GLshort red, GLshort green, GLshort blue)
{
	
	{
		cr_server.head_spu->dispatch_table.Color3s(red, green, blue);
		cr_server.current.c.color.s3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor3ub(GLubyte red, GLubyte green, GLubyte blue)
{
	
	{
		cr_server.head_spu->dispatch_table.Color3ub(red, green, blue);
		cr_server.current.c.color.ub3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor3ui(GLuint red, GLuint green, GLuint blue)
{
	
	{
		cr_server.head_spu->dispatch_table.Color3ui(red, green, blue);
		cr_server.current.c.color.ui3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor3us(GLushort red, GLushort green, GLushort blue)
{
	
	{
		cr_server.head_spu->dispatch_table.Color3us(red, green, blue);
		cr_server.current.c.color.us3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor4b(GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha)
{
	
	{
		cr_server.head_spu->dispatch_table.Color4b(red, green, blue, alpha);
		cr_server.current.c.color.b4 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor4d(GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha)
{
	
	{
		cr_server.head_spu->dispatch_table.Color4d(red, green, blue, alpha);
		cr_server.current.c.color.d4 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor4f(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
	
	{
		cr_server.head_spu->dispatch_table.Color4f(red, green, blue, alpha);
		cr_server.current.c.color.f4 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor4i(GLint red, GLint green, GLint blue, GLint alpha)
{
	
	{
		cr_server.head_spu->dispatch_table.Color4i(red, green, blue, alpha);
		cr_server.current.c.color.i4 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor4s(GLshort red, GLshort green, GLshort blue, GLshort alpha)
{
	
	{
		cr_server.head_spu->dispatch_table.Color4s(red, green, blue, alpha);
		cr_server.current.c.color.s4 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor4ub(GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha)
{
	
	{
		cr_server.head_spu->dispatch_table.Color4ub(red, green, blue, alpha);
		cr_server.current.c.color.ub4 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor4ui(GLuint red, GLuint green, GLuint blue, GLuint alpha)
{
	
	{
		cr_server.head_spu->dispatch_table.Color4ui(red, green, blue, alpha);
		cr_server.current.c.color.ui4 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchColor4us(GLushort red, GLushort green, GLushort blue, GLushort alpha)
{
	
	{
		cr_server.head_spu->dispatch_table.Color4us(red, green, blue, alpha);
		cr_server.current.c.color.us4 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchEdgeFlag(GLboolean flag)
{
	
	{
		cr_server.head_spu->dispatch_table.EdgeFlag(flag);
		cr_server.current.c.edgeFlag.l1 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchFogCoorddEXT(GLdouble coord)
{
	
	{
		cr_server.head_spu->dispatch_table.FogCoorddEXT(coord);
		cr_server.current.c.fogCoord.d1 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchFogCoordfEXT(GLfloat coord)
{
	
	{
		cr_server.head_spu->dispatch_table.FogCoordfEXT(coord);
		cr_server.current.c.fogCoord.f1 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchIndexd(GLdouble c)
{
	
	{
		cr_server.head_spu->dispatch_table.Indexd(c);
		cr_server.current.c.index.d1 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchIndexf(GLfloat c)
{
	
	{
		cr_server.head_spu->dispatch_table.Indexf(c);
		cr_server.current.c.index.f1 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchIndexi(GLint c)
{
	
	{
		cr_server.head_spu->dispatch_table.Indexi(c);
		cr_server.current.c.index.i1 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchIndexs(GLshort c)
{
	
	{
		cr_server.head_spu->dispatch_table.Indexs(c);
		cr_server.current.c.index.s1 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchIndexub(GLubyte c)
{
	
	{
		cr_server.head_spu->dispatch_table.Indexub(c);
		cr_server.current.c.index.ub1 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord1dARB(GLenum texture, GLdouble s)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord1dARB(texture, s);
		cr_server.current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord1fARB(GLenum texture, GLfloat s)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord1fARB(texture, s);
		cr_server.current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord1iARB(GLenum texture, GLint s)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord1iARB(texture, s);
		cr_server.current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord1sARB(GLenum texture, GLshort s)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord1sARB(texture, s);
		cr_server.current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord2dARB(GLenum texture, GLdouble s, GLdouble t)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord2dARB(texture, s, t);
		cr_server.current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord2fARB(GLenum texture, GLfloat s, GLfloat t)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord2fARB(texture, s, t);
		cr_server.current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord2iARB(GLenum texture, GLint s, GLint t)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord2iARB(texture, s, t);
		cr_server.current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord2sARB(GLenum texture, GLshort s, GLshort t)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord2sARB(texture, s, t);
		cr_server.current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord3dARB(GLenum texture, GLdouble s, GLdouble t, GLdouble r)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord3dARB(texture, s, t, r);
		cr_server.current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord3fARB(GLenum texture, GLfloat s, GLfloat t, GLfloat r)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord3fARB(texture, s, t, r);
		cr_server.current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord3iARB(GLenum texture, GLint s, GLint t, GLint r)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord3iARB(texture, s, t, r);
		cr_server.current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord3sARB(GLenum texture, GLshort s, GLshort t, GLshort r)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord3sARB(texture, s, t, r);
		cr_server.current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord4dARB(GLenum texture, GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord4dARB(texture, s, t, r, q);
		cr_server.current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord4fARB(GLenum texture, GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord4fARB(texture, s, t, r, q);
		cr_server.current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord4iARB(GLenum texture, GLint s, GLint t, GLint r, GLint q)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord4iARB(texture, s, t, r, q);
		cr_server.current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchMultiTexCoord4sARB(GLenum texture, GLshort s, GLshort t, GLshort r, GLshort q)
{
	if (texture >= GL_TEXTURE0_ARB && texture < GL_TEXTURE0_ARB + CR_MAX_TEXTURE_UNITS)
	{
		cr_server.head_spu->dispatch_table.MultiTexCoord4sARB(texture, s, t, r, q);
		cr_server.current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchNormal3b(GLbyte nx, GLbyte ny, GLbyte nz)
{
	
	{
		cr_server.head_spu->dispatch_table.Normal3b(nx, ny, nz);
		cr_server.current.c.normal.b3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchNormal3d(GLdouble nx, GLdouble ny, GLdouble nz)
{
	
	{
		cr_server.head_spu->dispatch_table.Normal3d(nx, ny, nz);
		cr_server.current.c.normal.d3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchNormal3f(GLfloat nx, GLfloat ny, GLfloat nz)
{
	
	{
		cr_server.head_spu->dispatch_table.Normal3f(nx, ny, nz);
		cr_server.current.c.normal.f3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchNormal3i(GLint nx, GLint ny, GLint nz)
{
	
	{
		cr_server.head_spu->dispatch_table.Normal3i(nx, ny, nz);
		cr_server.current.c.normal.i3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchNormal3s(GLshort nx, GLshort ny, GLshort nz)
{
	
	{
		cr_server.head_spu->dispatch_table.Normal3s(nx, ny, nz);
		cr_server.current.c.normal.s3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColor3bEXT(GLbyte red, GLbyte green, GLbyte blue)
{
	
	{
		cr_server.head_spu->dispatch_table.SecondaryColor3bEXT(red, green, blue);
		cr_server.current.c.secondaryColor.b3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColor3dEXT(GLdouble red, GLdouble green, GLdouble blue)
{
	
	{
		cr_server.head_spu->dispatch_table.SecondaryColor3dEXT(red, green, blue);
		cr_server.current.c.secondaryColor.d3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColor3fEXT(GLfloat red, GLfloat green, GLfloat blue)
{
	
	{
		cr_server.head_spu->dispatch_table.SecondaryColor3fEXT(red, green, blue);
		cr_server.current.c.secondaryColor.f3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColor3iEXT(GLint red, GLint green, GLint blue)
{
	
	{
		cr_server.head_spu->dispatch_table.SecondaryColor3iEXT(red, green, blue);
		cr_server.current.c.secondaryColor.i3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColor3sEXT(GLshort red, GLshort green, GLshort blue)
{
	
	{
		cr_server.head_spu->dispatch_table.SecondaryColor3sEXT(red, green, blue);
		cr_server.current.c.secondaryColor.s3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColor3ubEXT(GLubyte red, GLubyte green, GLubyte blue)
{
	
	{
		cr_server.head_spu->dispatch_table.SecondaryColor3ubEXT(red, green, blue);
		cr_server.current.c.secondaryColor.ub3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColor3uiEXT(GLuint red, GLuint green, GLuint blue)
{
	
	{
		cr_server.head_spu->dispatch_table.SecondaryColor3uiEXT(red, green, blue);
		cr_server.current.c.secondaryColor.ui3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchSecondaryColor3usEXT(GLushort red, GLushort green, GLushort blue)
{
	
	{
		cr_server.head_spu->dispatch_table.SecondaryColor3usEXT(red, green, blue);
		cr_server.current.c.secondaryColor.us3 = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord1d(GLdouble s)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord1d(s);
		cr_server.current.c.texCoord.d1[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord1f(GLfloat s)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord1f(s);
		cr_server.current.c.texCoord.f1[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord1i(GLint s)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord1i(s);
		cr_server.current.c.texCoord.i1[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord1s(GLshort s)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord1s(s);
		cr_server.current.c.texCoord.s1[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord2d(GLdouble s, GLdouble t)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord2d(s, t);
		cr_server.current.c.texCoord.d2[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord2f(GLfloat s, GLfloat t)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord2f(s, t);
		cr_server.current.c.texCoord.f2[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord2i(GLint s, GLint t)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord2i(s, t);
		cr_server.current.c.texCoord.i2[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord2s(GLshort s, GLshort t)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord2s(s, t);
		cr_server.current.c.texCoord.s2[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord3d(GLdouble s, GLdouble t, GLdouble r)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord3d(s, t, r);
		cr_server.current.c.texCoord.d3[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord3f(GLfloat s, GLfloat t, GLfloat r)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord3f(s, t, r);
		cr_server.current.c.texCoord.f3[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord3i(GLint s, GLint t, GLint r)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord3i(s, t, r);
		cr_server.current.c.texCoord.i3[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord3s(GLshort s, GLshort t, GLshort r)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord3s(s, t, r);
		cr_server.current.c.texCoord.s3[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord4d(GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord4d(s, t, r, q);
		cr_server.current.c.texCoord.d4[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord4f(GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord4f(s, t, r, q);
		cr_server.current.c.texCoord.f4[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord4i(GLint s, GLint t, GLint r, GLint q)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord4i(s, t, r, q);
		cr_server.current.c.texCoord.i4[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchTexCoord4s(GLshort s, GLshort t, GLshort r, GLshort q)
{
	
	{
		cr_server.head_spu->dispatch_table.TexCoord4s(s, t, r, q);
		cr_server.current.c.texCoord.s4[0] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib1dARB(GLuint index, GLdouble x)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib1dARB(index, x);
		cr_server.current.c.vertexAttrib.d1[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib1fARB(GLuint index, GLfloat x)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib1fARB(index, x);
		cr_server.current.c.vertexAttrib.f1[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib1sARB(GLuint index, GLshort x)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib1sARB(index, x);
		cr_server.current.c.vertexAttrib.s1[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib2dARB(GLuint index, GLdouble x, GLdouble y)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib2dARB(index, x, y);
		cr_server.current.c.vertexAttrib.d2[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib2fARB(GLuint index, GLfloat x, GLfloat y)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib2fARB(index, x, y);
		cr_server.current.c.vertexAttrib.f2[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib2sARB(GLuint index, GLshort x, GLshort y)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib2sARB(index, x, y);
		cr_server.current.c.vertexAttrib.s2[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib3dARB(GLuint index, GLdouble x, GLdouble y, GLdouble z)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib3dARB(index, x, y, z);
		cr_server.current.c.vertexAttrib.d3[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib3fARB(GLuint index, GLfloat x, GLfloat y, GLfloat z)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib3fARB(index, x, y, z);
		cr_server.current.c.vertexAttrib.f3[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib3sARB(GLuint index, GLshort x, GLshort y, GLshort z)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib3sARB(index, x, y, z);
		cr_server.current.c.vertexAttrib.s3[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib4NubARB(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib4NubARB(index, x, y, z, w);
		cr_server.current.c.vertexAttrib.ub4[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib4dARB(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib4dARB(index, x, y, z, w);
		cr_server.current.c.vertexAttrib.d4[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib4fARB(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib4fARB(index, x, y, z, w);
		cr_server.current.c.vertexAttrib.f4[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}

void SERVER_DISPATCH_APIENTRY crServerDispatchVertexAttrib4sARB(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
{
	if (index < CR_MAX_VERTEX_ATTRIBS)
	{
		cr_server.head_spu->dispatch_table.VertexAttrib4sARB(index, x, y, z, w);
		cr_server.current.c.vertexAttrib.s4[index] = cr_server.pUnpackerState->pbUnpackData;
	}
}


void crServerInitDispatch(void)
{
    crSPUInitDispatchTable( &(cr_server.dispatch) );
    crSPUCopyDispatchTable( &(cr_server.dispatch), &(cr_server.head_spu->dispatch_table ) );

#if defined(CR_EXT_stencil_two_side)
	cr_server.dispatch.ActiveStencilFaceEXT = crServerDispatchActiveStencilFaceEXT;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.ActiveTextureARB = crServerDispatchActiveTextureARB;
#endif
	cr_server.dispatch.AlphaFunc = crServerDispatchAlphaFunc;
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.AreProgramsResidentNV = crServerDispatchAreProgramsResidentNV;
#endif
	cr_server.dispatch.AreTexturesResident = crServerDispatchAreTexturesResident;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.AttachShader = crServerDispatchAttachShader;
#endif
	cr_server.dispatch.BarrierCreateCR = crServerDispatchBarrierCreateCR;
	cr_server.dispatch.BarrierDestroyCR = crServerDispatchBarrierDestroyCR;
	cr_server.dispatch.BarrierExecCR = crServerDispatchBarrierExecCR;
	cr_server.dispatch.Begin = crServerDispatchBegin;
#if defined(CR_ARB_occlusion_query)
	cr_server.dispatch.BeginQueryARB = crServerDispatchBeginQueryARB;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.BindAttribLocation = crServerDispatchBindAttribLocation;
#endif
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.BindBufferARB = crServerDispatchBindBufferARB;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.BindFramebufferEXT = crServerDispatchBindFramebufferEXT;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.BindProgramARB = crServerDispatchBindProgramARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.BindProgramNV = crServerDispatchBindProgramNV;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.BindRenderbufferEXT = crServerDispatchBindRenderbufferEXT;
#endif
	cr_server.dispatch.BindTexture = crServerDispatchBindTexture;
	cr_server.dispatch.Bitmap = crServerDispatchBitmap;
#if defined(CR_EXT_blend_color)
	cr_server.dispatch.BlendColorEXT = crServerDispatchBlendColorEXT;
#endif
#if defined(CR_EXT_blend_minmax)
	cr_server.dispatch.BlendEquationEXT = crServerDispatchBlendEquationEXT;
#endif
	cr_server.dispatch.BlendFunc = crServerDispatchBlendFunc;
#if defined(CR_EXT_blend_func_separate)
	cr_server.dispatch.BlendFuncSeparateEXT = crServerDispatchBlendFuncSeparateEXT;
#endif
#if defined(CR_EXT_framebuffer_blit)
	cr_server.dispatch.BlitFramebufferEXT = crServerDispatchBlitFramebufferEXT;
#endif
	cr_server.dispatch.BoundsInfoCR = crServerDispatchBoundsInfoCR;
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.BufferDataARB = crServerDispatchBufferDataARB;
#endif
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.BufferSubDataARB = crServerDispatchBufferSubDataARB;
#endif
	cr_server.dispatch.CallList = crServerDispatchCallList;
	cr_server.dispatch.CallLists = crServerDispatchCallLists;
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.CheckFramebufferStatusEXT = crServerDispatchCheckFramebufferStatusEXT;
#endif
	cr_server.dispatch.ChromiumParameterfCR = crServerDispatchChromiumParameterfCR;
	cr_server.dispatch.ChromiumParameteriCR = crServerDispatchChromiumParameteriCR;
	cr_server.dispatch.ChromiumParametervCR = crServerDispatchChromiumParametervCR;
	cr_server.dispatch.Clear = crServerDispatchClear;
	cr_server.dispatch.ClearAccum = crServerDispatchClearAccum;
	cr_server.dispatch.ClearColor = crServerDispatchClearColor;
	cr_server.dispatch.ClearDepth = crServerDispatchClearDepth;
	cr_server.dispatch.ClearIndex = crServerDispatchClearIndex;
	cr_server.dispatch.ClearStencil = crServerDispatchClearStencil;
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.ClientActiveTextureARB = crServerDispatchClientActiveTextureARB;
#endif
	cr_server.dispatch.ClipPlane = crServerDispatchClipPlane;
	cr_server.dispatch.Color3b = crServerDispatchColor3b;
	cr_server.dispatch.Color3d = crServerDispatchColor3d;
	cr_server.dispatch.Color3f = crServerDispatchColor3f;
	cr_server.dispatch.Color3fv = crServerDispatchColor3fv;
	cr_server.dispatch.Color3i = crServerDispatchColor3i;
	cr_server.dispatch.Color3s = crServerDispatchColor3s;
	cr_server.dispatch.Color3ub = crServerDispatchColor3ub;
	cr_server.dispatch.Color3ui = crServerDispatchColor3ui;
	cr_server.dispatch.Color3us = crServerDispatchColor3us;
	cr_server.dispatch.Color4b = crServerDispatchColor4b;
	cr_server.dispatch.Color4d = crServerDispatchColor4d;
	cr_server.dispatch.Color4f = crServerDispatchColor4f;
	cr_server.dispatch.Color4fv = crServerDispatchColor4fv;
	cr_server.dispatch.Color4i = crServerDispatchColor4i;
	cr_server.dispatch.Color4s = crServerDispatchColor4s;
	cr_server.dispatch.Color4ub = crServerDispatchColor4ub;
	cr_server.dispatch.Color4ui = crServerDispatchColor4ui;
	cr_server.dispatch.Color4us = crServerDispatchColor4us;
	cr_server.dispatch.ColorMask = crServerDispatchColorMask;
	cr_server.dispatch.ColorMaterial = crServerDispatchColorMaterial;
	cr_server.dispatch.ColorPointer = crServerDispatchColorPointer;
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.CombinerInputNV = crServerDispatchCombinerInputNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.CombinerOutputNV = crServerDispatchCombinerOutputNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.CombinerParameterfNV = crServerDispatchCombinerParameterfNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.CombinerParameterfvNV = crServerDispatchCombinerParameterfvNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.CombinerParameteriNV = crServerDispatchCombinerParameteriNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.CombinerParameterivNV = crServerDispatchCombinerParameterivNV;
#endif
#if defined(CR_NV_register_combiners2)
	cr_server.dispatch.CombinerStageParameterfvNV = crServerDispatchCombinerStageParameterfvNV;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.CompileShader = crServerDispatchCompileShader;
#endif
#if defined(CR_ARB_texture_compression)
	cr_server.dispatch.CompressedTexImage1DARB = crServerDispatchCompressedTexImage1DARB;
#endif
#if defined(CR_ARB_texture_compression)
	cr_server.dispatch.CompressedTexImage2DARB = crServerDispatchCompressedTexImage2DARB;
#endif
#if defined(CR_ARB_texture_compression)
	cr_server.dispatch.CompressedTexImage3DARB = crServerDispatchCompressedTexImage3DARB;
#endif
#if defined(CR_ARB_texture_compression)
	cr_server.dispatch.CompressedTexSubImage1DARB = crServerDispatchCompressedTexSubImage1DARB;
#endif
#if defined(CR_ARB_texture_compression)
	cr_server.dispatch.CompressedTexSubImage2DARB = crServerDispatchCompressedTexSubImage2DARB;
#endif
#if defined(CR_ARB_texture_compression)
	cr_server.dispatch.CompressedTexSubImage3DARB = crServerDispatchCompressedTexSubImage3DARB;
#endif
	cr_server.dispatch.CopyTexImage2D = crServerDispatchCopyTexImage2D;
	cr_server.dispatch.CopyTexSubImage2D = crServerDispatchCopyTexSubImage2D;
	cr_server.dispatch.CreateContext = crServerDispatchCreateContext;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.CreateProgram = crServerDispatchCreateProgram;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.CreateShader = crServerDispatchCreateShader;
#endif
	cr_server.dispatch.CullFace = crServerDispatchCullFace;
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.DeleteBuffersARB = crServerDispatchDeleteBuffersARB;
#endif
#if defined(CR_NV_fence)
	cr_server.dispatch.DeleteFencesNV = crServerDispatchDeleteFencesNV;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.DeleteFramebuffersEXT = crServerDispatchDeleteFramebuffersEXT;
#endif
	cr_server.dispatch.DeleteLists = crServerDispatchDeleteLists;
#if defined(CR_ARB_shader_objects)
	cr_server.dispatch.DeleteObjectARB = crServerDispatchDeleteObjectARB;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.DeleteProgram = crServerDispatchDeleteProgram;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.DeleteProgramsARB = crServerDispatchDeleteProgramsARB;
#endif
#if defined(CR_ARB_occlusion_query)
	cr_server.dispatch.DeleteQueriesARB = crServerDispatchDeleteQueriesARB;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.DeleteRenderbuffersEXT = crServerDispatchDeleteRenderbuffersEXT;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.DeleteShader = crServerDispatchDeleteShader;
#endif
	cr_server.dispatch.DeleteTextures = crServerDispatchDeleteTextures;
	cr_server.dispatch.DepthFunc = crServerDispatchDepthFunc;
	cr_server.dispatch.DepthMask = crServerDispatchDepthMask;
	cr_server.dispatch.DepthRange = crServerDispatchDepthRange;
	cr_server.dispatch.DestroyContext = crServerDispatchDestroyContext;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.DetachShader = crServerDispatchDetachShader;
#endif
	cr_server.dispatch.Disable = crServerDispatchDisable;
	cr_server.dispatch.DisableClientState = crServerDispatchDisableClientState;
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.DisableVertexAttribArrayARB = crServerDispatchDisableVertexAttribArrayARB;
#endif
	cr_server.dispatch.DrawArrays = crServerDispatchDrawArrays;
	cr_server.dispatch.DrawBuffer = crServerDispatchDrawBuffer;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.DrawBuffers = crServerDispatchDrawBuffers;
#endif
	cr_server.dispatch.DrawElements = crServerDispatchDrawElements;
	cr_server.dispatch.EdgeFlag = crServerDispatchEdgeFlag;
	cr_server.dispatch.EdgeFlagPointer = crServerDispatchEdgeFlagPointer;
	cr_server.dispatch.Enable = crServerDispatchEnable;
	cr_server.dispatch.EnableClientState = crServerDispatchEnableClientState;
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.EnableVertexAttribArrayARB = crServerDispatchEnableVertexAttribArrayARB;
#endif
	cr_server.dispatch.End = crServerDispatchEnd;
	cr_server.dispatch.EndList = crServerDispatchEndList;
#if defined(CR_ARB_occlusion_query)
	cr_server.dispatch.EndQueryARB = crServerDispatchEndQueryARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.ExecuteProgramNV = crServerDispatchExecuteProgramNV;
#endif
	cr_server.dispatch.FeedbackBuffer = crServerDispatchFeedbackBuffer;
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.FinalCombinerInputNV = crServerDispatchFinalCombinerInputNV;
#endif
	cr_server.dispatch.Finish = crServerDispatchFinish;
#if defined(CR_NV_fence)
	cr_server.dispatch.FinishFenceNV = crServerDispatchFinishFenceNV;
#endif
	cr_server.dispatch.Flush = crServerDispatchFlush;
#if defined(CR_NV_vertex_array_range)
	cr_server.dispatch.FlushVertexArrayRangeNV = crServerDispatchFlushVertexArrayRangeNV;
#endif
#if defined(CR_EXT_fog_coord)
	cr_server.dispatch.FogCoordPointerEXT = crServerDispatchFogCoordPointerEXT;
#endif
#if defined(CR_EXT_fog_coord)
	cr_server.dispatch.FogCoorddEXT = crServerDispatchFogCoorddEXT;
#endif
#if defined(CR_EXT_fog_coord)
	cr_server.dispatch.FogCoordfEXT = crServerDispatchFogCoordfEXT;
#endif
	cr_server.dispatch.Fogf = crServerDispatchFogf;
	cr_server.dispatch.Fogfv = crServerDispatchFogfv;
	cr_server.dispatch.Fogi = crServerDispatchFogi;
	cr_server.dispatch.Fogiv = crServerDispatchFogiv;
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.FramebufferRenderbufferEXT = crServerDispatchFramebufferRenderbufferEXT;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.FramebufferTexture1DEXT = crServerDispatchFramebufferTexture1DEXT;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.FramebufferTexture2DEXT = crServerDispatchFramebufferTexture2DEXT;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.FramebufferTexture3DEXT = crServerDispatchFramebufferTexture3DEXT;
#endif
	cr_server.dispatch.FrontFace = crServerDispatchFrontFace;
	cr_server.dispatch.Frustum = crServerDispatchFrustum;
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.GenBuffersARB = crServerDispatchGenBuffersARB;
#endif
#if defined(CR_NV_fence)
	cr_server.dispatch.GenFencesNV = crServerDispatchGenFencesNV;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.GenFramebuffersEXT = crServerDispatchGenFramebuffersEXT;
#endif
	cr_server.dispatch.GenLists = crServerDispatchGenLists;
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GenProgramsARB = crServerDispatchGenProgramsARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GenProgramsNV = crServerDispatchGenProgramsNV;
#endif
#if defined(CR_ARB_occlusion_query)
	cr_server.dispatch.GenQueriesARB = crServerDispatchGenQueriesARB;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.GenRenderbuffersEXT = crServerDispatchGenRenderbuffersEXT;
#endif
	cr_server.dispatch.GenTextures = crServerDispatchGenTextures;
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.GenerateMipmapEXT = crServerDispatchGenerateMipmapEXT;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetActiveAttrib = crServerDispatchGetActiveAttrib;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetActiveUniform = crServerDispatchGetActiveUniform;
#endif
#if defined(CR_ARB_shader_objects)
	cr_server.dispatch.GetAttachedObjectsARB = crServerDispatchGetAttachedObjectsARB;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetAttachedShaders = crServerDispatchGetAttachedShaders;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetAttribLocation = crServerDispatchGetAttribLocation;
#endif
	cr_server.dispatch.GetAttribsLocations = crServerDispatchGetAttribsLocations;
	cr_server.dispatch.GetBooleanv = crServerDispatchGetBooleanv;
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.GetBufferParameterivARB = crServerDispatchGetBufferParameterivARB;
#endif
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.GetBufferPointervARB = crServerDispatchGetBufferPointervARB;
#endif
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.GetBufferSubDataARB = crServerDispatchGetBufferSubDataARB;
#endif
	cr_server.dispatch.GetChromiumParametervCR = crServerDispatchGetChromiumParametervCR;
	cr_server.dispatch.GetClipPlane = crServerDispatchGetClipPlane;
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.GetCombinerInputParameterfvNV = crServerDispatchGetCombinerInputParameterfvNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.GetCombinerInputParameterivNV = crServerDispatchGetCombinerInputParameterivNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.GetCombinerOutputParameterfvNV = crServerDispatchGetCombinerOutputParameterfvNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.GetCombinerOutputParameterivNV = crServerDispatchGetCombinerOutputParameterivNV;
#endif
#if defined(CR_NV_register_combiners2)
	cr_server.dispatch.GetCombinerStageParameterfvNV = crServerDispatchGetCombinerStageParameterfvNV;
#endif
#if defined(CR_ARB_texture_compression)
	cr_server.dispatch.GetCompressedTexImageARB = crServerDispatchGetCompressedTexImageARB;
#endif
	cr_server.dispatch.GetDoublev = crServerDispatchGetDoublev;
	cr_server.dispatch.GetError = crServerDispatchGetError;
#if defined(CR_NV_fence)
	cr_server.dispatch.GetFenceivNV = crServerDispatchGetFenceivNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.GetFinalCombinerInputParameterfvNV = crServerDispatchGetFinalCombinerInputParameterfvNV;
#endif
#if defined(CR_NV_register_combiners)
	cr_server.dispatch.GetFinalCombinerInputParameterivNV = crServerDispatchGetFinalCombinerInputParameterivNV;
#endif
	cr_server.dispatch.GetFloatv = crServerDispatchGetFloatv;
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.GetFramebufferAttachmentParameterivEXT = crServerDispatchGetFramebufferAttachmentParameterivEXT;
#endif
#if defined(CR_ARB_shader_objects)
	cr_server.dispatch.GetHandleARB = crServerDispatchGetHandleARB;
#endif
#if defined(CR_ARB_shader_objects)
	cr_server.dispatch.GetInfoLogARB = crServerDispatchGetInfoLogARB;
#endif
	cr_server.dispatch.GetIntegerv = crServerDispatchGetIntegerv;
	cr_server.dispatch.GetLightfv = crServerDispatchGetLightfv;
	cr_server.dispatch.GetLightiv = crServerDispatchGetLightiv;
	cr_server.dispatch.GetMapdv = crServerDispatchGetMapdv;
	cr_server.dispatch.GetMapfv = crServerDispatchGetMapfv;
	cr_server.dispatch.GetMapiv = crServerDispatchGetMapiv;
	cr_server.dispatch.GetMaterialfv = crServerDispatchGetMaterialfv;
	cr_server.dispatch.GetMaterialiv = crServerDispatchGetMaterialiv;
#if defined(CR_ARB_shader_objects)
	cr_server.dispatch.GetObjectParameterfvARB = crServerDispatchGetObjectParameterfvARB;
#endif
#if defined(CR_ARB_shader_objects)
	cr_server.dispatch.GetObjectParameterivARB = crServerDispatchGetObjectParameterivARB;
#endif
	cr_server.dispatch.GetPixelMapfv = crServerDispatchGetPixelMapfv;
	cr_server.dispatch.GetPixelMapuiv = crServerDispatchGetPixelMapuiv;
	cr_server.dispatch.GetPixelMapusv = crServerDispatchGetPixelMapusv;
	cr_server.dispatch.GetPointerv = crServerDispatchGetPointerv;
	cr_server.dispatch.GetPolygonStipple = crServerDispatchGetPolygonStipple;
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetProgramEnvParameterdvARB = crServerDispatchGetProgramEnvParameterdvARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetProgramEnvParameterfvARB = crServerDispatchGetProgramEnvParameterfvARB;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetProgramInfoLog = crServerDispatchGetProgramInfoLog;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetProgramLocalParameterdvARB = crServerDispatchGetProgramLocalParameterdvARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetProgramLocalParameterfvARB = crServerDispatchGetProgramLocalParameterfvARB;
#endif
#if defined(CR_NV_fragment_program)
	cr_server.dispatch.GetProgramNamedParameterdvNV = crServerDispatchGetProgramNamedParameterdvNV;
#endif
#if defined(CR_NV_fragment_program)
	cr_server.dispatch.GetProgramNamedParameterfvNV = crServerDispatchGetProgramNamedParameterfvNV;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetProgramParameterdvNV = crServerDispatchGetProgramParameterdvNV;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetProgramParameterfvNV = crServerDispatchGetProgramParameterfvNV;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetProgramStringARB = crServerDispatchGetProgramStringARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetProgramStringNV = crServerDispatchGetProgramStringNV;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetProgramiv = crServerDispatchGetProgramiv;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetProgramivARB = crServerDispatchGetProgramivARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetProgramivNV = crServerDispatchGetProgramivNV;
#endif
#if defined(CR_ARB_occlusion_query)
	cr_server.dispatch.GetQueryObjectivARB = crServerDispatchGetQueryObjectivARB;
#endif
#if defined(CR_ARB_occlusion_query)
	cr_server.dispatch.GetQueryObjectuivARB = crServerDispatchGetQueryObjectuivARB;
#endif
#if defined(CR_ARB_occlusion_query)
	cr_server.dispatch.GetQueryivARB = crServerDispatchGetQueryivARB;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.GetRenderbufferParameterivEXT = crServerDispatchGetRenderbufferParameterivEXT;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetShaderInfoLog = crServerDispatchGetShaderInfoLog;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetShaderSource = crServerDispatchGetShaderSource;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetShaderiv = crServerDispatchGetShaderiv;
#endif
	cr_server.dispatch.GetString = crServerDispatchGetString;
	cr_server.dispatch.GetTexEnvfv = crServerDispatchGetTexEnvfv;
	cr_server.dispatch.GetTexEnviv = crServerDispatchGetTexEnviv;
	cr_server.dispatch.GetTexGendv = crServerDispatchGetTexGendv;
	cr_server.dispatch.GetTexGenfv = crServerDispatchGetTexGenfv;
	cr_server.dispatch.GetTexGeniv = crServerDispatchGetTexGeniv;
	cr_server.dispatch.GetTexImage = crServerDispatchGetTexImage;
	cr_server.dispatch.GetTexLevelParameterfv = crServerDispatchGetTexLevelParameterfv;
	cr_server.dispatch.GetTexLevelParameteriv = crServerDispatchGetTexLevelParameteriv;
	cr_server.dispatch.GetTexParameterfv = crServerDispatchGetTexParameterfv;
	cr_server.dispatch.GetTexParameteriv = crServerDispatchGetTexParameteriv;
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetTrackMatrixivNV = crServerDispatchGetTrackMatrixivNV;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetUniformLocation = crServerDispatchGetUniformLocation;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetUniformfv = crServerDispatchGetUniformfv;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.GetUniformiv = crServerDispatchGetUniformiv;
#endif
	cr_server.dispatch.GetUniformsLocations = crServerDispatchGetUniformsLocations;
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetVertexAttribPointervARB = crServerDispatchGetVertexAttribPointervARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetVertexAttribPointervNV = crServerDispatchGetVertexAttribPointervNV;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetVertexAttribdvARB = crServerDispatchGetVertexAttribdvARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetVertexAttribdvNV = crServerDispatchGetVertexAttribdvNV;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetVertexAttribfvARB = crServerDispatchGetVertexAttribfvARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetVertexAttribfvNV = crServerDispatchGetVertexAttribfvNV;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.GetVertexAttribivARB = crServerDispatchGetVertexAttribivARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.GetVertexAttribivNV = crServerDispatchGetVertexAttribivNV;
#endif
	cr_server.dispatch.Hint = crServerDispatchHint;
	cr_server.dispatch.IndexMask = crServerDispatchIndexMask;
	cr_server.dispatch.IndexPointer = crServerDispatchIndexPointer;
	cr_server.dispatch.Indexd = crServerDispatchIndexd;
	cr_server.dispatch.Indexf = crServerDispatchIndexf;
	cr_server.dispatch.Indexi = crServerDispatchIndexi;
	cr_server.dispatch.Indexs = crServerDispatchIndexs;
	cr_server.dispatch.Indexub = crServerDispatchIndexub;
	cr_server.dispatch.InitNames = crServerDispatchInitNames;
	cr_server.dispatch.InterleavedArrays = crServerDispatchInterleavedArrays;
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.IsBufferARB = crServerDispatchIsBufferARB;
#endif
	cr_server.dispatch.IsEnabled = crServerDispatchIsEnabled;
#if defined(CR_NV_fence)
	cr_server.dispatch.IsFenceNV = crServerDispatchIsFenceNV;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.IsFramebufferEXT = crServerDispatchIsFramebufferEXT;
#endif
	cr_server.dispatch.IsList = crServerDispatchIsList;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.IsProgram = crServerDispatchIsProgram;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.IsProgramARB = crServerDispatchIsProgramARB;
#endif
#if defined(CR_ARB_occlusion_query)
	cr_server.dispatch.IsQueryARB = crServerDispatchIsQueryARB;
#endif
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.IsRenderbufferEXT = crServerDispatchIsRenderbufferEXT;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.IsShader = crServerDispatchIsShader;
#endif
	cr_server.dispatch.IsTexture = crServerDispatchIsTexture;
	cr_server.dispatch.LightModelf = crServerDispatchLightModelf;
	cr_server.dispatch.LightModelfv = crServerDispatchLightModelfv;
	cr_server.dispatch.LightModeli = crServerDispatchLightModeli;
	cr_server.dispatch.LightModeliv = crServerDispatchLightModeliv;
	cr_server.dispatch.Lightf = crServerDispatchLightf;
	cr_server.dispatch.Lightfv = crServerDispatchLightfv;
	cr_server.dispatch.Lighti = crServerDispatchLighti;
	cr_server.dispatch.Lightiv = crServerDispatchLightiv;
	cr_server.dispatch.LineStipple = crServerDispatchLineStipple;
	cr_server.dispatch.LineWidth = crServerDispatchLineWidth;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.LinkProgram = crServerDispatchLinkProgram;
#endif
	cr_server.dispatch.ListBase = crServerDispatchListBase;
	cr_server.dispatch.LoadIdentity = crServerDispatchLoadIdentity;
	cr_server.dispatch.LoadMatrixd = crServerDispatchLoadMatrixd;
	cr_server.dispatch.LoadMatrixf = crServerDispatchLoadMatrixf;
	cr_server.dispatch.LoadName = crServerDispatchLoadName;
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.LoadProgramNV = crServerDispatchLoadProgramNV;
#endif
#if defined(CR_ARB_transpose_matrix)
	cr_server.dispatch.LoadTransposeMatrixdARB = crServerDispatchLoadTransposeMatrixdARB;
#endif
#if defined(CR_ARB_transpose_matrix)
	cr_server.dispatch.LoadTransposeMatrixfARB = crServerDispatchLoadTransposeMatrixfARB;
#endif
#if defined(CR_EXT_compiled_vertex_array)
	cr_server.dispatch.LockArraysEXT = crServerDispatchLockArraysEXT;
#endif
	cr_server.dispatch.LogicOp = crServerDispatchLogicOp;
	cr_server.dispatch.MakeCurrent = crServerDispatchMakeCurrent;
	cr_server.dispatch.Map1d = crServerDispatchMap1d;
	cr_server.dispatch.Map1f = crServerDispatchMap1f;
	cr_server.dispatch.Map2d = crServerDispatchMap2d;
	cr_server.dispatch.Map2f = crServerDispatchMap2f;
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.MapBufferARB = crServerDispatchMapBufferARB;
#endif
	cr_server.dispatch.MapGrid1d = crServerDispatchMapGrid1d;
	cr_server.dispatch.MapGrid1f = crServerDispatchMapGrid1f;
	cr_server.dispatch.MapGrid2d = crServerDispatchMapGrid2d;
	cr_server.dispatch.MapGrid2f = crServerDispatchMapGrid2f;
	cr_server.dispatch.Materialf = crServerDispatchMaterialf;
	cr_server.dispatch.Materialfv = crServerDispatchMaterialfv;
	cr_server.dispatch.Materiali = crServerDispatchMateriali;
	cr_server.dispatch.Materialiv = crServerDispatchMaterialiv;
	cr_server.dispatch.MatrixMode = crServerDispatchMatrixMode;
	cr_server.dispatch.MultMatrixd = crServerDispatchMultMatrixd;
	cr_server.dispatch.MultMatrixf = crServerDispatchMultMatrixf;
#if defined(CR_ARB_transpose_matrix)
	cr_server.dispatch.MultTransposeMatrixdARB = crServerDispatchMultTransposeMatrixdARB;
#endif
#if defined(CR_ARB_transpose_matrix)
	cr_server.dispatch.MultTransposeMatrixfARB = crServerDispatchMultTransposeMatrixfARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord1dARB = crServerDispatchMultiTexCoord1dARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord1fARB = crServerDispatchMultiTexCoord1fARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord1iARB = crServerDispatchMultiTexCoord1iARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord1sARB = crServerDispatchMultiTexCoord1sARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord2dARB = crServerDispatchMultiTexCoord2dARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord2fARB = crServerDispatchMultiTexCoord2fARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord2iARB = crServerDispatchMultiTexCoord2iARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord2sARB = crServerDispatchMultiTexCoord2sARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord3dARB = crServerDispatchMultiTexCoord3dARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord3fARB = crServerDispatchMultiTexCoord3fARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord3iARB = crServerDispatchMultiTexCoord3iARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord3sARB = crServerDispatchMultiTexCoord3sARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord4dARB = crServerDispatchMultiTexCoord4dARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord4fARB = crServerDispatchMultiTexCoord4fARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord4iARB = crServerDispatchMultiTexCoord4iARB;
#endif
#if defined(CR_ARB_multitexture)
	cr_server.dispatch.MultiTexCoord4sARB = crServerDispatchMultiTexCoord4sARB;
#endif
	cr_server.dispatch.NewList = crServerDispatchNewList;
	cr_server.dispatch.Normal3b = crServerDispatchNormal3b;
	cr_server.dispatch.Normal3d = crServerDispatchNormal3d;
	cr_server.dispatch.Normal3f = crServerDispatchNormal3f;
	cr_server.dispatch.Normal3i = crServerDispatchNormal3i;
	cr_server.dispatch.Normal3s = crServerDispatchNormal3s;
	cr_server.dispatch.NormalPointer = crServerDispatchNormalPointer;
	cr_server.dispatch.Ortho = crServerDispatchOrtho;
	cr_server.dispatch.PassThrough = crServerDispatchPassThrough;
	cr_server.dispatch.PixelMapfv = crServerDispatchPixelMapfv;
	cr_server.dispatch.PixelMapuiv = crServerDispatchPixelMapuiv;
	cr_server.dispatch.PixelMapusv = crServerDispatchPixelMapusv;
	cr_server.dispatch.PixelStoref = crServerDispatchPixelStoref;
	cr_server.dispatch.PixelStorei = crServerDispatchPixelStorei;
	cr_server.dispatch.PixelTransferf = crServerDispatchPixelTransferf;
	cr_server.dispatch.PixelTransferi = crServerDispatchPixelTransferi;
	cr_server.dispatch.PixelZoom = crServerDispatchPixelZoom;
#if defined(CR_ARB_point_parameters)
	cr_server.dispatch.PointParameterfARB = crServerDispatchPointParameterfARB;
#endif
#if defined(CR_ARB_point_parameters)
	cr_server.dispatch.PointParameterfvARB = crServerDispatchPointParameterfvARB;
#endif
#if defined(CR_OPENGL_VERSION_1_4)
	cr_server.dispatch.PointParameteri = crServerDispatchPointParameteri;
#endif
#if defined(CR_OPENGL_VERSION_1_4)
	cr_server.dispatch.PointParameteriv = crServerDispatchPointParameteriv;
#endif
	cr_server.dispatch.PointSize = crServerDispatchPointSize;
	cr_server.dispatch.PolygonMode = crServerDispatchPolygonMode;
	cr_server.dispatch.PolygonOffset = crServerDispatchPolygonOffset;
	cr_server.dispatch.PolygonStipple = crServerDispatchPolygonStipple;
	cr_server.dispatch.PopAttrib = crServerDispatchPopAttrib;
	cr_server.dispatch.PopClientAttrib = crServerDispatchPopClientAttrib;
	cr_server.dispatch.PopMatrix = crServerDispatchPopMatrix;
	cr_server.dispatch.PopName = crServerDispatchPopName;
	cr_server.dispatch.PrioritizeTextures = crServerDispatchPrioritizeTextures;
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramEnvParameter4dARB = crServerDispatchProgramEnvParameter4dARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramEnvParameter4dvARB = crServerDispatchProgramEnvParameter4dvARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramEnvParameter4fARB = crServerDispatchProgramEnvParameter4fARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramEnvParameter4fvARB = crServerDispatchProgramEnvParameter4fvARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramLocalParameter4dARB = crServerDispatchProgramLocalParameter4dARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramLocalParameter4dvARB = crServerDispatchProgramLocalParameter4dvARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramLocalParameter4fARB = crServerDispatchProgramLocalParameter4fARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramLocalParameter4fvARB = crServerDispatchProgramLocalParameter4fvARB;
#endif
#if defined(CR_NV_fragment_program)
	cr_server.dispatch.ProgramNamedParameter4dNV = crServerDispatchProgramNamedParameter4dNV;
#endif
#if defined(CR_NV_fragment_program)
	cr_server.dispatch.ProgramNamedParameter4dvNV = crServerDispatchProgramNamedParameter4dvNV;
#endif
#if defined(CR_NV_fragment_program)
	cr_server.dispatch.ProgramNamedParameter4fNV = crServerDispatchProgramNamedParameter4fNV;
#endif
#if defined(CR_NV_fragment_program)
	cr_server.dispatch.ProgramNamedParameter4fvNV = crServerDispatchProgramNamedParameter4fvNV;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.ProgramParameter4dNV = crServerDispatchProgramParameter4dNV;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.ProgramParameter4dvNV = crServerDispatchProgramParameter4dvNV;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.ProgramParameter4fNV = crServerDispatchProgramParameter4fNV;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.ProgramParameter4fvNV = crServerDispatchProgramParameter4fvNV;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.ProgramParameters4dvNV = crServerDispatchProgramParameters4dvNV;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.ProgramParameters4fvNV = crServerDispatchProgramParameters4fvNV;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.ProgramStringARB = crServerDispatchProgramStringARB;
#endif
	cr_server.dispatch.PushAttrib = crServerDispatchPushAttrib;
	cr_server.dispatch.PushClientAttrib = crServerDispatchPushClientAttrib;
	cr_server.dispatch.PushMatrix = crServerDispatchPushMatrix;
	cr_server.dispatch.PushName = crServerDispatchPushName;
	cr_server.dispatch.RasterPos2d = crServerDispatchRasterPos2d;
	cr_server.dispatch.RasterPos2dv = crServerDispatchRasterPos2dv;
	cr_server.dispatch.RasterPos2f = crServerDispatchRasterPos2f;
	cr_server.dispatch.RasterPos2fv = crServerDispatchRasterPos2fv;
	cr_server.dispatch.RasterPos2i = crServerDispatchRasterPos2i;
	cr_server.dispatch.RasterPos2iv = crServerDispatchRasterPos2iv;
	cr_server.dispatch.RasterPos2s = crServerDispatchRasterPos2s;
	cr_server.dispatch.RasterPos2sv = crServerDispatchRasterPos2sv;
	cr_server.dispatch.RasterPos3d = crServerDispatchRasterPos3d;
	cr_server.dispatch.RasterPos3dv = crServerDispatchRasterPos3dv;
	cr_server.dispatch.RasterPos3f = crServerDispatchRasterPos3f;
	cr_server.dispatch.RasterPos3fv = crServerDispatchRasterPos3fv;
	cr_server.dispatch.RasterPos3i = crServerDispatchRasterPos3i;
	cr_server.dispatch.RasterPos3iv = crServerDispatchRasterPos3iv;
	cr_server.dispatch.RasterPos3s = crServerDispatchRasterPos3s;
	cr_server.dispatch.RasterPos3sv = crServerDispatchRasterPos3sv;
	cr_server.dispatch.RasterPos4d = crServerDispatchRasterPos4d;
	cr_server.dispatch.RasterPos4dv = crServerDispatchRasterPos4dv;
	cr_server.dispatch.RasterPos4f = crServerDispatchRasterPos4f;
	cr_server.dispatch.RasterPos4fv = crServerDispatchRasterPos4fv;
	cr_server.dispatch.RasterPos4i = crServerDispatchRasterPos4i;
	cr_server.dispatch.RasterPos4iv = crServerDispatchRasterPos4iv;
	cr_server.dispatch.RasterPos4s = crServerDispatchRasterPos4s;
	cr_server.dispatch.RasterPos4sv = crServerDispatchRasterPos4sv;
	cr_server.dispatch.ReadBuffer = crServerDispatchReadBuffer;
	cr_server.dispatch.ReadPixels = crServerDispatchReadPixels;
	cr_server.dispatch.RenderMode = crServerDispatchRenderMode;
#if defined(CR_EXT_framebuffer_object)
	cr_server.dispatch.RenderbufferStorageEXT = crServerDispatchRenderbufferStorageEXT;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.RequestResidentProgramsNV = crServerDispatchRequestResidentProgramsNV;
#endif
	cr_server.dispatch.Rotated = crServerDispatchRotated;
	cr_server.dispatch.Rotatef = crServerDispatchRotatef;
#if defined(CR_ARB_multisample)
	cr_server.dispatch.SampleCoverageARB = crServerDispatchSampleCoverageARB;
#endif
	cr_server.dispatch.Scaled = crServerDispatchScaled;
	cr_server.dispatch.Scalef = crServerDispatchScalef;
	cr_server.dispatch.Scissor = crServerDispatchScissor;
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColor3bEXT = crServerDispatchSecondaryColor3bEXT;
#endif
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColor3dEXT = crServerDispatchSecondaryColor3dEXT;
#endif
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColor3fEXT = crServerDispatchSecondaryColor3fEXT;
#endif
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColor3iEXT = crServerDispatchSecondaryColor3iEXT;
#endif
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColor3sEXT = crServerDispatchSecondaryColor3sEXT;
#endif
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColor3ubEXT = crServerDispatchSecondaryColor3ubEXT;
#endif
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColor3uiEXT = crServerDispatchSecondaryColor3uiEXT;
#endif
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColor3usEXT = crServerDispatchSecondaryColor3usEXT;
#endif
#if defined(CR_EXT_secondary_color)
	cr_server.dispatch.SecondaryColorPointerEXT = crServerDispatchSecondaryColorPointerEXT;
#endif
	cr_server.dispatch.SelectBuffer = crServerDispatchSelectBuffer;
	cr_server.dispatch.SemaphoreCreateCR = crServerDispatchSemaphoreCreateCR;
	cr_server.dispatch.SemaphoreDestroyCR = crServerDispatchSemaphoreDestroyCR;
	cr_server.dispatch.SemaphorePCR = crServerDispatchSemaphorePCR;
	cr_server.dispatch.SemaphoreVCR = crServerDispatchSemaphoreVCR;
#if defined(CR_NV_fence)
	cr_server.dispatch.SetFenceNV = crServerDispatchSetFenceNV;
#endif
	cr_server.dispatch.ShadeModel = crServerDispatchShadeModel;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.ShaderSource = crServerDispatchShaderSource;
#endif
	cr_server.dispatch.StencilFunc = crServerDispatchStencilFunc;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.StencilFuncSeparate = crServerDispatchStencilFuncSeparate;
#endif
	cr_server.dispatch.StencilMask = crServerDispatchStencilMask;
	cr_server.dispatch.StencilOp = crServerDispatchStencilOp;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.StencilOpSeparate = crServerDispatchStencilOpSeparate;
#endif
	cr_server.dispatch.SwapBuffers = crServerDispatchSwapBuffers;
#if defined(CR_NV_fence)
	cr_server.dispatch.TestFenceNV = crServerDispatchTestFenceNV;
#endif
	cr_server.dispatch.TexCoord1d = crServerDispatchTexCoord1d;
	cr_server.dispatch.TexCoord1f = crServerDispatchTexCoord1f;
	cr_server.dispatch.TexCoord1i = crServerDispatchTexCoord1i;
	cr_server.dispatch.TexCoord1s = crServerDispatchTexCoord1s;
	cr_server.dispatch.TexCoord2d = crServerDispatchTexCoord2d;
	cr_server.dispatch.TexCoord2f = crServerDispatchTexCoord2f;
	cr_server.dispatch.TexCoord2i = crServerDispatchTexCoord2i;
	cr_server.dispatch.TexCoord2s = crServerDispatchTexCoord2s;
	cr_server.dispatch.TexCoord3d = crServerDispatchTexCoord3d;
	cr_server.dispatch.TexCoord3f = crServerDispatchTexCoord3f;
	cr_server.dispatch.TexCoord3i = crServerDispatchTexCoord3i;
	cr_server.dispatch.TexCoord3s = crServerDispatchTexCoord3s;
	cr_server.dispatch.TexCoord4d = crServerDispatchTexCoord4d;
	cr_server.dispatch.TexCoord4f = crServerDispatchTexCoord4f;
	cr_server.dispatch.TexCoord4i = crServerDispatchTexCoord4i;
	cr_server.dispatch.TexCoord4s = crServerDispatchTexCoord4s;
	cr_server.dispatch.TexCoordPointer = crServerDispatchTexCoordPointer;
	cr_server.dispatch.TexEnvf = crServerDispatchTexEnvf;
	cr_server.dispatch.TexEnvfv = crServerDispatchTexEnvfv;
	cr_server.dispatch.TexEnvi = crServerDispatchTexEnvi;
	cr_server.dispatch.TexEnviv = crServerDispatchTexEnviv;
	cr_server.dispatch.TexGend = crServerDispatchTexGend;
	cr_server.dispatch.TexGendv = crServerDispatchTexGendv;
	cr_server.dispatch.TexGenf = crServerDispatchTexGenf;
	cr_server.dispatch.TexGenfv = crServerDispatchTexGenfv;
	cr_server.dispatch.TexGeni = crServerDispatchTexGeni;
	cr_server.dispatch.TexGeniv = crServerDispatchTexGeniv;
	cr_server.dispatch.TexImage1D = crServerDispatchTexImage1D;
	cr_server.dispatch.TexImage2D = crServerDispatchTexImage2D;
	cr_server.dispatch.TexImage3D = crServerDispatchTexImage3D;
#if defined(CR_EXT_texture3D)
	cr_server.dispatch.TexImage3DEXT = crServerDispatchTexImage3DEXT;
#endif
	cr_server.dispatch.TexParameterf = crServerDispatchTexParameterf;
	cr_server.dispatch.TexParameterfv = crServerDispatchTexParameterfv;
	cr_server.dispatch.TexParameteri = crServerDispatchTexParameteri;
	cr_server.dispatch.TexParameteriv = crServerDispatchTexParameteriv;
	cr_server.dispatch.TexSubImage1D = crServerDispatchTexSubImage1D;
	cr_server.dispatch.TexSubImage2D = crServerDispatchTexSubImage2D;
	cr_server.dispatch.TexSubImage3D = crServerDispatchTexSubImage3D;
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.TrackMatrixNV = crServerDispatchTrackMatrixNV;
#endif
	cr_server.dispatch.Translated = crServerDispatchTranslated;
	cr_server.dispatch.Translatef = crServerDispatchTranslatef;
#if defined(CR_EXT_compiled_vertex_array)
	cr_server.dispatch.UnlockArraysEXT = crServerDispatchUnlockArraysEXT;
#endif
#if defined(CR_ARB_vertex_buffer_object)
	cr_server.dispatch.UnmapBufferARB = crServerDispatchUnmapBufferARB;
#endif
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.UseProgram = crServerDispatchUseProgram;
#endif
	cr_server.dispatch.VBoxTexPresent = crServerDispatchVBoxTexPresent;
#if defined(CR_OPENGL_VERSION_2_0)
	cr_server.dispatch.ValidateProgram = crServerDispatchValidateProgram;
#endif
#if defined(CR_NV_vertex_array_range)
	cr_server.dispatch.VertexArrayRangeNV = crServerDispatchVertexArrayRangeNV;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib1dARB = crServerDispatchVertexAttrib1dARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib1fARB = crServerDispatchVertexAttrib1fARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib1sARB = crServerDispatchVertexAttrib1sARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib2dARB = crServerDispatchVertexAttrib2dARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib2fARB = crServerDispatchVertexAttrib2fARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib2sARB = crServerDispatchVertexAttrib2sARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib3dARB = crServerDispatchVertexAttrib3dARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib3fARB = crServerDispatchVertexAttrib3fARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib3sARB = crServerDispatchVertexAttrib3sARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib4NubARB = crServerDispatchVertexAttrib4NubARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib4dARB = crServerDispatchVertexAttrib4dARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib4fARB = crServerDispatchVertexAttrib4fARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttrib4sARB = crServerDispatchVertexAttrib4sARB;
#endif
#if defined(CR_ARB_vertex_program)
	cr_server.dispatch.VertexAttribPointerARB = crServerDispatchVertexAttribPointerARB;
#endif
#if defined(CR_NV_vertex_program)
	cr_server.dispatch.VertexAttribPointerNV = crServerDispatchVertexAttribPointerNV;
#endif
	cr_server.dispatch.VertexPointer = crServerDispatchVertexPointer;
	cr_server.dispatch.Viewport = crServerDispatchViewport;
	cr_server.dispatch.WindowCreate = crServerDispatchWindowCreate;
	cr_server.dispatch.WindowDestroy = crServerDispatchWindowDestroy;
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos2dARB = crServerDispatchWindowPos2dARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos2dvARB = crServerDispatchWindowPos2dvARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos2fARB = crServerDispatchWindowPos2fARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos2fvARB = crServerDispatchWindowPos2fvARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos2iARB = crServerDispatchWindowPos2iARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos2ivARB = crServerDispatchWindowPos2ivARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos2sARB = crServerDispatchWindowPos2sARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos2svARB = crServerDispatchWindowPos2svARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos3dARB = crServerDispatchWindowPos3dARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos3dvARB = crServerDispatchWindowPos3dvARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos3fARB = crServerDispatchWindowPos3fARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos3fvARB = crServerDispatchWindowPos3fvARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos3iARB = crServerDispatchWindowPos3iARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos3ivARB = crServerDispatchWindowPos3ivARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos3sARB = crServerDispatchWindowPos3sARB;
#endif
#if defined(CR_ARB_window_pos)
	cr_server.dispatch.WindowPos3svARB = crServerDispatchWindowPos3svARB;
#endif
	cr_server.dispatch.WindowPosition = crServerDispatchWindowPosition;
	cr_server.dispatch.WindowShow = crServerDispatchWindowShow;
	cr_server.dispatch.WindowSize = crServerDispatchWindowSize;
	cr_server.dispatch.WindowVisibleRegion = crServerDispatchWindowVisibleRegion;
	cr_server.dispatch.Writeback = crServerDispatchWriteback;
}
