/* Copyright (c) 2001, Stanford University
	All rights reserved.

	See the file LICENSE.txt for information on redistributing this software. */
	
/* DO NOT EDIT!  THIS CODE IS AUTOGENERATED BY unpack.py */

#include "unpacker.h"
#include "cr_opcodes.h"
#include "cr_error.h"
#include "cr_mem.h"
#include "cr_spu.h"
#include "unpack_extend.h"
#include <stdio.h>
#include <memory.h>

#include <iprt/cdefs.h>

DECLEXPORT(const unsigned char *) cr_unpackData = NULL;
DECLEXPORT(const unsigned char *) cr_unpackDataEnd = NULL;

static void crUnpackExtend(PCrUnpackerState pState);
static void crUnpackExtendDbg(PCrUnpackerState pState);

#if 0 //def DEBUG_misha
//# define CR_UNPACK_DEBUG_OPCODES
# define CR_UNPACK_DEBUG_LAST_OPCODES
# define CR_UNPACK_DEBUG_PREV_OPCODES
#endif

#ifdef CR_UNPACK_DEBUG_PREV_OPCODES
static GLenum g_VBoxDbgCrPrevOpcode = 0;
static GLenum g_VBoxDbgCrPrevExtendOpcode = 0;
#endif

static void crUnpackAlphaFunc(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum func = READ_DATA(pState, 0, GLenum);
	GLclampf ref = READ_DATA(pState, 4, GLclampf);
	pState->pDispatchTbl->AlphaFunc(func, ref);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackArrayElement(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLint i = READ_DATA(pState, 0, GLint);
	pState->pDispatchTbl->ArrayElement(i);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackBegin(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum mode = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->Begin(mode);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackBindTexture(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum target = READ_DATA(pState, 0, GLenum);
	GLuint texture = READ_DATA(pState, 4, GLuint);
	pState->pDispatchTbl->BindTexture(target, texture);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackBlendFunc(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum sfactor = READ_DATA(pState, 0, GLenum);
	GLenum dfactor = READ_DATA(pState, 4, GLenum);
	pState->pDispatchTbl->BlendFunc(sfactor, dfactor);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackCallList(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLuint list = READ_DATA(pState, 0, GLuint);
	pState->pDispatchTbl->CallList(list);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackClear(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLbitfield mask = READ_DATA(pState, 0, GLbitfield);
	pState->pDispatchTbl->Clear(mask);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackColor3b(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Color3bv((const GLbyte *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackColor3d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->Color3dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->Color3d(v0, v1, v2);
#endif
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackColor3f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->Color3fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackColor3i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->Color3iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackColor3s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Color3sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackColor3ub(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Color3ubv((const GLubyte *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackColor3ui(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->Color3uiv((const GLuint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackColor3us(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Color3usv((const GLushort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackColor4b(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Color4bv((const GLbyte *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackColor4d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->Color4dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	GLdouble v3 = READ_DOUBLE(pState, 24);
	pState->pDispatchTbl->Color4d(v0, v1, v2, v3);
#endif
	INCR_DATA_PTR(pState, 32);
}

static void crUnpackColor4f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->Color4fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackColor4i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->Color4iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackColor4s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Color4sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackColor4ub(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Color4ubv((const GLubyte *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackColor4ui(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->Color4uiv((const GLuint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackColor4us(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Color4usv((const GLushort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackColorMask(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLboolean red = READ_DATA(pState, 0, GLboolean);
	GLboolean green = READ_DATA(pState, 1, GLboolean);
	GLboolean blue = READ_DATA(pState, 2, GLboolean);
	GLboolean alpha = READ_DATA(pState, 3, GLboolean);
	pState->pDispatchTbl->ColorMask(red, green, blue, alpha);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackColorMaterial(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum face = READ_DATA(pState, 0, GLenum);
	GLenum mode = READ_DATA(pState, 4, GLenum);
	pState->pDispatchTbl->ColorMaterial(face, mode);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackCopyPixels(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLint x = READ_DATA(pState, 0, GLint);
	GLint y = READ_DATA(pState, 4, GLint);
	GLsizei width = READ_DATA(pState, 8, GLsizei);
	GLsizei height = READ_DATA(pState, 12, GLsizei);
	GLenum type = READ_DATA(pState, 16, GLenum);
	pState->pDispatchTbl->CopyPixels(x, y, width, height, type);
	INCR_DATA_PTR(pState, 20);
}

static void crUnpackCopyTexImage1D(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum target = READ_DATA(pState, 0, GLenum);
	GLint level = READ_DATA(pState, 4, GLint);
	GLenum internalFormat = READ_DATA(pState, 8, GLenum);
	GLint x = READ_DATA(pState, 12, GLint);
	GLint y = READ_DATA(pState, 16, GLint);
	GLsizei width = READ_DATA(pState, 20, GLsizei);
	GLint border = READ_DATA(pState, 24, GLint);
	pState->pDispatchTbl->CopyTexImage1D(target, level, internalFormat, x, y, width, border);
	INCR_DATA_PTR(pState, 28);
}

static void crUnpackCopyTexImage2D(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 0, GLenum);
	GLint level = READ_DATA(pState, 4, GLint);
	GLenum internalFormat = READ_DATA(pState, 8, GLenum);
	GLint x = READ_DATA(pState, 12, GLint);
	GLint y = READ_DATA(pState, 16, GLint);
	GLsizei width = READ_DATA(pState, 20, GLsizei);
	GLsizei height = READ_DATA(pState, 24, GLsizei);
	GLint border = READ_DATA(pState, 28, GLint);
	pState->pDispatchTbl->CopyTexImage2D(target, level, internalFormat, x, y, width, height, border);
	INCR_DATA_PTR(pState, 32);
}

static void crUnpackCopyTexSubImage1D(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLenum target = READ_DATA(pState, 0, GLenum);
	GLint level = READ_DATA(pState, 4, GLint);
	GLint xoffset = READ_DATA(pState, 8, GLint);
	GLint x = READ_DATA(pState, 12, GLint);
	GLint y = READ_DATA(pState, 16, GLint);
	GLsizei width = READ_DATA(pState, 20, GLsizei);
	pState->pDispatchTbl->CopyTexSubImage1D(target, level, xoffset, x, y, width);
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackCopyTexSubImage2D(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 0, GLenum);
	GLint level = READ_DATA(pState, 4, GLint);
	GLint xoffset = READ_DATA(pState, 8, GLint);
	GLint yoffset = READ_DATA(pState, 12, GLint);
	GLint x = READ_DATA(pState, 16, GLint);
	GLint y = READ_DATA(pState, 20, GLint);
	GLsizei width = READ_DATA(pState, 24, GLsizei);
	GLsizei height = READ_DATA(pState, 28, GLsizei);
	pState->pDispatchTbl->CopyTexSubImage2D(target, level, xoffset, yoffset, x, y, width, height);
	INCR_DATA_PTR(pState, 32);
}

static void crUnpackCopyTexSubImage3D(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum target = READ_DATA(pState, 0, GLenum);
	GLint level = READ_DATA(pState, 4, GLint);
	GLint xoffset = READ_DATA(pState, 8, GLint);
	GLint yoffset = READ_DATA(pState, 12, GLint);
	GLint zoffset = READ_DATA(pState, 16, GLint);
	GLint x = READ_DATA(pState, 20, GLint);
	GLint y = READ_DATA(pState, 24, GLint);
	GLsizei width = READ_DATA(pState, 28, GLsizei);
	GLsizei height = READ_DATA(pState, 32, GLsizei);
	pState->pDispatchTbl->CopyTexSubImage3D(target, level, xoffset, yoffset, zoffset, x, y, width, height);
	INCR_DATA_PTR(pState, 36);
}

static void crUnpackCullFace(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum mode = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->CullFace(mode);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackDepthFunc(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum func = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->DepthFunc(func);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackDepthMask(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLboolean flag = READ_DATA(pState, 0, GLboolean);
	pState->pDispatchTbl->DepthMask(flag);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackDepthRange(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLclampd zNear = READ_DOUBLE(pState, 0);
	GLclampd zFar = READ_DOUBLE(pState, 8);
	pState->pDispatchTbl->DepthRange(zNear, zFar);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackDisable(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum cap = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->Disable(cap);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackDisableClientState(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum array = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->DisableClientState(array);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackDrawArrays(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum mode = READ_DATA(pState, 0, GLenum);
	GLint first = READ_DATA(pState, 4, GLint);
	GLsizei count = READ_DATA(pState, 8, GLsizei);
	pState->pDispatchTbl->DrawArrays(mode, first, count);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackEdgeFlag(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->EdgeFlagv((const GLboolean *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackEnable(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum cap = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->Enable(cap);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackEnableClientState(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum array = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->EnableClientState(array);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackEnd(PCrUnpackerState pState)
{
	pState->pDispatchTbl->End();
	INCR_DATA_PTR_NO_ARGS(pState);
}

static void crUnpackEvalCoord1d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->EvalCoord1dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	pState->pDispatchTbl->EvalCoord1d(v0);
#endif
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackEvalCoord1f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->EvalCoord1fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackEvalCoord2d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->EvalCoord2dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	pState->pDispatchTbl->EvalCoord2d(v0, v1);
#endif
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackEvalCoord2f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->EvalCoord2fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackEvalMesh1(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum mode = READ_DATA(pState, 0, GLenum);
	GLint i1 = READ_DATA(pState, 4, GLint);
	GLint i2 = READ_DATA(pState, 8, GLint);
	pState->pDispatchTbl->EvalMesh1(mode, i1, i2);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackEvalMesh2(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLenum mode = READ_DATA(pState, 0, GLenum);
	GLint i1 = READ_DATA(pState, 4, GLint);
	GLint i2 = READ_DATA(pState, 8, GLint);
	GLint j1 = READ_DATA(pState, 12, GLint);
	GLint j2 = READ_DATA(pState, 16, GLint);
	pState->pDispatchTbl->EvalMesh2(mode, i1, i2, j1, j2);
	INCR_DATA_PTR(pState, 20);
}

static void crUnpackEvalPoint1(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLint i = READ_DATA(pState, 0, GLint);
	pState->pDispatchTbl->EvalPoint1(i);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackEvalPoint2(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLint i = READ_DATA(pState, 0, GLint);
	GLint j = READ_DATA(pState, 4, GLint);
	pState->pDispatchTbl->EvalPoint2(i, j);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackFeedbackBuffer(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLsizei size = READ_DATA(pState, 0, GLsizei);
	GLenum type = READ_DATA(pState, 4, GLenum);
	crError( "FeedbackBuffer needs to be special cased!" );
	pState->pDispatchTbl->FeedbackBuffer(size, type, NULL);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackFinish(PCrUnpackerState pState)
{
	pState->pDispatchTbl->Finish();
	INCR_DATA_PTR_NO_ARGS(pState);
}

static void crUnpackFlush(PCrUnpackerState pState)
{
	pState->pDispatchTbl->Flush();
	INCR_DATA_PTR_NO_ARGS(pState);
}

static void crUnpackFogCoorddEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->FogCoorddvEXT((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	pState->pDispatchTbl->FogCoorddEXT(v0);
#endif
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackFogCoordfEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->FogCoordfvEXT((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackFogf(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum pname = READ_DATA(pState, 0, GLenum);
	GLfloat param = READ_DATA(pState, 4, GLfloat);
	pState->pDispatchTbl->Fogf(pname, param);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackFogi(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum pname = READ_DATA(pState, 0, GLenum);
	GLint param = READ_DATA(pState, 4, GLint);
	pState->pDispatchTbl->Fogi(pname, param);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackFrontFace(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum mode = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->FrontFace(mode);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackFrustum(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 48);
	GLdouble left = READ_DOUBLE(pState, 0);
	GLdouble right = READ_DOUBLE(pState, 8);
	GLdouble bottom = READ_DOUBLE(pState, 16);
	GLdouble top = READ_DOUBLE(pState, 24);
	GLdouble zNear = READ_DOUBLE(pState, 32);
	GLdouble zFar = READ_DOUBLE(pState, 40);
	pState->pDispatchTbl->Frustum(left, right, bottom, top, zNear, zFar);
	INCR_DATA_PTR(pState, 48);
}

static void crUnpackIndexMask(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLuint mask = READ_DATA(pState, 0, GLuint);
	pState->pDispatchTbl->IndexMask(mask);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackIndexd(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->Indexdv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	pState->pDispatchTbl->Indexd(v0);
#endif
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackIndexf(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Indexfv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackIndexi(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Indexiv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackIndexs(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Indexsv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackIndexub(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Indexubv((const GLubyte *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackInitNames(PCrUnpackerState pState)
{
	pState->pDispatchTbl->InitNames();
	INCR_DATA_PTR_NO_ARGS(pState);
}

static void crUnpackLightModelf(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum pname = READ_DATA(pState, 0, GLenum);
	GLfloat param = READ_DATA(pState, 4, GLfloat);
	pState->pDispatchTbl->LightModelf(pname, param);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackLightModeli(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum pname = READ_DATA(pState, 0, GLenum);
	GLint param = READ_DATA(pState, 4, GLint);
	pState->pDispatchTbl->LightModeli(pname, param);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackLightf(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum light = READ_DATA(pState, 0, GLenum);
	GLenum pname = READ_DATA(pState, 4, GLenum);
	GLfloat param = READ_DATA(pState, 8, GLfloat);
	pState->pDispatchTbl->Lightf(light, pname, param);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackLighti(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum light = READ_DATA(pState, 0, GLenum);
	GLenum pname = READ_DATA(pState, 4, GLenum);
	GLint param = READ_DATA(pState, 8, GLint);
	pState->pDispatchTbl->Lighti(light, pname, param);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackLineStipple(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLint factor = READ_DATA(pState, 0, GLint);
	GLushort pattern = READ_DATA(pState, 4, GLushort);
	pState->pDispatchTbl->LineStipple(factor, pattern);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackLineWidth(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLfloat width = READ_DATA(pState, 0, GLfloat);
	pState->pDispatchTbl->LineWidth(width);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackLoadIdentity(PCrUnpackerState pState)
{
	pState->pDispatchTbl->LoadIdentity();
	INCR_DATA_PTR_NO_ARGS(pState);
}

static void crUnpackLoadName(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLuint name = READ_DATA(pState, 0, GLuint);
	pState->pDispatchTbl->LoadName(name);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackMapGrid1d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLint un = READ_DATA(pState, 0, GLint);
	GLdouble u1 = READ_DOUBLE(pState, 4);
	GLdouble u2 = READ_DOUBLE(pState, 12);
	pState->pDispatchTbl->MapGrid1d(un, u1, u2);
	INCR_DATA_PTR(pState, 20);
}

static void crUnpackMapGrid1f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLint un = READ_DATA(pState, 0, GLint);
	GLfloat u1 = READ_DATA(pState, 4, GLfloat);
	GLfloat u2 = READ_DATA(pState, 8, GLfloat);
	pState->pDispatchTbl->MapGrid1f(un, u1, u2);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackMapGrid2d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 40);
	GLint un = READ_DATA(pState, 0, GLint);
	GLdouble u1 = READ_DOUBLE(pState, 4);
	GLdouble u2 = READ_DOUBLE(pState, 12);
	GLint vn = READ_DATA(pState, 20, GLint);
	GLdouble v1 = READ_DOUBLE(pState, 24);
	GLdouble v2 = READ_DOUBLE(pState, 32);
	pState->pDispatchTbl->MapGrid2d(un, u1, u2, vn, v1, v2);
	INCR_DATA_PTR(pState, 40);
}

static void crUnpackMapGrid2f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLint un = READ_DATA(pState, 0, GLint);
	GLfloat u1 = READ_DATA(pState, 4, GLfloat);
	GLfloat u2 = READ_DATA(pState, 8, GLfloat);
	GLint vn = READ_DATA(pState, 12, GLint);
	GLfloat v1 = READ_DATA(pState, 16, GLfloat);
	GLfloat v2 = READ_DATA(pState, 20, GLfloat);
	pState->pDispatchTbl->MapGrid2f(un, u1, u2, vn, v1, v2);
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackMaterialf(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum face = READ_DATA(pState, 0, GLenum);
	GLenum pname = READ_DATA(pState, 4, GLenum);
	GLfloat param = READ_DATA(pState, 8, GLfloat);
	pState->pDispatchTbl->Materialf(face, pname, param);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackMateriali(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum face = READ_DATA(pState, 0, GLenum);
	GLenum pname = READ_DATA(pState, 4, GLenum);
	GLint param = READ_DATA(pState, 8, GLint);
	pState->pDispatchTbl->Materiali(face, pname, param);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackMatrixMode(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum mode = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->MatrixMode(mode);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackMultiTexCoord1dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLdouble s = READ_DOUBLE(pState, 4);
	pState->pDispatchTbl->MultiTexCoord1dARB(texture, s);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackMultiTexCoord1fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLfloat s = READ_DATA(pState, 4, GLfloat);
	pState->pDispatchTbl->MultiTexCoord1fARB(texture, s);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackMultiTexCoord1iARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLint s = READ_DATA(pState, 4, GLint);
	pState->pDispatchTbl->MultiTexCoord1iARB(texture, s);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackMultiTexCoord1sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLshort s = READ_DATA(pState, 4, GLshort);
	pState->pDispatchTbl->MultiTexCoord1sARB(texture, s);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackMultiTexCoord2dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLdouble s = READ_DOUBLE(pState, 4);
	GLdouble t = READ_DOUBLE(pState, 12);
	pState->pDispatchTbl->MultiTexCoord2dARB(texture, s, t);
	INCR_DATA_PTR(pState, 20);
}

static void crUnpackMultiTexCoord2fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLfloat s = READ_DATA(pState, 4, GLfloat);
	GLfloat t = READ_DATA(pState, 8, GLfloat);
	pState->pDispatchTbl->MultiTexCoord2fARB(texture, s, t);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackMultiTexCoord2iARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLint s = READ_DATA(pState, 4, GLint);
	GLint t = READ_DATA(pState, 8, GLint);
	pState->pDispatchTbl->MultiTexCoord2iARB(texture, s, t);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackMultiTexCoord2sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLshort s = READ_DATA(pState, 4, GLshort);
	GLshort t = READ_DATA(pState, 6, GLshort);
	pState->pDispatchTbl->MultiTexCoord2sARB(texture, s, t);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackMultiTexCoord3dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLdouble s = READ_DOUBLE(pState, 4);
	GLdouble t = READ_DOUBLE(pState, 12);
	GLdouble r = READ_DOUBLE(pState, 20);
	pState->pDispatchTbl->MultiTexCoord3dARB(texture, s, t, r);
	INCR_DATA_PTR(pState, 28);
}

static void crUnpackMultiTexCoord3fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLfloat s = READ_DATA(pState, 4, GLfloat);
	GLfloat t = READ_DATA(pState, 8, GLfloat);
	GLfloat r = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->MultiTexCoord3fARB(texture, s, t, r);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackMultiTexCoord3iARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLint s = READ_DATA(pState, 4, GLint);
	GLint t = READ_DATA(pState, 8, GLint);
	GLint r = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->MultiTexCoord3iARB(texture, s, t, r);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackMultiTexCoord3sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLshort s = READ_DATA(pState, 4, GLshort);
	GLshort t = READ_DATA(pState, 6, GLshort);
	GLshort r = READ_DATA(pState, 8, GLshort);
	pState->pDispatchTbl->MultiTexCoord3sARB(texture, s, t, r);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackMultiTexCoord4dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLdouble s = READ_DOUBLE(pState, 4);
	GLdouble t = READ_DOUBLE(pState, 12);
	GLdouble r = READ_DOUBLE(pState, 20);
	GLdouble q = READ_DOUBLE(pState, 28);
	pState->pDispatchTbl->MultiTexCoord4dARB(texture, s, t, r, q);
	INCR_DATA_PTR(pState, 36);
}

static void crUnpackMultiTexCoord4fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLfloat s = READ_DATA(pState, 4, GLfloat);
	GLfloat t = READ_DATA(pState, 8, GLfloat);
	GLfloat r = READ_DATA(pState, 12, GLfloat);
	GLfloat q = READ_DATA(pState, 16, GLfloat);
	pState->pDispatchTbl->MultiTexCoord4fARB(texture, s, t, r, q);
	INCR_DATA_PTR(pState, 20);
}

static void crUnpackMultiTexCoord4iARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLint s = READ_DATA(pState, 4, GLint);
	GLint t = READ_DATA(pState, 8, GLint);
	GLint r = READ_DATA(pState, 12, GLint);
	GLint q = READ_DATA(pState, 16, GLint);
	pState->pDispatchTbl->MultiTexCoord4iARB(texture, s, t, r, q);
	INCR_DATA_PTR(pState, 20);
}

static void crUnpackMultiTexCoord4sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum texture = READ_DATA(pState, 0, GLenum);
	GLshort s = READ_DATA(pState, 4, GLshort);
	GLshort t = READ_DATA(pState, 6, GLshort);
	GLshort r = READ_DATA(pState, 8, GLshort);
	GLshort q = READ_DATA(pState, 10, GLshort);
	pState->pDispatchTbl->MultiTexCoord4sARB(texture, s, t, r, q);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackNormal3b(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Normal3bv((const GLbyte *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackNormal3d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->Normal3dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->Normal3d(v0, v1, v2);
#endif
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackNormal3f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->Normal3fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackNormal3i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->Normal3iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackNormal3s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Normal3sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackOrtho(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 48);
	GLdouble left = READ_DOUBLE(pState, 0);
	GLdouble right = READ_DOUBLE(pState, 8);
	GLdouble bottom = READ_DOUBLE(pState, 16);
	GLdouble top = READ_DOUBLE(pState, 24);
	GLdouble zNear = READ_DOUBLE(pState, 32);
	GLdouble zFar = READ_DOUBLE(pState, 40);
	pState->pDispatchTbl->Ortho(left, right, bottom, top, zNear, zFar);
	INCR_DATA_PTR(pState, 48);
}

static void crUnpackPassThrough(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLfloat token = READ_DATA(pState, 0, GLfloat);
	pState->pDispatchTbl->PassThrough(token);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackPixelStoref(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum pname = READ_DATA(pState, 0, GLenum);
	GLfloat param = READ_DATA(pState, 4, GLfloat);
	pState->pDispatchTbl->PixelStoref(pname, param);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackPixelStorei(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum pname = READ_DATA(pState, 0, GLenum);
	GLint param = READ_DATA(pState, 4, GLint);
	pState->pDispatchTbl->PixelStorei(pname, param);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackPixelTransferf(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum pname = READ_DATA(pState, 0, GLenum);
	GLfloat param = READ_DATA(pState, 4, GLfloat);
	pState->pDispatchTbl->PixelTransferf(pname, param);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackPixelTransferi(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum pname = READ_DATA(pState, 0, GLenum);
	GLint param = READ_DATA(pState, 4, GLint);
	pState->pDispatchTbl->PixelTransferi(pname, param);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackPixelZoom(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLfloat xfactor = READ_DATA(pState, 0, GLfloat);
	GLfloat yfactor = READ_DATA(pState, 4, GLfloat);
	pState->pDispatchTbl->PixelZoom(xfactor, yfactor);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackPointSize(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLfloat size = READ_DATA(pState, 0, GLfloat);
	pState->pDispatchTbl->PointSize(size);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackPolygonMode(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLenum face = READ_DATA(pState, 0, GLenum);
	GLenum mode = READ_DATA(pState, 4, GLenum);
	pState->pDispatchTbl->PolygonMode(face, mode);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackPolygonOffset(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLfloat factor = READ_DATA(pState, 0, GLfloat);
	GLfloat units = READ_DATA(pState, 4, GLfloat);
	pState->pDispatchTbl->PolygonOffset(factor, units);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackPopMatrix(PCrUnpackerState pState)
{
	pState->pDispatchTbl->PopMatrix();
	INCR_DATA_PTR_NO_ARGS(pState);
}

static void crUnpackPopName(PCrUnpackerState pState)
{
	pState->pDispatchTbl->PopName();
	INCR_DATA_PTR_NO_ARGS(pState);
}

static void crUnpackPushMatrix(PCrUnpackerState pState)
{
	pState->pDispatchTbl->PushMatrix();
	INCR_DATA_PTR_NO_ARGS(pState);
}

static void crUnpackPushName(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLuint name = READ_DATA(pState, 0, GLuint);
	pState->pDispatchTbl->PushName(name);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackRasterPos2d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->RasterPos2dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	pState->pDispatchTbl->RasterPos2d(v0, v1);
#endif
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackRasterPos2f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->RasterPos2fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackRasterPos2i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->RasterPos2iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackRasterPos2s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->RasterPos2sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackRasterPos3d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->RasterPos3dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->RasterPos3d(v0, v1, v2);
#endif
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackRasterPos3f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->RasterPos3fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackRasterPos3i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->RasterPos3iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackRasterPos3s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->RasterPos3sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackRasterPos4d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->RasterPos4dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	GLdouble v3 = READ_DOUBLE(pState, 24);
	pState->pDispatchTbl->RasterPos4d(v0, v1, v2, v3);
#endif
	INCR_DATA_PTR(pState, 32);
}

static void crUnpackRasterPos4f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->RasterPos4fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackRasterPos4i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->RasterPos4iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackRasterPos4s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->RasterPos4sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackRectd(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLdouble x1 = READ_DOUBLE(pState, 0);
	GLdouble y1 = READ_DOUBLE(pState, 8);
	GLdouble x2 = READ_DOUBLE(pState, 16);
	GLdouble y2 = READ_DOUBLE(pState, 24);
	pState->pDispatchTbl->Rectd(x1, y1, x2, y2);
	INCR_DATA_PTR(pState, 32);
}

static void crUnpackRectf(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLfloat x1 = READ_DATA(pState, 0, GLfloat);
	GLfloat y1 = READ_DATA(pState, 4, GLfloat);
	GLfloat x2 = READ_DATA(pState, 8, GLfloat);
	GLfloat y2 = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->Rectf(x1, y1, x2, y2);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackRecti(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLint x1 = READ_DATA(pState, 0, GLint);
	GLint y1 = READ_DATA(pState, 4, GLint);
	GLint x2 = READ_DATA(pState, 8, GLint);
	GLint y2 = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->Recti(x1, y1, x2, y2);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackRects(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLshort x1 = READ_DATA(pState, 0, GLshort);
	GLshort y1 = READ_DATA(pState, 2, GLshort);
	GLshort x2 = READ_DATA(pState, 4, GLshort);
	GLshort y2 = READ_DATA(pState, 6, GLshort);
	pState->pDispatchTbl->Rects(x1, y1, x2, y2);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackRotated(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLdouble angle = READ_DOUBLE(pState, 0);
	GLdouble x = READ_DOUBLE(pState, 8);
	GLdouble y = READ_DOUBLE(pState, 16);
	GLdouble z = READ_DOUBLE(pState, 24);
	pState->pDispatchTbl->Rotated(angle, x, y, z);
	INCR_DATA_PTR(pState, 32);
}

static void crUnpackRotatef(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLfloat angle = READ_DATA(pState, 0, GLfloat);
	GLfloat x = READ_DATA(pState, 4, GLfloat);
	GLfloat y = READ_DATA(pState, 8, GLfloat);
	GLfloat z = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->Rotatef(angle, x, y, z);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackScaled(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLdouble x = READ_DOUBLE(pState, 0);
	GLdouble y = READ_DOUBLE(pState, 8);
	GLdouble z = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->Scaled(x, y, z);
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackScalef(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLfloat x = READ_DATA(pState, 0, GLfloat);
	GLfloat y = READ_DATA(pState, 4, GLfloat);
	GLfloat z = READ_DATA(pState, 8, GLfloat);
	pState->pDispatchTbl->Scalef(x, y, z);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackScissor(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLint x = READ_DATA(pState, 0, GLint);
	GLint y = READ_DATA(pState, 4, GLint);
	GLsizei width = READ_DATA(pState, 8, GLsizei);
	GLsizei height = READ_DATA(pState, 12, GLsizei);
	pState->pDispatchTbl->Scissor(x, y, width, height);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackSecondaryColor3bEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->SecondaryColor3bvEXT((const GLbyte *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackSecondaryColor3dEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->SecondaryColor3dvEXT((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->SecondaryColor3dEXT(v0, v1, v2);
#endif
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackSecondaryColor3fEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->SecondaryColor3fvEXT((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackSecondaryColor3iEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->SecondaryColor3ivEXT((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackSecondaryColor3sEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->SecondaryColor3svEXT((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackSecondaryColor3ubEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->SecondaryColor3ubvEXT((const GLubyte *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackSecondaryColor3uiEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->SecondaryColor3uivEXT((const GLuint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackSecondaryColor3usEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->SecondaryColor3usvEXT((const GLushort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackSelectBuffer(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLsizei size = READ_DATA(pState, 0, GLsizei);
	crError( "SelectBuffer needs to be special cased!" );
	pState->pDispatchTbl->SelectBuffer(size, NULL);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackShadeModel(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLenum mode = READ_DATA(pState, 0, GLenum);
	pState->pDispatchTbl->ShadeModel(mode);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackStencilFunc(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum func = READ_DATA(pState, 0, GLenum);
	GLint ref = READ_DATA(pState, 4, GLint);
	GLuint mask = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->StencilFunc(func, ref, mask);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackStencilMask(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	GLuint mask = READ_DATA(pState, 0, GLuint);
	pState->pDispatchTbl->StencilMask(mask);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackStencilOp(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum fail = READ_DATA(pState, 0, GLenum);
	GLenum zfail = READ_DATA(pState, 4, GLenum);
	GLenum zpass = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->StencilOp(fail, zfail, zpass);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackTexCoord1d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->TexCoord1dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	pState->pDispatchTbl->TexCoord1d(v0);
#endif
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackTexCoord1f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->TexCoord1fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackTexCoord1i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->TexCoord1iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackTexCoord1s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->TexCoord1sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackTexCoord2d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->TexCoord2dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	pState->pDispatchTbl->TexCoord2d(v0, v1);
#endif
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackTexCoord2f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->TexCoord2fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackTexCoord2i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->TexCoord2iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackTexCoord2s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->TexCoord2sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackTexCoord3d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->TexCoord3dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->TexCoord3d(v0, v1, v2);
#endif
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackTexCoord3f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->TexCoord3fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackTexCoord3i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->TexCoord3iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackTexCoord3s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->TexCoord3sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackTexCoord4d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->TexCoord4dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	GLdouble v3 = READ_DOUBLE(pState, 24);
	pState->pDispatchTbl->TexCoord4d(v0, v1, v2, v3);
#endif
	INCR_DATA_PTR(pState, 32);
}

static void crUnpackTexCoord4f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->TexCoord4fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackTexCoord4i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->TexCoord4iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackTexCoord4s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->TexCoord4sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackTranslated(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLdouble x = READ_DOUBLE(pState, 0);
	GLdouble y = READ_DOUBLE(pState, 8);
	GLdouble z = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->Translated(x, y, z);
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackTranslatef(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLfloat x = READ_DATA(pState, 0, GLfloat);
	GLfloat y = READ_DATA(pState, 4, GLfloat);
	GLfloat z = READ_DATA(pState, 8, GLfloat);
	pState->pDispatchTbl->Translatef(x, y, z);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackVertex2d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->Vertex2dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	pState->pDispatchTbl->Vertex2d(v0, v1);
#endif
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackVertex2f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Vertex2fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackVertex2i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Vertex2iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackVertex2s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 4);
	pState->pDispatchTbl->Vertex2sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 4);
}

static void crUnpackVertex3d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->Vertex3dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->Vertex3d(v0, v1, v2);
#endif
	INCR_DATA_PTR(pState, 24);
}

static void crUnpackVertex3f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->Vertex3fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackVertex3i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	pState->pDispatchTbl->Vertex3iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackVertex3s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Vertex3sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackVertex4d(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
#ifdef CR_UNALIGNED_ACCESS_OKAY
	pState->pDispatchTbl->Vertex4dv((const GLdouble *) pState->pbUnpackData);
#else
	GLdouble v0 = READ_DOUBLE(pState, 0);
	GLdouble v1 = READ_DOUBLE(pState, 8);
	GLdouble v2 = READ_DOUBLE(pState, 16);
	GLdouble v3 = READ_DOUBLE(pState, 24);
	pState->pDispatchTbl->Vertex4d(v0, v1, v2, v3);
#endif
	INCR_DATA_PTR(pState, 32);
}

static void crUnpackVertex4f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->Vertex4fv((const GLfloat *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackVertex4i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	pState->pDispatchTbl->Vertex4iv((const GLint *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackVertex4s(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->Vertex4sv((const GLshort *) pState->pbUnpackData);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackVertexAttrib1dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLdouble x = READ_DOUBLE(pState, 4);
	pState->pDispatchTbl->VertexAttrib1dARB(index, x);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackVertexAttrib1fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLfloat x = READ_DATA(pState, 4, GLfloat);
	pState->pDispatchTbl->VertexAttrib1fARB(index, x);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackVertexAttrib1sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLshort x = READ_DATA(pState, 4, GLshort);
	pState->pDispatchTbl->VertexAttrib1sARB(index, x);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackVertexAttrib2dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLdouble x = READ_DOUBLE(pState, 4);
	GLdouble y = READ_DOUBLE(pState, 12);
	pState->pDispatchTbl->VertexAttrib2dARB(index, x, y);
	INCR_DATA_PTR(pState, 20);
}

static void crUnpackVertexAttrib2fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLfloat x = READ_DATA(pState, 4, GLfloat);
	GLfloat y = READ_DATA(pState, 8, GLfloat);
	pState->pDispatchTbl->VertexAttrib2fARB(index, x, y);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackVertexAttrib2sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLshort x = READ_DATA(pState, 4, GLshort);
	GLshort y = READ_DATA(pState, 6, GLshort);
	pState->pDispatchTbl->VertexAttrib2sARB(index, x, y);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackVertexAttrib3dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLdouble x = READ_DOUBLE(pState, 4);
	GLdouble y = READ_DOUBLE(pState, 12);
	GLdouble z = READ_DOUBLE(pState, 20);
	pState->pDispatchTbl->VertexAttrib3dARB(index, x, y, z);
	INCR_DATA_PTR(pState, 28);
}

static void crUnpackVertexAttrib3fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLfloat x = READ_DATA(pState, 4, GLfloat);
	GLfloat y = READ_DATA(pState, 8, GLfloat);
	GLfloat z = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->VertexAttrib3fARB(index, x, y, z);
	INCR_DATA_PTR(pState, 16);
}

static void crUnpackVertexAttrib3sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLshort x = READ_DATA(pState, 4, GLshort);
	GLshort y = READ_DATA(pState, 6, GLshort);
	GLshort z = READ_DATA(pState, 8, GLshort);
	pState->pDispatchTbl->VertexAttrib3sARB(index, x, y, z);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackVertexAttrib4NubARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLubyte x = READ_DATA(pState, 4, GLubyte);
	GLubyte y = READ_DATA(pState, 5, GLubyte);
	GLubyte z = READ_DATA(pState, 6, GLubyte);
	GLubyte w = READ_DATA(pState, 7, GLubyte);
	pState->pDispatchTbl->VertexAttrib4NubARB(index, x, y, z, w);
	INCR_DATA_PTR(pState, 8);
}

static void crUnpackVertexAttrib4dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLdouble x = READ_DOUBLE(pState, 4);
	GLdouble y = READ_DOUBLE(pState, 12);
	GLdouble z = READ_DOUBLE(pState, 20);
	GLdouble w = READ_DOUBLE(pState, 28);
	pState->pDispatchTbl->VertexAttrib4dARB(index, x, y, z, w);
	INCR_DATA_PTR(pState, 36);
}

static void crUnpackVertexAttrib4fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLfloat x = READ_DATA(pState, 4, GLfloat);
	GLfloat y = READ_DATA(pState, 8, GLfloat);
	GLfloat z = READ_DATA(pState, 12, GLfloat);
	GLfloat w = READ_DATA(pState, 16, GLfloat);
	pState->pDispatchTbl->VertexAttrib4fARB(index, x, y, z, w);
	INCR_DATA_PTR(pState, 20);
}

static void crUnpackVertexAttrib4sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint index = READ_DATA(pState, 0, GLuint);
	GLshort x = READ_DATA(pState, 4, GLshort);
	GLshort y = READ_DATA(pState, 6, GLshort);
	GLshort z = READ_DATA(pState, 8, GLshort);
	GLshort w = READ_DATA(pState, 10, GLshort);
	pState->pDispatchTbl->VertexAttrib4sARB(index, x, y, z, w);
	INCR_DATA_PTR(pState, 12);
}

static void crUnpackViewport(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLint x = READ_DATA(pState, 0, GLint);
	GLint y = READ_DATA(pState, 4, GLint);
	GLsizei width = READ_DATA(pState, 8, GLsizei);
	GLsizei height = READ_DATA(pState, 12, GLsizei);
	pState->pDispatchTbl->Viewport(x, y, width, height);
	INCR_DATA_PTR(pState, 16);
}

 
CR_UNPACK_BUFFER_TYPE crUnpackGetBufferType(const void *opcodes, unsigned int num_opcodes)
{
    const uint8_t *pu8Codes = (const uint8_t *)opcodes;

    uint8_t first;
    uint8_t last;

    if (!num_opcodes)
        return CR_UNPACK_BUFFER_TYPE_GENERIC;

    first = pu8Codes[0];
    last = pu8Codes[1-(int)num_opcodes];
    
    switch (last)
    {
        case CR_CMDBLOCKFLUSH_OPCODE:
            return CR_UNPACK_BUFFER_TYPE_CMDBLOCK_FLUSH;
        case CR_CMDBLOCKEND_OPCODE:
            return (first == CR_CMDBLOCKBEGIN_OPCODE) ? CR_UNPACK_BUFFER_TYPE_GENERIC : CR_UNPACK_BUFFER_TYPE_CMDBLOCK_END;
        default:
            return (first != CR_CMDBLOCKBEGIN_OPCODE) ? CR_UNPACK_BUFFER_TYPE_GENERIC : CR_UNPACK_BUFFER_TYPE_CMDBLOCK_BEGIN;
    } 
}

void crUnpack(PCrUnpackerState pState)
{
    unsigned int i;

#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
    crDebug("crUnpack: %d opcodes", pState->cOpcodes);
#endif

    for (i = 0; i < pState->cOpcodes && RT_SUCCESS(pState->rcUnpack); i++)
    {
    
        CRDBGPTR_CHECKZ(pState->pWritebackPtr);
        CRDBGPTR_CHECKZ(pState->pReturnPtr);
    
        /*crDebug("Unpacking opcode \%d", *pState->pbOpcodes);*/
#ifdef CR_UNPACK_DEBUG_PREV_OPCODES
        g_VBoxDbgCrPrevOpcode = *pState->pbOpcodes;
#endif
        switch( *pState->pbOpcodes )
        {
			case CR_ALPHAFUNC_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ALPHAFUNC_OPCODE");
#endif 
				crUnpackAlphaFunc(pState); 
				break;
			case CR_ARRAYELEMENT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ARRAYELEMENT_OPCODE");
#endif 
				crUnpackArrayElement(pState); 
				break;
			case CR_BEGIN_OPCODE:
				crUnpackBegin(pState); 
				break;
			case CR_BINDTEXTURE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_BINDTEXTURE_OPCODE");
#endif 
				crUnpackBindTexture(pState); 
				break;
			case CR_BITMAP_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_BITMAP_OPCODE");
#endif 
				crUnpackBitmap(pState); 
				break;
			case CR_BLENDFUNC_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_BLENDFUNC_OPCODE");
#endif 
				crUnpackBlendFunc(pState); 
				break;
			case CR_BOUNDSINFOCR_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_BOUNDSINFOCR_OPCODE");
#endif 
				crUnpackBoundsInfoCR(pState); 
				break;
			case CR_CALLLIST_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CALLLIST_OPCODE");
#endif 
				crUnpackCallList(pState); 
				break;
			case CR_CALLLISTS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CALLLISTS_OPCODE");
#endif 
				crUnpackCallLists(pState); 
				break;
			case CR_CLEAR_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CLEAR_OPCODE");
#endif 
				crUnpackClear(pState); 
				break;
			case CR_CLIPPLANE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CLIPPLANE_OPCODE");
#endif 
				crUnpackClipPlane(pState); 
				break;
			case CR_COLOR3B_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3B_OPCODE");
#endif 
				crUnpackColor3b(pState); 
				break;
			case CR_COLOR3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3D_OPCODE");
#endif 
				crUnpackColor3d(pState); 
				break;
			case CR_COLOR3F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3F_OPCODE");
#endif 
				crUnpackColor3f(pState); 
				break;
			case CR_COLOR3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3I_OPCODE");
#endif 
				crUnpackColor3i(pState); 
				break;
			case CR_COLOR3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3S_OPCODE");
#endif 
				crUnpackColor3s(pState); 
				break;
			case CR_COLOR3UB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3UB_OPCODE");
#endif 
				crUnpackColor3ub(pState); 
				break;
			case CR_COLOR3UI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3UI_OPCODE");
#endif 
				crUnpackColor3ui(pState); 
				break;
			case CR_COLOR3US_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3US_OPCODE");
#endif 
				crUnpackColor3us(pState); 
				break;
			case CR_COLOR4B_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4B_OPCODE");
#endif 
				crUnpackColor4b(pState); 
				break;
			case CR_COLOR4D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4D_OPCODE");
#endif 
				crUnpackColor4d(pState); 
				break;
			case CR_COLOR4F_OPCODE:
				crUnpackColor4f(pState); 
				break;
			case CR_COLOR4I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4I_OPCODE");
#endif 
				crUnpackColor4i(pState); 
				break;
			case CR_COLOR4S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4S_OPCODE");
#endif 
				crUnpackColor4s(pState); 
				break;
			case CR_COLOR4UB_OPCODE:
				crUnpackColor4ub(pState); 
				break;
			case CR_COLOR4UI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4UI_OPCODE");
#endif 
				crUnpackColor4ui(pState); 
				break;
			case CR_COLOR4US_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4US_OPCODE");
#endif 
				crUnpackColor4us(pState); 
				break;
			case CR_COLORMASK_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLORMASK_OPCODE");
#endif 
				crUnpackColorMask(pState); 
				break;
			case CR_COLORMATERIAL_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLORMATERIAL_OPCODE");
#endif 
				crUnpackColorMaterial(pState); 
				break;
			case CR_COPYPIXELS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYPIXELS_OPCODE");
#endif 
				crUnpackCopyPixels(pState); 
				break;
			case CR_COPYTEXIMAGE1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXIMAGE1D_OPCODE");
#endif 
				crUnpackCopyTexImage1D(pState); 
				break;
			case CR_COPYTEXIMAGE2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXIMAGE2D_OPCODE");
#endif 
				crUnpackCopyTexImage2D(pState); 
				break;
			case CR_COPYTEXSUBIMAGE1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXSUBIMAGE1D_OPCODE");
#endif 
				crUnpackCopyTexSubImage1D(pState); 
				break;
			case CR_COPYTEXSUBIMAGE2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXSUBIMAGE2D_OPCODE");
#endif 
				crUnpackCopyTexSubImage2D(pState); 
				break;
			case CR_COPYTEXSUBIMAGE3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXSUBIMAGE3D_OPCODE");
#endif 
				crUnpackCopyTexSubImage3D(pState); 
				break;
			case CR_CULLFACE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CULLFACE_OPCODE");
#endif 
				crUnpackCullFace(pState); 
				break;
			case CR_DELETETEXTURES_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DELETETEXTURES_OPCODE");
#endif 
				crUnpackDeleteTextures(pState); 
				break;
			case CR_DEPTHFUNC_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DEPTHFUNC_OPCODE");
#endif 
				crUnpackDepthFunc(pState); 
				break;
			case CR_DEPTHMASK_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DEPTHMASK_OPCODE");
#endif 
				crUnpackDepthMask(pState); 
				break;
			case CR_DEPTHRANGE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DEPTHRANGE_OPCODE");
#endif 
				crUnpackDepthRange(pState); 
				break;
			case CR_DISABLE_OPCODE:
				crUnpackDisable(pState); 
				break;
			case CR_DISABLECLIENTSTATE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DISABLECLIENTSTATE_OPCODE");
#endif 
				crUnpackDisableClientState(pState); 
				break;
			case CR_DRAWARRAYS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DRAWARRAYS_OPCODE");
#endif 
				crUnpackDrawArrays(pState); 
				break;
			case CR_DRAWPIXELS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DRAWPIXELS_OPCODE");
#endif 
				crUnpackDrawPixels(pState); 
				break;
			case CR_EDGEFLAG_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EDGEFLAG_OPCODE");
#endif 
				crUnpackEdgeFlag(pState); 
				break;
			case CR_ENABLE_OPCODE:
				crUnpackEnable(pState); 
				break;
			case CR_ENABLECLIENTSTATE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ENABLECLIENTSTATE_OPCODE");
#endif 
				crUnpackEnableClientState(pState); 
				break;
			case CR_END_OPCODE:
				crUnpackEnd(pState); 
				break;
			case CR_EVALCOORD1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALCOORD1D_OPCODE");
#endif 
				crUnpackEvalCoord1d(pState); 
				break;
			case CR_EVALCOORD1F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALCOORD1F_OPCODE");
#endif 
				crUnpackEvalCoord1f(pState); 
				break;
			case CR_EVALCOORD2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALCOORD2D_OPCODE");
#endif 
				crUnpackEvalCoord2d(pState); 
				break;
			case CR_EVALCOORD2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALCOORD2F_OPCODE");
#endif 
				crUnpackEvalCoord2f(pState); 
				break;
			case CR_EVALMESH1_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALMESH1_OPCODE");
#endif 
				crUnpackEvalMesh1(pState); 
				break;
			case CR_EVALMESH2_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALMESH2_OPCODE");
#endif 
				crUnpackEvalMesh2(pState); 
				break;
			case CR_EVALPOINT1_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALPOINT1_OPCODE");
#endif 
				crUnpackEvalPoint1(pState); 
				break;
			case CR_EVALPOINT2_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALPOINT2_OPCODE");
#endif 
				crUnpackEvalPoint2(pState); 
				break;
			case CR_FEEDBACKBUFFER_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FEEDBACKBUFFER_OPCODE");
#endif 
				crUnpackFeedbackBuffer(pState); 
				break;
			case CR_FINISH_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FINISH_OPCODE");
#endif 
				crUnpackFinish(pState); 
				break;
			case CR_FLUSH_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FLUSH_OPCODE");
#endif 
				crUnpackFlush(pState); 
				break;
			case CR_FOGCOORDDEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGCOORDDEXT_OPCODE");
#endif 
				crUnpackFogCoorddEXT(pState); 
				break;
			case CR_FOGCOORDFEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGCOORDFEXT_OPCODE");
#endif 
				crUnpackFogCoordfEXT(pState); 
				break;
			case CR_FOGF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGF_OPCODE");
#endif 
				crUnpackFogf(pState); 
				break;
			case CR_FOGFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGFV_OPCODE");
#endif 
				crUnpackFogfv(pState); 
				break;
			case CR_FOGI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGI_OPCODE");
#endif 
				crUnpackFogi(pState); 
				break;
			case CR_FOGIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGIV_OPCODE");
#endif 
				crUnpackFogiv(pState); 
				break;
			case CR_FRONTFACE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FRONTFACE_OPCODE");
#endif 
				crUnpackFrontFace(pState); 
				break;
			case CR_FRUSTUM_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FRUSTUM_OPCODE");
#endif 
				crUnpackFrustum(pState); 
				break;
			case CR_INDEXMASK_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXMASK_OPCODE");
#endif 
				crUnpackIndexMask(pState); 
				break;
			case CR_INDEXD_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXD_OPCODE");
#endif 
				crUnpackIndexd(pState); 
				break;
			case CR_INDEXF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXF_OPCODE");
#endif 
				crUnpackIndexf(pState); 
				break;
			case CR_INDEXI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXI_OPCODE");
#endif 
				crUnpackIndexi(pState); 
				break;
			case CR_INDEXS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXS_OPCODE");
#endif 
				crUnpackIndexs(pState); 
				break;
			case CR_INDEXUB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXUB_OPCODE");
#endif 
				crUnpackIndexub(pState); 
				break;
			case CR_INITNAMES_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INITNAMES_OPCODE");
#endif 
				crUnpackInitNames(pState); 
				break;
			case CR_LIGHTMODELF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTMODELF_OPCODE");
#endif 
				crUnpackLightModelf(pState); 
				break;
			case CR_LIGHTMODELFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTMODELFV_OPCODE");
#endif 
				crUnpackLightModelfv(pState); 
				break;
			case CR_LIGHTMODELI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTMODELI_OPCODE");
#endif 
				crUnpackLightModeli(pState); 
				break;
			case CR_LIGHTMODELIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTMODELIV_OPCODE");
#endif 
				crUnpackLightModeliv(pState); 
				break;
			case CR_LIGHTF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTF_OPCODE");
#endif 
				crUnpackLightf(pState); 
				break;
			case CR_LIGHTFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTFV_OPCODE");
#endif 
				crUnpackLightfv(pState); 
				break;
			case CR_LIGHTI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTI_OPCODE");
#endif 
				crUnpackLighti(pState); 
				break;
			case CR_LIGHTIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTIV_OPCODE");
#endif 
				crUnpackLightiv(pState); 
				break;
			case CR_LINESTIPPLE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LINESTIPPLE_OPCODE");
#endif 
				crUnpackLineStipple(pState); 
				break;
			case CR_LINEWIDTH_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LINEWIDTH_OPCODE");
#endif 
				crUnpackLineWidth(pState); 
				break;
			case CR_LOADIDENTITY_OPCODE:
				crUnpackLoadIdentity(pState); 
				break;
			case CR_LOADMATRIXD_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LOADMATRIXD_OPCODE");
#endif 
				crUnpackLoadMatrixd(pState); 
				break;
			case CR_LOADMATRIXF_OPCODE:
				crUnpackLoadMatrixf(pState); 
				break;
			case CR_LOADNAME_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LOADNAME_OPCODE");
#endif 
				crUnpackLoadName(pState); 
				break;
			case CR_MAP1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAP1D_OPCODE");
#endif 
				crUnpackMap1d(pState); 
				break;
			case CR_MAP1F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAP1F_OPCODE");
#endif 
				crUnpackMap1f(pState); 
				break;
			case CR_MAP2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAP2D_OPCODE");
#endif 
				crUnpackMap2d(pState); 
				break;
			case CR_MAP2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAP2F_OPCODE");
#endif 
				crUnpackMap2f(pState); 
				break;
			case CR_MAPGRID1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAPGRID1D_OPCODE");
#endif 
				crUnpackMapGrid1d(pState); 
				break;
			case CR_MAPGRID1F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAPGRID1F_OPCODE");
#endif 
				crUnpackMapGrid1f(pState); 
				break;
			case CR_MAPGRID2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAPGRID2D_OPCODE");
#endif 
				crUnpackMapGrid2d(pState); 
				break;
			case CR_MAPGRID2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAPGRID2F_OPCODE");
#endif 
				crUnpackMapGrid2f(pState); 
				break;
			case CR_MATERIALF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MATERIALF_OPCODE");
#endif 
				crUnpackMaterialf(pState); 
				break;
			case CR_MATERIALFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MATERIALFV_OPCODE");
#endif 
				crUnpackMaterialfv(pState); 
				break;
			case CR_MATERIALI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MATERIALI_OPCODE");
#endif 
				crUnpackMateriali(pState); 
				break;
			case CR_MATERIALIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MATERIALIV_OPCODE");
#endif 
				crUnpackMaterialiv(pState); 
				break;
			case CR_MATRIXMODE_OPCODE:
				crUnpackMatrixMode(pState); 
				break;
			case CR_MULTMATRIXD_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTMATRIXD_OPCODE");
#endif 
				crUnpackMultMatrixd(pState); 
				break;
			case CR_MULTMATRIXF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTMATRIXF_OPCODE");
#endif 
				crUnpackMultMatrixf(pState); 
				break;
			case CR_MULTITEXCOORD1DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD1DARB_OPCODE");
#endif 
				crUnpackMultiTexCoord1dARB(pState); 
				break;
			case CR_MULTITEXCOORD1FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD1FARB_OPCODE");
#endif 
				crUnpackMultiTexCoord1fARB(pState); 
				break;
			case CR_MULTITEXCOORD1IARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD1IARB_OPCODE");
#endif 
				crUnpackMultiTexCoord1iARB(pState); 
				break;
			case CR_MULTITEXCOORD1SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD1SARB_OPCODE");
#endif 
				crUnpackMultiTexCoord1sARB(pState); 
				break;
			case CR_MULTITEXCOORD2DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD2DARB_OPCODE");
#endif 
				crUnpackMultiTexCoord2dARB(pState); 
				break;
			case CR_MULTITEXCOORD2FARB_OPCODE:
				crUnpackMultiTexCoord2fARB(pState); 
				break;
			case CR_MULTITEXCOORD2IARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD2IARB_OPCODE");
#endif 
				crUnpackMultiTexCoord2iARB(pState); 
				break;
			case CR_MULTITEXCOORD2SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD2SARB_OPCODE");
#endif 
				crUnpackMultiTexCoord2sARB(pState); 
				break;
			case CR_MULTITEXCOORD3DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD3DARB_OPCODE");
#endif 
				crUnpackMultiTexCoord3dARB(pState); 
				break;
			case CR_MULTITEXCOORD3FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD3FARB_OPCODE");
#endif 
				crUnpackMultiTexCoord3fARB(pState); 
				break;
			case CR_MULTITEXCOORD3IARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD3IARB_OPCODE");
#endif 
				crUnpackMultiTexCoord3iARB(pState); 
				break;
			case CR_MULTITEXCOORD3SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD3SARB_OPCODE");
#endif 
				crUnpackMultiTexCoord3sARB(pState); 
				break;
			case CR_MULTITEXCOORD4DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD4DARB_OPCODE");
#endif 
				crUnpackMultiTexCoord4dARB(pState); 
				break;
			case CR_MULTITEXCOORD4FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD4FARB_OPCODE");
#endif 
				crUnpackMultiTexCoord4fARB(pState); 
				break;
			case CR_MULTITEXCOORD4IARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD4IARB_OPCODE");
#endif 
				crUnpackMultiTexCoord4iARB(pState); 
				break;
			case CR_MULTITEXCOORD4SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD4SARB_OPCODE");
#endif 
				crUnpackMultiTexCoord4sARB(pState); 
				break;
			case CR_NORMAL3B_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_NORMAL3B_OPCODE");
#endif 
				crUnpackNormal3b(pState); 
				break;
			case CR_NORMAL3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_NORMAL3D_OPCODE");
#endif 
				crUnpackNormal3d(pState); 
				break;
			case CR_NORMAL3F_OPCODE:
				crUnpackNormal3f(pState); 
				break;
			case CR_NORMAL3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_NORMAL3I_OPCODE");
#endif 
				crUnpackNormal3i(pState); 
				break;
			case CR_NORMAL3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_NORMAL3S_OPCODE");
#endif 
				crUnpackNormal3s(pState); 
				break;
			case CR_ORTHO_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ORTHO_OPCODE");
#endif 
				crUnpackOrtho(pState); 
				break;
			case CR_PASSTHROUGH_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PASSTHROUGH_OPCODE");
#endif 
				crUnpackPassThrough(pState); 
				break;
			case CR_PIXELMAPFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELMAPFV_OPCODE");
#endif 
				crUnpackPixelMapfv(pState); 
				break;
			case CR_PIXELMAPUIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELMAPUIV_OPCODE");
#endif 
				crUnpackPixelMapuiv(pState); 
				break;
			case CR_PIXELMAPUSV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELMAPUSV_OPCODE");
#endif 
				crUnpackPixelMapusv(pState); 
				break;
			case CR_PIXELSTOREF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELSTOREF_OPCODE");
#endif 
				crUnpackPixelStoref(pState); 
				break;
			case CR_PIXELSTOREI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELSTOREI_OPCODE");
#endif 
				crUnpackPixelStorei(pState); 
				break;
			case CR_PIXELTRANSFERF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELTRANSFERF_OPCODE");
#endif 
				crUnpackPixelTransferf(pState); 
				break;
			case CR_PIXELTRANSFERI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELTRANSFERI_OPCODE");
#endif 
				crUnpackPixelTransferi(pState); 
				break;
			case CR_PIXELZOOM_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELZOOM_OPCODE");
#endif 
				crUnpackPixelZoom(pState); 
				break;
			case CR_POINTSIZE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POINTSIZE_OPCODE");
#endif 
				crUnpackPointSize(pState); 
				break;
			case CR_POLYGONMODE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POLYGONMODE_OPCODE");
#endif 
				crUnpackPolygonMode(pState); 
				break;
			case CR_POLYGONOFFSET_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POLYGONOFFSET_OPCODE");
#endif 
				crUnpackPolygonOffset(pState); 
				break;
			case CR_POLYGONSTIPPLE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POLYGONSTIPPLE_OPCODE");
#endif 
				crUnpackPolygonStipple(pState); 
				break;
			case CR_POPMATRIX_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POPMATRIX_OPCODE");
#endif 
				crUnpackPopMatrix(pState); 
				break;
			case CR_POPNAME_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POPNAME_OPCODE");
#endif 
				crUnpackPopName(pState); 
				break;
			case CR_PRIORITIZETEXTURES_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PRIORITIZETEXTURES_OPCODE");
#endif 
				crUnpackPrioritizeTextures(pState); 
				break;
			case CR_PUSHMATRIX_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PUSHMATRIX_OPCODE");
#endif 
				crUnpackPushMatrix(pState); 
				break;
			case CR_PUSHNAME_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PUSHNAME_OPCODE");
#endif 
				crUnpackPushName(pState); 
				break;
			case CR_RASTERPOS2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS2D_OPCODE");
#endif 
				crUnpackRasterPos2d(pState); 
				break;
			case CR_RASTERPOS2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS2F_OPCODE");
#endif 
				crUnpackRasterPos2f(pState); 
				break;
			case CR_RASTERPOS2I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS2I_OPCODE");
#endif 
				crUnpackRasterPos2i(pState); 
				break;
			case CR_RASTERPOS2S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS2S_OPCODE");
#endif 
				crUnpackRasterPos2s(pState); 
				break;
			case CR_RASTERPOS3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS3D_OPCODE");
#endif 
				crUnpackRasterPos3d(pState); 
				break;
			case CR_RASTERPOS3F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS3F_OPCODE");
#endif 
				crUnpackRasterPos3f(pState); 
				break;
			case CR_RASTERPOS3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS3I_OPCODE");
#endif 
				crUnpackRasterPos3i(pState); 
				break;
			case CR_RASTERPOS3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS3S_OPCODE");
#endif 
				crUnpackRasterPos3s(pState); 
				break;
			case CR_RASTERPOS4D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS4D_OPCODE");
#endif 
				crUnpackRasterPos4d(pState); 
				break;
			case CR_RASTERPOS4F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS4F_OPCODE");
#endif 
				crUnpackRasterPos4f(pState); 
				break;
			case CR_RASTERPOS4I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS4I_OPCODE");
#endif 
				crUnpackRasterPos4i(pState); 
				break;
			case CR_RASTERPOS4S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS4S_OPCODE");
#endif 
				crUnpackRasterPos4s(pState); 
				break;
			case CR_READPIXELS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_READPIXELS_OPCODE");
#endif 
				crUnpackReadPixels(pState); 
				break;
			case CR_RECTD_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RECTD_OPCODE");
#endif 
				crUnpackRectd(pState); 
				break;
			case CR_RECTF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RECTF_OPCODE");
#endif 
				crUnpackRectf(pState); 
				break;
			case CR_RECTI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RECTI_OPCODE");
#endif 
				crUnpackRecti(pState); 
				break;
			case CR_RECTS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RECTS_OPCODE");
#endif 
				crUnpackRects(pState); 
				break;
			case CR_ROTATED_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ROTATED_OPCODE");
#endif 
				crUnpackRotated(pState); 
				break;
			case CR_ROTATEF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ROTATEF_OPCODE");
#endif 
				crUnpackRotatef(pState); 
				break;
			case CR_SCALED_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SCALED_OPCODE");
#endif 
				crUnpackScaled(pState); 
				break;
			case CR_SCALEF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SCALEF_OPCODE");
#endif 
				crUnpackScalef(pState); 
				break;
			case CR_SCISSOR_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SCISSOR_OPCODE");
#endif 
				crUnpackScissor(pState); 
				break;
			case CR_SECONDARYCOLOR3BEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3BEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3bEXT(pState); 
				break;
			case CR_SECONDARYCOLOR3DEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3DEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3dEXT(pState); 
				break;
			case CR_SECONDARYCOLOR3FEXT_OPCODE:
				crUnpackSecondaryColor3fEXT(pState); 
				break;
			case CR_SECONDARYCOLOR3IEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3IEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3iEXT(pState); 
				break;
			case CR_SECONDARYCOLOR3SEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3SEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3sEXT(pState); 
				break;
			case CR_SECONDARYCOLOR3UBEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3UBEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3ubEXT(pState); 
				break;
			case CR_SECONDARYCOLOR3UIEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3UIEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3uiEXT(pState); 
				break;
			case CR_SECONDARYCOLOR3USEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3USEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3usEXT(pState); 
				break;
			case CR_SELECTBUFFER_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SELECTBUFFER_OPCODE");
#endif 
				crUnpackSelectBuffer(pState); 
				break;
			case CR_SHADEMODEL_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SHADEMODEL_OPCODE");
#endif 
				crUnpackShadeModel(pState); 
				break;
			case CR_STENCILFUNC_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_STENCILFUNC_OPCODE");
#endif 
				crUnpackStencilFunc(pState); 
				break;
			case CR_STENCILMASK_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_STENCILMASK_OPCODE");
#endif 
				crUnpackStencilMask(pState); 
				break;
			case CR_STENCILOP_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_STENCILOP_OPCODE");
#endif 
				crUnpackStencilOp(pState); 
				break;
			case CR_TEXCOORD1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD1D_OPCODE");
#endif 
				crUnpackTexCoord1d(pState); 
				break;
			case CR_TEXCOORD1F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD1F_OPCODE");
#endif 
				crUnpackTexCoord1f(pState); 
				break;
			case CR_TEXCOORD1I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD1I_OPCODE");
#endif 
				crUnpackTexCoord1i(pState); 
				break;
			case CR_TEXCOORD1S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD1S_OPCODE");
#endif 
				crUnpackTexCoord1s(pState); 
				break;
			case CR_TEXCOORD2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD2D_OPCODE");
#endif 
				crUnpackTexCoord2d(pState); 
				break;
			case CR_TEXCOORD2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD2F_OPCODE");
#endif 
				crUnpackTexCoord2f(pState); 
				break;
			case CR_TEXCOORD2I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD2I_OPCODE");
#endif 
				crUnpackTexCoord2i(pState); 
				break;
			case CR_TEXCOORD2S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD2S_OPCODE");
#endif 
				crUnpackTexCoord2s(pState); 
				break;
			case CR_TEXCOORD3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD3D_OPCODE");
#endif 
				crUnpackTexCoord3d(pState); 
				break;
			case CR_TEXCOORD3F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD3F_OPCODE");
#endif 
				crUnpackTexCoord3f(pState); 
				break;
			case CR_TEXCOORD3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD3I_OPCODE");
#endif 
				crUnpackTexCoord3i(pState); 
				break;
			case CR_TEXCOORD3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD3S_OPCODE");
#endif 
				crUnpackTexCoord3s(pState); 
				break;
			case CR_TEXCOORD4D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD4D_OPCODE");
#endif 
				crUnpackTexCoord4d(pState); 
				break;
			case CR_TEXCOORD4F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD4F_OPCODE");
#endif 
				crUnpackTexCoord4f(pState); 
				break;
			case CR_TEXCOORD4I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD4I_OPCODE");
#endif 
				crUnpackTexCoord4i(pState); 
				break;
			case CR_TEXCOORD4S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD4S_OPCODE");
#endif 
				crUnpackTexCoord4s(pState); 
				break;
			case CR_TEXENVFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXENVFV_OPCODE");
#endif 
				crUnpackTexEnvfv(pState); 
				break;
			case CR_TEXENVIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXENVIV_OPCODE");
#endif 
				crUnpackTexEnviv(pState); 
				break;
			case CR_TEXGENDV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXGENDV_OPCODE");
#endif 
				crUnpackTexGendv(pState); 
				break;
			case CR_TEXGENFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXGENFV_OPCODE");
#endif 
				crUnpackTexGenfv(pState); 
				break;
			case CR_TEXGENIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXGENIV_OPCODE");
#endif 
				crUnpackTexGeniv(pState); 
				break;
			case CR_TEXIMAGE1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXIMAGE1D_OPCODE");
#endif 
				crUnpackTexImage1D(pState); 
				break;
			case CR_TEXIMAGE2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXIMAGE2D_OPCODE");
#endif 
				crUnpackTexImage2D(pState); 
				break;
			case CR_TEXIMAGE3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXIMAGE3D_OPCODE");
#endif 
				crUnpackTexImage3D(pState); 
				break;
			case CR_TEXIMAGE3DEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXIMAGE3DEXT_OPCODE");
#endif 
				crUnpackTexImage3DEXT(pState); 
				break;
			case CR_TEXPARAMETERFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXPARAMETERFV_OPCODE");
#endif 
				crUnpackTexParameterfv(pState); 
				break;
			case CR_TEXPARAMETERIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXPARAMETERIV_OPCODE");
#endif 
				crUnpackTexParameteriv(pState); 
				break;
			case CR_TEXSUBIMAGE1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXSUBIMAGE1D_OPCODE");
#endif 
				crUnpackTexSubImage1D(pState); 
				break;
			case CR_TEXSUBIMAGE2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXSUBIMAGE2D_OPCODE");
#endif 
				crUnpackTexSubImage2D(pState); 
				break;
			case CR_TEXSUBIMAGE3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXSUBIMAGE3D_OPCODE");
#endif 
				crUnpackTexSubImage3D(pState); 
				break;
			case CR_TRANSLATED_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TRANSLATED_OPCODE");
#endif 
				crUnpackTranslated(pState); 
				break;
			case CR_TRANSLATEF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TRANSLATEF_OPCODE");
#endif 
				crUnpackTranslatef(pState); 
				break;
			case CR_VERTEX2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX2D_OPCODE");
#endif 
				crUnpackVertex2d(pState); 
				break;
			case CR_VERTEX2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX2F_OPCODE");
#endif 
				crUnpackVertex2f(pState); 
				break;
			case CR_VERTEX2I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX2I_OPCODE");
#endif 
				crUnpackVertex2i(pState); 
				break;
			case CR_VERTEX2S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX2S_OPCODE");
#endif 
				crUnpackVertex2s(pState); 
				break;
			case CR_VERTEX3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX3D_OPCODE");
#endif 
				crUnpackVertex3d(pState); 
				break;
			case CR_VERTEX3F_OPCODE:
				crUnpackVertex3f(pState); 
				break;
			case CR_VERTEX3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX3I_OPCODE");
#endif 
				crUnpackVertex3i(pState); 
				break;
			case CR_VERTEX3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX3S_OPCODE");
#endif 
				crUnpackVertex3s(pState); 
				break;
			case CR_VERTEX4D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX4D_OPCODE");
#endif 
				crUnpackVertex4d(pState); 
				break;
			case CR_VERTEX4F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX4F_OPCODE");
#endif 
				crUnpackVertex4f(pState); 
				break;
			case CR_VERTEX4I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX4I_OPCODE");
#endif 
				crUnpackVertex4i(pState); 
				break;
			case CR_VERTEX4S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX4S_OPCODE");
#endif 
				crUnpackVertex4s(pState); 
				break;
			case CR_VERTEXATTRIB1DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB1DARB_OPCODE");
#endif 
				crUnpackVertexAttrib1dARB(pState); 
				break;
			case CR_VERTEXATTRIB1FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB1FARB_OPCODE");
#endif 
				crUnpackVertexAttrib1fARB(pState); 
				break;
			case CR_VERTEXATTRIB1SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB1SARB_OPCODE");
#endif 
				crUnpackVertexAttrib1sARB(pState); 
				break;
			case CR_VERTEXATTRIB2DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB2DARB_OPCODE");
#endif 
				crUnpackVertexAttrib2dARB(pState); 
				break;
			case CR_VERTEXATTRIB2FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB2FARB_OPCODE");
#endif 
				crUnpackVertexAttrib2fARB(pState); 
				break;
			case CR_VERTEXATTRIB2SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB2SARB_OPCODE");
#endif 
				crUnpackVertexAttrib2sARB(pState); 
				break;
			case CR_VERTEXATTRIB3DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB3DARB_OPCODE");
#endif 
				crUnpackVertexAttrib3dARB(pState); 
				break;
			case CR_VERTEXATTRIB3FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB3FARB_OPCODE");
#endif 
				crUnpackVertexAttrib3fARB(pState); 
				break;
			case CR_VERTEXATTRIB3SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB3SARB_OPCODE");
#endif 
				crUnpackVertexAttrib3sARB(pState); 
				break;
			case CR_VERTEXATTRIB4NBVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NBVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NbvARB(pState); 
				break;
			case CR_VERTEXATTRIB4NIVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NIVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NivARB(pState); 
				break;
			case CR_VERTEXATTRIB4NSVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NSVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NsvARB(pState); 
				break;
			case CR_VERTEXATTRIB4NUBARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NUBARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NubARB(pState); 
				break;
			case CR_VERTEXATTRIB4NUBVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NUBVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NubvARB(pState); 
				break;
			case CR_VERTEXATTRIB4NUIVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NUIVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NuivARB(pState); 
				break;
			case CR_VERTEXATTRIB4NUSVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NUSVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NusvARB(pState); 
				break;
			case CR_VERTEXATTRIB4BVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4BVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4bvARB(pState); 
				break;
			case CR_VERTEXATTRIB4DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4DARB_OPCODE");
#endif 
				crUnpackVertexAttrib4dARB(pState); 
				break;
			case CR_VERTEXATTRIB4FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4FARB_OPCODE");
#endif 
				crUnpackVertexAttrib4fARB(pState); 
				break;
			case CR_VERTEXATTRIB4IVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4IVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4ivARB(pState); 
				break;
			case CR_VERTEXATTRIB4SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4SARB_OPCODE");
#endif 
				crUnpackVertexAttrib4sARB(pState); 
				break;
			case CR_VERTEXATTRIB4UBVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4UBVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4ubvARB(pState); 
				break;
			case CR_VERTEXATTRIB4UIVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4UIVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4uivARB(pState); 
				break;
			case CR_VERTEXATTRIB4USVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4USVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4usvARB(pState); 
				break;
			case CR_VIEWPORT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(pState->cOpcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VIEWPORT_OPCODE");
#endif 
				crUnpackViewport(pState); 
				break;
       
            case CR_EXTEND_OPCODE:
                #ifdef CR_UNPACK_DEBUG_OPCODES 
                    crUnpackExtendDbg(pState);
                #else
                # ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                    if (i==(pState->cOpcodes-1)) crUnpackExtendDbg(pState);
                    else
                # endif
                    crUnpackExtend(pState);
                #endif
                break;
            case CR_CMDBLOCKBEGIN_OPCODE:
            case CR_CMDBLOCKEND_OPCODE:
            case CR_CMDBLOCKFLUSH_OPCODE:
            case CR_NOP_OPCODE:
                INCR_DATA_PTR_NO_ARGS(pState);
                break;
            default:
                crError( "Unknown opcode: %d", *pState->pbOpcodes );
                break;
        }

        CRDBGPTR_CHECKZ(pState->pWritebackPtr);
        CRDBGPTR_CHECKZ(pState->pReturnPtr);
        pState->pbOpcodes--;
    }
}
static void crUnpackExtendAccum(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum op = READ_DATA(pState, 8, GLenum);
	GLfloat value = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->Accum(op, value);
}

static void crUnpackExtendActiveStencilFaceEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum face = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->ActiveStencilFaceEXT(face);
}

static void crUnpackExtendActiveTextureARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum texture = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->ActiveTextureARB(texture);
}

static void crUnpackExtendAttachShader(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLuint program = READ_DATA(pState, 8, GLuint);
	GLuint shader = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->AttachShader(program, shader);
}

static void crUnpackExtendBarrierCreateCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLuint name = READ_DATA(pState, 8, GLuint);
	GLuint count = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->BarrierCreateCR(name, count);
}

static void crUnpackExtendBarrierDestroyCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint name = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->BarrierDestroyCR(name);
}

static void crUnpackExtendBarrierExecCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint name = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->BarrierExecCR(name);
}

static void crUnpackExtendBeginQueryARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint id = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->BeginQueryARB(target, id);
}

static void crUnpackExtendBindBufferARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint buffer = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->BindBufferARB(target, buffer);
}

static void crUnpackExtendBindFramebufferEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint framebuffer = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->BindFramebufferEXT(target, framebuffer);
}

static void crUnpackExtendBindProgramARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint program = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->BindProgramARB(target, program);
}

static void crUnpackExtendBindProgramNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint id = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->BindProgramNV(target, id);
}

static void crUnpackExtendBindRenderbufferEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint renderbuffer = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->BindRenderbufferEXT(target, renderbuffer);
}

static void crUnpackExtendBlendColorEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLclampf red = READ_DATA(pState, 8, GLclampf);
	GLclampf green = READ_DATA(pState, 12, GLclampf);
	GLclampf blue = READ_DATA(pState, 16, GLclampf);
	GLclampf alpha = READ_DATA(pState, 20, GLclampf);
	pState->pDispatchTbl->BlendColorEXT(red, green, blue, alpha);
}

static void crUnpackExtendBlendEquationEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum mode = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->BlendEquationEXT(mode);
}

static void crUnpackExtendBlendEquationSeparate(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum modeRGB = READ_DATA(pState, 8, GLenum);
	GLenum modeAlpha = READ_DATA(pState, 12, GLenum);
	pState->pDispatchTbl->BlendEquationSeparate(modeRGB, modeAlpha);
}

static void crUnpackExtendBlendFuncSeparateEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLenum sfactorRGB = READ_DATA(pState, 8, GLenum);
	GLenum dfactorRGB = READ_DATA(pState, 12, GLenum);
	GLenum sfactorA = READ_DATA(pState, 16, GLenum);
	GLenum dfactorA = READ_DATA(pState, 20, GLenum);
	pState->pDispatchTbl->BlendFuncSeparateEXT(sfactorRGB, dfactorRGB, sfactorA, dfactorA);
}

static void crUnpackExtendBlitFramebufferEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 48);
	GLint srcX0 = READ_DATA(pState, 8, GLint);
	GLint srcY0 = READ_DATA(pState, 12, GLint);
	GLint srcX1 = READ_DATA(pState, 16, GLint);
	GLint srcY1 = READ_DATA(pState, 20, GLint);
	GLint dstX0 = READ_DATA(pState, 24, GLint);
	GLint dstY0 = READ_DATA(pState, 28, GLint);
	GLint dstX1 = READ_DATA(pState, 32, GLint);
	GLint dstY1 = READ_DATA(pState, 36, GLint);
	GLbitfield mask = READ_DATA(pState, 40, GLbitfield);
	GLenum filter = READ_DATA(pState, 44, GLenum);
	pState->pDispatchTbl->BlitFramebufferEXT(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
}

static void crUnpackExtendCheckFramebufferStatusEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum target = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->CheckFramebufferStatusEXT(target);
}

static void crUnpackExtendChromiumParameterfCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLfloat value = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->ChromiumParameterfCR(target, value);
}

static void crUnpackExtendChromiumParameteriCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLint value = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->ChromiumParameteriCR(target, value);
}

static void crUnpackExtendClearAccum(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLfloat red = READ_DATA(pState, 8, GLfloat);
	GLfloat green = READ_DATA(pState, 12, GLfloat);
	GLfloat blue = READ_DATA(pState, 16, GLfloat);
	GLfloat alpha = READ_DATA(pState, 20, GLfloat);
	pState->pDispatchTbl->ClearAccum(red, green, blue, alpha);
}

static void crUnpackExtendClearColor(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLclampf red = READ_DATA(pState, 8, GLclampf);
	GLclampf green = READ_DATA(pState, 12, GLclampf);
	GLclampf blue = READ_DATA(pState, 16, GLclampf);
	GLclampf alpha = READ_DATA(pState, 20, GLclampf);
	pState->pDispatchTbl->ClearColor(red, green, blue, alpha);
}

static void crUnpackExtendClearDepth(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLclampd depth = READ_DOUBLE(pState, 8);
	pState->pDispatchTbl->ClearDepth(depth);
}

static void crUnpackExtendClearIndex(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLfloat c = READ_DATA(pState, 8, GLfloat);
	pState->pDispatchTbl->ClearIndex(c);
}

static void crUnpackExtendClearStencil(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLint s = READ_DATA(pState, 8, GLint);
	pState->pDispatchTbl->ClearStencil(s);
}

static void crUnpackExtendClientActiveTextureARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum texture = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->ClientActiveTextureARB(texture);
}

static void crUnpackExtendCombinerInputNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum stage = READ_DATA(pState, 8, GLenum);
	GLenum portion = READ_DATA(pState, 12, GLenum);
	GLenum variable = READ_DATA(pState, 16, GLenum);
	GLenum input = READ_DATA(pState, 20, GLenum);
	GLenum mapping = READ_DATA(pState, 24, GLenum);
	GLenum componentUsage = READ_DATA(pState, 28, GLenum);
	pState->pDispatchTbl->CombinerInputNV(stage, portion, variable, input, mapping, componentUsage);
}

static void crUnpackExtendCombinerOutputNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 40);
	GLenum stage = READ_DATA(pState, 8, GLenum);
	GLenum portion = READ_DATA(pState, 12, GLenum);
	GLenum abOutput = READ_DATA(pState, 16, GLenum);
	GLenum cdOutput = READ_DATA(pState, 20, GLenum);
	GLenum sumOutput = READ_DATA(pState, 24, GLenum);
	GLenum scale = READ_DATA(pState, 28, GLenum);
	GLenum bias = READ_DATA(pState, 32, GLenum);
	GLboolean abDotProduct = READ_DATA(pState, 36, GLboolean);
	GLboolean cdDotProduct = READ_DATA(pState, 37, GLboolean);
	GLboolean muxSum = READ_DATA(pState, 38, GLboolean);
	pState->pDispatchTbl->CombinerOutputNV(stage, portion, abOutput, cdOutput, sumOutput, scale, bias, abDotProduct, cdDotProduct, muxSum);
}

static void crUnpackExtendCombinerParameterfNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	GLfloat param = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->CombinerParameterfNV(pname, param);
}

static void crUnpackExtendCombinerParameteriNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	GLint param = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->CombinerParameteriNV(pname, param);
}

static void crUnpackExtendCompileShader(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint shader = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->CompileShader(shader);
}

static void crUnpackExtendCreateProgram(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	SET_RETURN_PTR(pState, 8);
	SET_WRITEBACK_PTR(pState, 16);
	(void) pState->pDispatchTbl->CreateProgram();
}

static void crUnpackExtendCreateShader(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum type = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->CreateShader(type);
}

static void crUnpackExtendDeleteLists(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLuint list = READ_DATA(pState, 8, GLuint);
	GLsizei range = READ_DATA(pState, 12, GLsizei);
	pState->pDispatchTbl->DeleteLists(list, range);
}

static void crUnpackExtendDeleteObjectARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	VBoxGLhandleARB obj = READ_DATA(pState, 8, VBoxGLhandleARB);
	pState->pDispatchTbl->DeleteObjectARB(obj);
}

static void crUnpackExtendDeleteProgram(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint program = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->DeleteProgram(program);
}

static void crUnpackExtendDeleteShader(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint shader = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->DeleteShader(shader);
}

static void crUnpackExtendDestroyContext(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLint ctx = READ_DATA(pState, 8, GLint);
	pState->pDispatchTbl->DestroyContext(ctx);
}

static void crUnpackExtendDetachShader(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLuint program = READ_DATA(pState, 8, GLuint);
	GLuint shader = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->DetachShader(program, shader);
}

static void crUnpackExtendDisableVertexAttribArrayARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint index = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->DisableVertexAttribArrayARB(index);
}

static void crUnpackExtendDrawBuffer(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum mode = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->DrawBuffer(mode);
}

static void crUnpackExtendEnableVertexAttribArrayARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint index = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->EnableVertexAttribArrayARB(index);
}

static void crUnpackExtendEndList(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->EndList();
}

static void crUnpackExtendEndQueryARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum target = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->EndQueryARB(target);
}

static void crUnpackExtendFinalCombinerInputNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLenum variable = READ_DATA(pState, 8, GLenum);
	GLenum input = READ_DATA(pState, 12, GLenum);
	GLenum mapping = READ_DATA(pState, 16, GLenum);
	GLenum componentUsage = READ_DATA(pState, 20, GLenum);
	pState->pDispatchTbl->FinalCombinerInputNV(variable, input, mapping, componentUsage);
}

static void crUnpackExtendFinishFenceNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint fence = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->FinishFenceNV(fence);
}

static void crUnpackExtendFlushVertexArrayRangeNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->FlushVertexArrayRangeNV();
}

static void crUnpackExtendFramebufferRenderbufferEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum attachment = READ_DATA(pState, 12, GLenum);
	GLenum renderbuffertarget = READ_DATA(pState, 16, GLenum);
	GLuint renderbuffer = READ_DATA(pState, 20, GLuint);
	pState->pDispatchTbl->FramebufferRenderbufferEXT(target, attachment, renderbuffertarget, renderbuffer);
}

static void crUnpackExtendFramebufferTexture1DEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum attachment = READ_DATA(pState, 12, GLenum);
	GLenum textarget = READ_DATA(pState, 16, GLenum);
	GLuint texture = READ_DATA(pState, 20, GLuint);
	GLint level = READ_DATA(pState, 24, GLint);
	pState->pDispatchTbl->FramebufferTexture1DEXT(target, attachment, textarget, texture, level);
}

static void crUnpackExtendFramebufferTexture2DEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum attachment = READ_DATA(pState, 12, GLenum);
	GLenum textarget = READ_DATA(pState, 16, GLenum);
	GLuint texture = READ_DATA(pState, 20, GLuint);
	GLint level = READ_DATA(pState, 24, GLint);
	pState->pDispatchTbl->FramebufferTexture2DEXT(target, attachment, textarget, texture, level);
}

static void crUnpackExtendFramebufferTexture3DEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum attachment = READ_DATA(pState, 12, GLenum);
	GLenum textarget = READ_DATA(pState, 16, GLenum);
	GLuint texture = READ_DATA(pState, 20, GLuint);
	GLint level = READ_DATA(pState, 24, GLint);
	GLint zoffset = READ_DATA(pState, 28, GLint);
	pState->pDispatchTbl->FramebufferTexture3DEXT(target, attachment, textarget, texture, level, zoffset);
}

static void crUnpackExtendGenBuffersARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei n = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GenBuffersARB(n, NULL);
}

static void crUnpackExtendGenFencesNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei n = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GenFencesNV(n, NULL);
}

static void crUnpackExtendGenFramebuffersEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei n = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GenFramebuffersEXT(n, NULL);
}

static void crUnpackExtendGenLists(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei range = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->GenLists(range);
}

static void crUnpackExtendGenProgramsARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei n = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GenProgramsARB(n, NULL);
}

static void crUnpackExtendGenProgramsNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei n = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GenProgramsNV(n, NULL);
}

static void crUnpackExtendGenQueriesARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei n = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GenQueriesARB(n, NULL);
}

static void crUnpackExtendGenRenderbuffersEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei n = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GenRenderbuffersEXT(n, NULL);
}

static void crUnpackExtendGenTextures(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLsizei n = READ_DATA(pState, 8, GLsizei);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GenTextures(n, NULL);
}

static void crUnpackExtendGenerateMipmapEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum target = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->GenerateMipmapEXT(target);
}

static void crUnpackExtendGetBooleanv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GetBooleanv(pname, NULL);
}

static void crUnpackExtendGetBufferParameterivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetBufferParameterivARB(target, pname, NULL);
}

static void crUnpackExtendGetChromiumParametervCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 40);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLenum type = READ_DATA(pState, 16, GLenum);
	GLsizei count = READ_DATA(pState, 20, GLsizei);
	SET_RETURN_PTR(pState, 24);
	SET_WRITEBACK_PTR(pState, 32);
	pState->pDispatchTbl->GetChromiumParametervCR(target, index, type, count, NULL);
}

static void crUnpackExtendGetClipPlane(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum plane = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GetClipPlane(plane, NULL);
}

static void crUnpackExtendGetCombinerInputParameterfvNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 40);
	GLenum stage = READ_DATA(pState, 8, GLenum);
	GLenum portion = READ_DATA(pState, 12, GLenum);
	GLenum variable = READ_DATA(pState, 16, GLenum);
	GLenum pname = READ_DATA(pState, 20, GLenum);
	SET_RETURN_PTR(pState, 24);
	SET_WRITEBACK_PTR(pState, 32);
	pState->pDispatchTbl->GetCombinerInputParameterfvNV(stage, portion, variable, pname, NULL);
}

static void crUnpackExtendGetCombinerInputParameterivNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 40);
	GLenum stage = READ_DATA(pState, 8, GLenum);
	GLenum portion = READ_DATA(pState, 12, GLenum);
	GLenum variable = READ_DATA(pState, 16, GLenum);
	GLenum pname = READ_DATA(pState, 20, GLenum);
	SET_RETURN_PTR(pState, 24);
	SET_WRITEBACK_PTR(pState, 32);
	pState->pDispatchTbl->GetCombinerInputParameterivNV(stage, portion, variable, pname, NULL);
}

static void crUnpackExtendGetCombinerOutputParameterfvNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum stage = READ_DATA(pState, 8, GLenum);
	GLenum portion = READ_DATA(pState, 12, GLenum);
	GLenum pname = READ_DATA(pState, 16, GLenum);
	SET_RETURN_PTR(pState, 20);
	SET_WRITEBACK_PTR(pState, 28);
	pState->pDispatchTbl->GetCombinerOutputParameterfvNV(stage, portion, pname, NULL);
}

static void crUnpackExtendGetCombinerOutputParameterivNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum stage = READ_DATA(pState, 8, GLenum);
	GLenum portion = READ_DATA(pState, 12, GLenum);
	GLenum pname = READ_DATA(pState, 16, GLenum);
	SET_RETURN_PTR(pState, 20);
	SET_WRITEBACK_PTR(pState, 28);
	pState->pDispatchTbl->GetCombinerOutputParameterivNV(stage, portion, pname, NULL);
}

static void crUnpackExtendGetCombinerStageParameterfvNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum stage = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetCombinerStageParameterfvNV(stage, pname, NULL);
}

static void crUnpackExtendGetDoublev(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GetDoublev(pname, NULL);
}

static void crUnpackExtendGetError(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	SET_RETURN_PTR(pState, 8);
	SET_WRITEBACK_PTR(pState, 16);
	(void) pState->pDispatchTbl->GetError();
}

static void crUnpackExtendGetFenceivNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint fence = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetFenceivNV(fence, pname, NULL);
}

static void crUnpackExtendGetFinalCombinerInputParameterfvNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum variable = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetFinalCombinerInputParameterfvNV(variable, pname, NULL);
}

static void crUnpackExtendGetFinalCombinerInputParameterivNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum variable = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetFinalCombinerInputParameterivNV(variable, pname, NULL);
}

static void crUnpackExtendGetFloatv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GetFloatv(pname, NULL);
}

static void crUnpackExtendGetFramebufferAttachmentParameterivEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum attachment = READ_DATA(pState, 12, GLenum);
	GLenum pname = READ_DATA(pState, 16, GLenum);
	SET_RETURN_PTR(pState, 20);
	SET_WRITEBACK_PTR(pState, 28);
	pState->pDispatchTbl->GetFramebufferAttachmentParameterivEXT(target, attachment, pname, NULL);
}

static void crUnpackExtendGetHandleARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->GetHandleARB(pname);
}

static void crUnpackExtendGetIntegerv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GetIntegerv(pname, NULL);
}

static void crUnpackExtendGetLightfv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum light = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetLightfv(light, pname, NULL);
}

static void crUnpackExtendGetLightiv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum light = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetLightiv(light, pname, NULL);
}

static void crUnpackExtendGetMapdv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum query = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetMapdv(target, query, NULL);
}

static void crUnpackExtendGetMapfv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum query = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetMapfv(target, query, NULL);
}

static void crUnpackExtendGetMapiv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum query = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetMapiv(target, query, NULL);
}

static void crUnpackExtendGetMaterialfv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum face = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetMaterialfv(face, pname, NULL);
}

static void crUnpackExtendGetMaterialiv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum face = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetMaterialiv(face, pname, NULL);
}

static void crUnpackExtendGetObjectParameterfvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	VBoxGLhandleARB obj = READ_DATA(pState, 8, VBoxGLhandleARB);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetObjectParameterfvARB(obj, pname, NULL);
}

static void crUnpackExtendGetObjectParameterivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	VBoxGLhandleARB obj = READ_DATA(pState, 8, VBoxGLhandleARB);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetObjectParameterivARB(obj, pname, NULL);
}

static void crUnpackExtendGetPointerv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	pState->pDispatchTbl->GetPointerv(pname, NULL);
}

static void crUnpackExtendGetProgramEnvParameterdvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetProgramEnvParameterdvARB(target, index, NULL);
}

static void crUnpackExtendGetProgramEnvParameterfvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetProgramEnvParameterfvARB(target, index, NULL);
}

static void crUnpackExtendGetProgramLocalParameterdvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetProgramLocalParameterdvARB(target, index, NULL);
}

static void crUnpackExtendGetProgramLocalParameterfvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetProgramLocalParameterfvARB(target, index, NULL);
}

static void crUnpackExtendGetProgramParameterdvNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLenum pname = READ_DATA(pState, 16, GLenum);
	SET_RETURN_PTR(pState, 20);
	SET_WRITEBACK_PTR(pState, 28);
	pState->pDispatchTbl->GetProgramParameterdvNV(target, index, pname, NULL);
}

static void crUnpackExtendGetProgramParameterfvNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLenum pname = READ_DATA(pState, 16, GLenum);
	SET_RETURN_PTR(pState, 20);
	SET_WRITEBACK_PTR(pState, 28);
	pState->pDispatchTbl->GetProgramParameterfvNV(target, index, pname, NULL);
}

static void crUnpackExtendGetProgramStringNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint id = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetProgramStringNV(id, pname, NULL);
}

static void crUnpackExtendGetProgramiv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint program = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetProgramiv(program, pname, NULL);
}

static void crUnpackExtendGetProgramivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetProgramivARB(target, pname, NULL);
}

static void crUnpackExtendGetProgramivNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint id = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetProgramivNV(id, pname, NULL);
}

static void crUnpackExtendGetQueryObjectivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint id = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetQueryObjectivARB(id, pname, NULL);
}

static void crUnpackExtendGetQueryObjectuivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint id = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetQueryObjectuivARB(id, pname, NULL);
}

static void crUnpackExtendGetQueryivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetQueryivARB(target, pname, NULL);
}

static void crUnpackExtendGetRenderbufferParameterivEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetRenderbufferParameterivEXT(target, pname, NULL);
}

static void crUnpackExtendGetShaderiv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint shader = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetShaderiv(shader, pname, NULL);
}

static void crUnpackExtendGetString(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum name = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->GetString(name);
}

static void crUnpackExtendGetTexEnvfv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetTexEnvfv(target, pname, NULL);
}

static void crUnpackExtendGetTexEnviv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetTexEnviv(target, pname, NULL);
}

static void crUnpackExtendGetTexGendv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum coord = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetTexGendv(coord, pname, NULL);
}

static void crUnpackExtendGetTexGenfv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum coord = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetTexGenfv(coord, pname, NULL);
}

static void crUnpackExtendGetTexGeniv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum coord = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetTexGeniv(coord, pname, NULL);
}

static void crUnpackExtendGetTexLevelParameterfv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLint level = READ_DATA(pState, 12, GLint);
	GLenum pname = READ_DATA(pState, 16, GLenum);
	SET_RETURN_PTR(pState, 20);
	SET_WRITEBACK_PTR(pState, 28);
	pState->pDispatchTbl->GetTexLevelParameterfv(target, level, pname, NULL);
}

static void crUnpackExtendGetTexLevelParameteriv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLint level = READ_DATA(pState, 12, GLint);
	GLenum pname = READ_DATA(pState, 16, GLenum);
	SET_RETURN_PTR(pState, 20);
	SET_WRITEBACK_PTR(pState, 28);
	pState->pDispatchTbl->GetTexLevelParameteriv(target, level, pname, NULL);
}

static void crUnpackExtendGetTexParameterfv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetTexParameterfv(target, pname, NULL);
}

static void crUnpackExtendGetTexParameteriv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetTexParameteriv(target, pname, NULL);
}

static void crUnpackExtendGetTrackMatrixivNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 36);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint address = READ_DATA(pState, 12, GLuint);
	GLenum pname = READ_DATA(pState, 16, GLenum);
	SET_RETURN_PTR(pState, 20);
	SET_WRITEBACK_PTR(pState, 28);
	pState->pDispatchTbl->GetTrackMatrixivNV(target, address, pname, NULL);
}

static void crUnpackExtendGetUniformfv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint program = READ_DATA(pState, 8, GLuint);
	GLint location = READ_DATA(pState, 12, GLint);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetUniformfv(program, location, NULL);
}

static void crUnpackExtendGetUniformiv(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint program = READ_DATA(pState, 8, GLuint);
	GLint location = READ_DATA(pState, 12, GLint);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetUniformiv(program, location, NULL);
}

static void crUnpackExtendGetVertexAttribPointervARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint index = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetVertexAttribPointervARB(index, pname, NULL);
}

static void crUnpackExtendGetVertexAttribPointervNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint index = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetVertexAttribPointervNV(index, pname, NULL);
}

static void crUnpackExtendGetVertexAttribdvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint index = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetVertexAttribdvARB(index, pname, NULL);
}

static void crUnpackExtendGetVertexAttribdvNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint index = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetVertexAttribdvNV(index, pname, NULL);
}

static void crUnpackExtendGetVertexAttribfvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint index = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetVertexAttribfvARB(index, pname, NULL);
}

static void crUnpackExtendGetVertexAttribfvNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint index = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetVertexAttribfvNV(index, pname, NULL);
}

static void crUnpackExtendGetVertexAttribivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint index = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetVertexAttribivARB(index, pname, NULL);
}

static void crUnpackExtendGetVertexAttribivNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLuint index = READ_DATA(pState, 8, GLuint);
	GLenum pname = READ_DATA(pState, 12, GLenum);
	SET_RETURN_PTR(pState, 16);
	SET_WRITEBACK_PTR(pState, 24);
	pState->pDispatchTbl->GetVertexAttribivNV(index, pname, NULL);
}

static void crUnpackExtendHint(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum mode = READ_DATA(pState, 12, GLenum);
	pState->pDispatchTbl->Hint(target, mode);
}

static void crUnpackExtendIsBufferARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint buffer = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsBufferARB(buffer);
}

static void crUnpackExtendIsEnabled(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum cap = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsEnabled(cap);
}

static void crUnpackExtendIsFenceNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint fence = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsFenceNV(fence);
}

static void crUnpackExtendIsFramebufferEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint framebuffer = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsFramebufferEXT(framebuffer);
}

static void crUnpackExtendIsList(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint list = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsList(list);
}

static void crUnpackExtendIsProgram(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint program = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsProgram(program);
}

static void crUnpackExtendIsProgramARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint program = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsProgramARB(program);
}

static void crUnpackExtendIsQueryARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint id = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsQueryARB(id);
}

static void crUnpackExtendIsRenderbufferEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint renderbuffer = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsRenderbufferEXT(renderbuffer);
}

static void crUnpackExtendIsShader(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint shader = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsShader(shader);
}

static void crUnpackExtendIsTexture(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint texture = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->IsTexture(texture);
}

static void crUnpackExtendLinkProgram(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint program = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->LinkProgram(program);
}

static void crUnpackExtendListBase(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint base = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->ListBase(base);
}

static void crUnpackExtendLogicOp(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum opcode = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->LogicOp(opcode);
}

static void crUnpackExtendMakeCurrent(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLint window = READ_DATA(pState, 8, GLint);
	GLint nativeWindow = READ_DATA(pState, 12, GLint);
	GLint ctx = READ_DATA(pState, 16, GLint);
	pState->pDispatchTbl->MakeCurrent(window, nativeWindow, ctx);
}

static void crUnpackExtendNewList(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLuint list = READ_DATA(pState, 8, GLuint);
	GLenum mode = READ_DATA(pState, 12, GLenum);
	pState->pDispatchTbl->NewList(list, mode);
}

static void crUnpackExtendPointParameterfARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	GLfloat param = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->PointParameterfARB(pname, param);
}

static void crUnpackExtendPointParameteri(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum pname = READ_DATA(pState, 8, GLenum);
	GLint param = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->PointParameteri(pname, param);
}

static void crUnpackExtendPopAttrib(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->PopAttrib();
}

static void crUnpackExtendPopClientAttrib(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 8);
	pState->pDispatchTbl->PopClientAttrib();
}

static void crUnpackExtendProgramEnvParameter4dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 48);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLdouble x = READ_DOUBLE(pState, 16);
	GLdouble y = READ_DOUBLE(pState, 24);
	GLdouble z = READ_DOUBLE(pState, 32);
	GLdouble w = READ_DOUBLE(pState, 40);
	pState->pDispatchTbl->ProgramEnvParameter4dARB(target, index, x, y, z, w);
}

static void crUnpackExtendProgramEnvParameter4fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLfloat x = READ_DATA(pState, 16, GLfloat);
	GLfloat y = READ_DATA(pState, 20, GLfloat);
	GLfloat z = READ_DATA(pState, 24, GLfloat);
	GLfloat w = READ_DATA(pState, 28, GLfloat);
	pState->pDispatchTbl->ProgramEnvParameter4fARB(target, index, x, y, z, w);
}

static void crUnpackExtendProgramLocalParameter4dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 48);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLdouble x = READ_DOUBLE(pState, 16);
	GLdouble y = READ_DOUBLE(pState, 24);
	GLdouble z = READ_DOUBLE(pState, 32);
	GLdouble w = READ_DOUBLE(pState, 40);
	pState->pDispatchTbl->ProgramLocalParameter4dARB(target, index, x, y, z, w);
}

static void crUnpackExtendProgramLocalParameter4fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLfloat x = READ_DATA(pState, 16, GLfloat);
	GLfloat y = READ_DATA(pState, 20, GLfloat);
	GLfloat z = READ_DATA(pState, 24, GLfloat);
	GLfloat w = READ_DATA(pState, 28, GLfloat);
	pState->pDispatchTbl->ProgramLocalParameter4fARB(target, index, x, y, z, w);
}

static void crUnpackExtendProgramParameter4dNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 48);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLdouble x = READ_DOUBLE(pState, 16);
	GLdouble y = READ_DOUBLE(pState, 24);
	GLdouble z = READ_DOUBLE(pState, 32);
	GLdouble w = READ_DOUBLE(pState, 40);
	pState->pDispatchTbl->ProgramParameter4dNV(target, index, x, y, z, w);
}

static void crUnpackExtendProgramParameter4fNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint index = READ_DATA(pState, 12, GLuint);
	GLfloat x = READ_DATA(pState, 16, GLfloat);
	GLfloat y = READ_DATA(pState, 20, GLfloat);
	GLfloat z = READ_DATA(pState, 24, GLfloat);
	GLfloat w = READ_DATA(pState, 28, GLfloat);
	pState->pDispatchTbl->ProgramParameter4fNV(target, index, x, y, z, w);
}

static void crUnpackExtendPushAttrib(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLbitfield mask = READ_DATA(pState, 8, GLbitfield);
	pState->pDispatchTbl->PushAttrib(mask);
}

static void crUnpackExtendPushClientAttrib(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLbitfield mask = READ_DATA(pState, 8, GLbitfield);
	pState->pDispatchTbl->PushClientAttrib(mask);
}

static void crUnpackExtendReadBuffer(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLenum mode = READ_DATA(pState, 8, GLenum);
	pState->pDispatchTbl->ReadBuffer(mode);
}

static void crUnpackExtendRenderMode(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLenum mode = READ_DATA(pState, 8, GLenum);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->RenderMode(mode);
}

static void crUnpackExtendRenderbufferStorageEXT(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLenum internalformat = READ_DATA(pState, 12, GLenum);
	GLsizei width = READ_DATA(pState, 16, GLsizei);
	GLsizei height = READ_DATA(pState, 20, GLsizei);
	pState->pDispatchTbl->RenderbufferStorageEXT(target, internalformat, width, height);
}

static void crUnpackExtendSampleCoverageARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLclampf value = READ_DATA(pState, 8, GLclampf);
	GLboolean invert = READ_DATA(pState, 12, GLboolean);
	pState->pDispatchTbl->SampleCoverageARB(value, invert);
}

static void crUnpackExtendSemaphoreCreateCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLuint name = READ_DATA(pState, 8, GLuint);
	GLuint count = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->SemaphoreCreateCR(name, count);
}

static void crUnpackExtendSemaphoreDestroyCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint name = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->SemaphoreDestroyCR(name);
}

static void crUnpackExtendSemaphorePCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint name = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->SemaphorePCR(name);
}

static void crUnpackExtendSemaphoreVCR(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint name = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->SemaphoreVCR(name);
}

static void crUnpackExtendSetFenceNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLuint fence = READ_DATA(pState, 8, GLuint);
	GLenum condition = READ_DATA(pState, 12, GLenum);
	pState->pDispatchTbl->SetFenceNV(fence, condition);
}

static void crUnpackExtendStencilFuncSeparate(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLenum frontfunc = READ_DATA(pState, 8, GLenum);
	GLenum backfunc = READ_DATA(pState, 12, GLenum);
	GLint ref = READ_DATA(pState, 16, GLint);
	GLuint mask = READ_DATA(pState, 20, GLuint);
	pState->pDispatchTbl->StencilFuncSeparate(frontfunc, backfunc, ref, mask);
}

static void crUnpackExtendStencilMaskSeparate(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLenum face = READ_DATA(pState, 8, GLenum);
	GLuint mask = READ_DATA(pState, 12, GLuint);
	pState->pDispatchTbl->StencilMaskSeparate(face, mask);
}

static void crUnpackExtendStencilOpSeparate(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLenum face = READ_DATA(pState, 8, GLenum);
	GLenum fail = READ_DATA(pState, 12, GLenum);
	GLenum zfail = READ_DATA(pState, 16, GLenum);
	GLenum zpass = READ_DATA(pState, 20, GLenum);
	pState->pDispatchTbl->StencilOpSeparate(face, fail, zfail, zpass);
}

static void crUnpackExtendSwapBuffers(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLint window = READ_DATA(pState, 8, GLint);
	GLint flags = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->SwapBuffers(window, flags);
}

static void crUnpackExtendTestFenceNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLuint fence = READ_DATA(pState, 8, GLuint);
	SET_RETURN_PTR(pState, 12);
	SET_WRITEBACK_PTR(pState, 20);
	(void) pState->pDispatchTbl->TestFenceNV(fence);
}

static void crUnpackExtendTrackMatrixNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLenum target = READ_DATA(pState, 8, GLenum);
	GLuint address = READ_DATA(pState, 12, GLuint);
	GLenum matrix = READ_DATA(pState, 16, GLenum);
	GLenum transform = READ_DATA(pState, 20, GLenum);
	pState->pDispatchTbl->TrackMatrixNV(target, address, matrix, transform);
}

static void crUnpackExtendUniform1f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLint location = READ_DATA(pState, 8, GLint);
	GLfloat v0 = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->Uniform1f(location, v0);
}

static void crUnpackExtendUniform1i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLint location = READ_DATA(pState, 8, GLint);
	GLint v0 = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->Uniform1i(location, v0);
}

static void crUnpackExtendUniform2f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLint location = READ_DATA(pState, 8, GLint);
	GLfloat v0 = READ_DATA(pState, 12, GLfloat);
	GLfloat v1 = READ_DATA(pState, 16, GLfloat);
	pState->pDispatchTbl->Uniform2f(location, v0, v1);
}

static void crUnpackExtendUniform2i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLint location = READ_DATA(pState, 8, GLint);
	GLint v0 = READ_DATA(pState, 12, GLint);
	GLint v1 = READ_DATA(pState, 16, GLint);
	pState->pDispatchTbl->Uniform2i(location, v0, v1);
}

static void crUnpackExtendUniform3f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLint location = READ_DATA(pState, 8, GLint);
	GLfloat v0 = READ_DATA(pState, 12, GLfloat);
	GLfloat v1 = READ_DATA(pState, 16, GLfloat);
	GLfloat v2 = READ_DATA(pState, 20, GLfloat);
	pState->pDispatchTbl->Uniform3f(location, v0, v1, v2);
}

static void crUnpackExtendUniform3i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLint location = READ_DATA(pState, 8, GLint);
	GLint v0 = READ_DATA(pState, 12, GLint);
	GLint v1 = READ_DATA(pState, 16, GLint);
	GLint v2 = READ_DATA(pState, 20, GLint);
	pState->pDispatchTbl->Uniform3i(location, v0, v1, v2);
}

static void crUnpackExtendUniform4f(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLint location = READ_DATA(pState, 8, GLint);
	GLfloat v0 = READ_DATA(pState, 12, GLfloat);
	GLfloat v1 = READ_DATA(pState, 16, GLfloat);
	GLfloat v2 = READ_DATA(pState, 20, GLfloat);
	GLfloat v3 = READ_DATA(pState, 24, GLfloat);
	pState->pDispatchTbl->Uniform4f(location, v0, v1, v2, v3);
}

static void crUnpackExtendUniform4i(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 28);
	GLint location = READ_DATA(pState, 8, GLint);
	GLint v0 = READ_DATA(pState, 12, GLint);
	GLint v1 = READ_DATA(pState, 16, GLint);
	GLint v2 = READ_DATA(pState, 20, GLint);
	GLint v3 = READ_DATA(pState, 24, GLint);
	pState->pDispatchTbl->Uniform4i(location, v0, v1, v2, v3);
}

static void crUnpackExtendUseProgram(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint program = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->UseProgram(program);
}

static void crUnpackExtendValidateProgram(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLuint program = READ_DATA(pState, 8, GLuint);
	pState->pDispatchTbl->ValidateProgram(program);
}

static void crUnpackExtendVertexArrayRangeNV(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLsizei length = READ_DATA(pState, 8, GLsizei);
	crError( "VertexArrayRangeNV needs to be special cased!" );
	pState->pDispatchTbl->VertexArrayRangeNV(length, NULL, 0 /*fRealPtr*/);
}

static void crUnpackExtendWindowDestroy(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLint window = READ_DATA(pState, 8, GLint);
	pState->pDispatchTbl->WindowDestroy(window);
}

static void crUnpackExtendWindowPos2dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 24);
	GLdouble x = READ_DOUBLE(pState, 8);
	GLdouble y = READ_DOUBLE(pState, 16);
	pState->pDispatchTbl->WindowPos2dARB(x, y);
}

static void crUnpackExtendWindowPos2dvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	crError( "WindowPos2dvARB needs to be special cased!" );
	pState->pDispatchTbl->WindowPos2dvARB(NULL);
}

static void crUnpackExtendWindowPos2fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLfloat x = READ_DATA(pState, 8, GLfloat);
	GLfloat y = READ_DATA(pState, 12, GLfloat);
	pState->pDispatchTbl->WindowPos2fARB(x, y);
}

static void crUnpackExtendWindowPos2fvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	crError( "WindowPos2fvARB needs to be special cased!" );
	pState->pDispatchTbl->WindowPos2fvARB(NULL);
}

static void crUnpackExtendWindowPos2iARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLint x = READ_DATA(pState, 8, GLint);
	GLint y = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->WindowPos2iARB(x, y);
}

static void crUnpackExtendWindowPos2ivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	crError( "WindowPos2ivARB needs to be special cased!" );
	pState->pDispatchTbl->WindowPos2ivARB(NULL);
}

static void crUnpackExtendWindowPos2sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 12);
	GLshort x = READ_DATA(pState, 8, GLshort);
	GLshort y = READ_DATA(pState, 10, GLshort);
	pState->pDispatchTbl->WindowPos2sARB(x, y);
}

static void crUnpackExtendWindowPos2svARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	crError( "WindowPos2svARB needs to be special cased!" );
	pState->pDispatchTbl->WindowPos2svARB(NULL);
}

static void crUnpackExtendWindowPos3dARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 32);
	GLdouble x = READ_DOUBLE(pState, 8);
	GLdouble y = READ_DOUBLE(pState, 16);
	GLdouble z = READ_DOUBLE(pState, 24);
	pState->pDispatchTbl->WindowPos3dARB(x, y, z);
}

static void crUnpackExtendWindowPos3dvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	crError( "WindowPos3dvARB needs to be special cased!" );
	pState->pDispatchTbl->WindowPos3dvARB(NULL);
}

static void crUnpackExtendWindowPos3fARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLfloat x = READ_DATA(pState, 8, GLfloat);
	GLfloat y = READ_DATA(pState, 12, GLfloat);
	GLfloat z = READ_DATA(pState, 16, GLfloat);
	pState->pDispatchTbl->WindowPos3fARB(x, y, z);
}

static void crUnpackExtendWindowPos3fvARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	crError( "WindowPos3fvARB needs to be special cased!" );
	pState->pDispatchTbl->WindowPos3fvARB(NULL);
}

static void crUnpackExtendWindowPos3iARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLint x = READ_DATA(pState, 8, GLint);
	GLint y = READ_DATA(pState, 12, GLint);
	GLint z = READ_DATA(pState, 16, GLint);
	pState->pDispatchTbl->WindowPos3iARB(x, y, z);
}

static void crUnpackExtendWindowPos3ivARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	crError( "WindowPos3ivARB needs to be special cased!" );
	pState->pDispatchTbl->WindowPos3ivARB(NULL);
}

static void crUnpackExtendWindowPos3sARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLshort x = READ_DATA(pState, 8, GLshort);
	GLshort y = READ_DATA(pState, 10, GLshort);
	GLshort z = READ_DATA(pState, 12, GLshort);
	pState->pDispatchTbl->WindowPos3sARB(x, y, z);
}

static void crUnpackExtendWindowPos3svARB(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	crError( "WindowPos3svARB needs to be special cased!" );
	pState->pDispatchTbl->WindowPos3svARB(NULL);
}

static void crUnpackExtendWindowPosition(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLint window = READ_DATA(pState, 8, GLint);
	GLint x = READ_DATA(pState, 12, GLint);
	GLint y = READ_DATA(pState, 16, GLint);
	pState->pDispatchTbl->WindowPosition(window, x, y);
}

static void crUnpackExtendWindowShow(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 16);
	GLint window = READ_DATA(pState, 8, GLint);
	GLint flag = READ_DATA(pState, 12, GLint);
	pState->pDispatchTbl->WindowShow(window, flag);
}

static void crUnpackExtendWindowSize(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC(pState, 20);
	GLint window = READ_DATA(pState, 8, GLint);
	GLint w = READ_DATA(pState, 12, GLint);
	GLint h = READ_DATA(pState, 16, GLint);
	pState->pDispatchTbl->WindowSize(window, w, h);
}

static void crUnpackExtend(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC_LAST(pState, 4, GLenum);
	GLenum extend_opcode = READ_DATA(pState, 4, GLenum);

#ifdef CR_UNPACK_DEBUG_PREV_OPCODES
	g_VBoxDbgCrPrevExtendOpcode = extend_opcode;
#endif

	/*crDebug("Unpacking extended opcode \%d", extend_opcode);*/
	switch( extend_opcode )
	{
		case CR_ACCUM_EXTEND_OPCODE:
			crUnpackExtendAccum(pState);
			break;
		case CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE:
			crUnpackExtendActiveStencilFaceEXT(pState);
			break;
		case CR_ACTIVETEXTUREARB_EXTEND_OPCODE:
			crUnpackExtendActiveTextureARB(pState);
			break;
		case CR_AREPROGRAMSRESIDENTNV_EXTEND_OPCODE:
			crUnpackExtendAreProgramsResidentNV(pState);
			break;
		case CR_ARETEXTURESRESIDENT_EXTEND_OPCODE:
			crUnpackExtendAreTexturesResident(pState);
			break;
		case CR_ATTACHSHADER_EXTEND_OPCODE:
			crUnpackExtendAttachShader(pState);
			break;
		case CR_BARRIERCREATECR_EXTEND_OPCODE:
			crUnpackExtendBarrierCreateCR(pState);
			break;
		case CR_BARRIERDESTROYCR_EXTEND_OPCODE:
			crUnpackExtendBarrierDestroyCR(pState);
			break;
		case CR_BARRIEREXECCR_EXTEND_OPCODE:
			crUnpackExtendBarrierExecCR(pState);
			break;
		case CR_BEGINQUERYARB_EXTEND_OPCODE:
			crUnpackExtendBeginQueryARB(pState);
			break;
		case CR_BINDATTRIBLOCATION_EXTEND_OPCODE:
			crUnpackExtendBindAttribLocation(pState);
			break;
		case CR_BINDBUFFERARB_EXTEND_OPCODE:
			crUnpackExtendBindBufferARB(pState);
			break;
		case CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendBindFramebufferEXT(pState);
			break;
		case CR_BINDPROGRAMARB_EXTEND_OPCODE:
			crUnpackExtendBindProgramARB(pState);
			break;
		case CR_BINDPROGRAMNV_EXTEND_OPCODE:
			crUnpackExtendBindProgramNV(pState);
			break;
		case CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendBindRenderbufferEXT(pState);
			break;
		case CR_BLENDCOLOREXT_EXTEND_OPCODE:
			crUnpackExtendBlendColorEXT(pState);
			break;
		case CR_BLENDEQUATIONEXT_EXTEND_OPCODE:
			crUnpackExtendBlendEquationEXT(pState);
			break;
		case CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE:
			crUnpackExtendBlendEquationSeparate(pState);
			break;
		case CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE:
			crUnpackExtendBlendFuncSeparateEXT(pState);
			break;
		case CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendBlitFramebufferEXT(pState);
			break;
		case CR_BUFFERDATAARB_EXTEND_OPCODE:
			crUnpackExtendBufferDataARB(pState);
			break;
		case CR_BUFFERSUBDATAARB_EXTEND_OPCODE:
			crUnpackExtendBufferSubDataARB(pState);
			break;
		case CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE:
			crUnpackExtendCheckFramebufferStatusEXT(pState);
			break;
		case CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE:
			crUnpackExtendChromiumParameterfCR(pState);
			break;
		case CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE:
			crUnpackExtendChromiumParameteriCR(pState);
			break;
		case CR_CHROMIUMPARAMETERVCR_EXTEND_OPCODE:
			crUnpackExtendChromiumParametervCR(pState);
			break;
		case CR_CLEARACCUM_EXTEND_OPCODE:
			crUnpackExtendClearAccum(pState);
			break;
		case CR_CLEARCOLOR_EXTEND_OPCODE:
			crUnpackExtendClearColor(pState);
			break;
		case CR_CLEARDEPTH_EXTEND_OPCODE:
			crUnpackExtendClearDepth(pState);
			break;
		case CR_CLEARINDEX_EXTEND_OPCODE:
			crUnpackExtendClearIndex(pState);
			break;
		case CR_CLEARSTENCIL_EXTEND_OPCODE:
			crUnpackExtendClearStencil(pState);
			break;
		case CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE:
			crUnpackExtendClientActiveTextureARB(pState);
			break;
		case CR_COLORPOINTER_EXTEND_OPCODE:
			crUnpackExtendColorPointer(pState);
			break;
		case CR_COMBINERINPUTNV_EXTEND_OPCODE:
			crUnpackExtendCombinerInputNV(pState);
			break;
		case CR_COMBINEROUTPUTNV_EXTEND_OPCODE:
			crUnpackExtendCombinerOutputNV(pState);
			break;
		case CR_COMBINERPARAMETERFNV_EXTEND_OPCODE:
			crUnpackExtendCombinerParameterfNV(pState);
			break;
		case CR_COMBINERPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendCombinerParameterfvNV(pState);
			break;
		case CR_COMBINERPARAMETERINV_EXTEND_OPCODE:
			crUnpackExtendCombinerParameteriNV(pState);
			break;
		case CR_COMBINERPARAMETERIVNV_EXTEND_OPCODE:
			crUnpackExtendCombinerParameterivNV(pState);
			break;
		case CR_COMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendCombinerStageParameterfvNV(pState);
			break;
		case CR_COMPILESHADER_EXTEND_OPCODE:
			crUnpackExtendCompileShader(pState);
			break;
		case CR_COMPRESSEDTEXIMAGE1DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexImage1DARB(pState);
			break;
		case CR_COMPRESSEDTEXIMAGE2DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexImage2DARB(pState);
			break;
		case CR_COMPRESSEDTEXIMAGE3DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexImage3DARB(pState);
			break;
		case CR_COMPRESSEDTEXSUBIMAGE1DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexSubImage1DARB(pState);
			break;
		case CR_COMPRESSEDTEXSUBIMAGE2DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexSubImage2DARB(pState);
			break;
		case CR_COMPRESSEDTEXSUBIMAGE3DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexSubImage3DARB(pState);
			break;
		case CR_CREATECONTEXT_EXTEND_OPCODE:
			crUnpackExtendCreateContext(pState);
			break;
		case CR_CREATEPROGRAM_EXTEND_OPCODE:
			crUnpackExtendCreateProgram(pState);
			break;
		case CR_CREATESHADER_EXTEND_OPCODE:
			crUnpackExtendCreateShader(pState);
			break;
		case CR_DELETEBUFFERSARB_EXTEND_OPCODE:
			crUnpackExtendDeleteBuffersARB(pState);
			break;
		case CR_DELETEFENCESNV_EXTEND_OPCODE:
			crUnpackExtendDeleteFencesNV(pState);
			break;
		case CR_DELETEFRAMEBUFFERSEXT_EXTEND_OPCODE:
			crUnpackExtendDeleteFramebuffersEXT(pState);
			break;
		case CR_DELETELISTS_EXTEND_OPCODE:
			crUnpackExtendDeleteLists(pState);
			break;
		case CR_DELETEOBJECTARB_EXTEND_OPCODE:
			crUnpackExtendDeleteObjectARB(pState);
			break;
		case CR_DELETEPROGRAM_EXTEND_OPCODE:
			crUnpackExtendDeleteProgram(pState);
			break;
		case CR_DELETEPROGRAMSARB_EXTEND_OPCODE:
			crUnpackExtendDeleteProgramsARB(pState);
			break;
		case CR_DELETEQUERIESARB_EXTEND_OPCODE:
			crUnpackExtendDeleteQueriesARB(pState);
			break;
		case CR_DELETERENDERBUFFERSEXT_EXTEND_OPCODE:
			crUnpackExtendDeleteRenderbuffersEXT(pState);
			break;
		case CR_DELETESHADER_EXTEND_OPCODE:
			crUnpackExtendDeleteShader(pState);
			break;
		case CR_DESTROYCONTEXT_EXTEND_OPCODE:
			crUnpackExtendDestroyContext(pState);
			break;
		case CR_DETACHSHADER_EXTEND_OPCODE:
			crUnpackExtendDetachShader(pState);
			break;
		case CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE:
			crUnpackExtendDisableVertexAttribArrayARB(pState);
			break;
		case CR_DRAWBUFFER_EXTEND_OPCODE:
			crUnpackExtendDrawBuffer(pState);
			break;
		case CR_DRAWBUFFERS_EXTEND_OPCODE:
			crUnpackExtendDrawBuffers(pState);
			break;
		case CR_DRAWELEMENTS_EXTEND_OPCODE:
			crUnpackExtendDrawElements(pState);
			break;
		case CR_DRAWRANGEELEMENTS_EXTEND_OPCODE:
			crUnpackExtendDrawRangeElements(pState);
			break;
		case CR_EDGEFLAGPOINTER_EXTEND_OPCODE:
			crUnpackExtendEdgeFlagPointer(pState);
			break;
		case CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE:
			crUnpackExtendEnableVertexAttribArrayARB(pState);
			break;
		case CR_ENDLIST_EXTEND_OPCODE:
			crUnpackExtendEndList(pState);
			break;
		case CR_ENDQUERYARB_EXTEND_OPCODE:
			crUnpackExtendEndQueryARB(pState);
			break;
		case CR_EXECUTEPROGRAMNV_EXTEND_OPCODE:
			crUnpackExtendExecuteProgramNV(pState);
			break;
		case CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE:
			crUnpackExtendFinalCombinerInputNV(pState);
			break;
		case CR_FINISHFENCENV_EXTEND_OPCODE:
			crUnpackExtendFinishFenceNV(pState);
			break;
		case CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE:
			crUnpackExtendFlushVertexArrayRangeNV(pState);
			break;
		case CR_FOGCOORDPOINTEREXT_EXTEND_OPCODE:
			crUnpackExtendFogCoordPointerEXT(pState);
			break;
		case CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendFramebufferRenderbufferEXT(pState);
			break;
		case CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE:
			crUnpackExtendFramebufferTexture1DEXT(pState);
			break;
		case CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE:
			crUnpackExtendFramebufferTexture2DEXT(pState);
			break;
		case CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE:
			crUnpackExtendFramebufferTexture3DEXT(pState);
			break;
		case CR_GENBUFFERSARB_EXTEND_OPCODE:
			crUnpackExtendGenBuffersARB(pState);
			break;
		case CR_GENFENCESNV_EXTEND_OPCODE:
			crUnpackExtendGenFencesNV(pState);
			break;
		case CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE:
			crUnpackExtendGenFramebuffersEXT(pState);
			break;
		case CR_GENLISTS_EXTEND_OPCODE:
			crUnpackExtendGenLists(pState);
			break;
		case CR_GENPROGRAMSARB_EXTEND_OPCODE:
			crUnpackExtendGenProgramsARB(pState);
			break;
		case CR_GENPROGRAMSNV_EXTEND_OPCODE:
			crUnpackExtendGenProgramsNV(pState);
			break;
		case CR_GENQUERIESARB_EXTEND_OPCODE:
			crUnpackExtendGenQueriesARB(pState);
			break;
		case CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE:
			crUnpackExtendGenRenderbuffersEXT(pState);
			break;
		case CR_GENTEXTURES_EXTEND_OPCODE:
			crUnpackExtendGenTextures(pState);
			break;
		case CR_GENERATEMIPMAPEXT_EXTEND_OPCODE:
			crUnpackExtendGenerateMipmapEXT(pState);
			break;
		case CR_GETACTIVEATTRIB_EXTEND_OPCODE:
			crUnpackExtendGetActiveAttrib(pState);
			break;
		case CR_GETACTIVEUNIFORM_EXTEND_OPCODE:
			crUnpackExtendGetActiveUniform(pState);
			break;
		case CR_GETATTACHEDOBJECTSARB_EXTEND_OPCODE:
			crUnpackExtendGetAttachedObjectsARB(pState);
			break;
		case CR_GETATTACHEDSHADERS_EXTEND_OPCODE:
			crUnpackExtendGetAttachedShaders(pState);
			break;
		case CR_GETATTRIBLOCATION_EXTEND_OPCODE:
			crUnpackExtendGetAttribLocation(pState);
			break;
		case CR_GETATTRIBSLOCATIONS_EXTEND_OPCODE:
			crUnpackExtendGetAttribsLocations(pState);
			break;
		case CR_GETBOOLEANV_EXTEND_OPCODE:
			crUnpackExtendGetBooleanv(pState);
			break;
		case CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE:
			crUnpackExtendGetBufferParameterivARB(pState);
			break;
		case CR_GETBUFFERSUBDATAARB_EXTEND_OPCODE:
			crUnpackExtendGetBufferSubDataARB(pState);
			break;
		case CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE:
			crUnpackExtendGetChromiumParametervCR(pState);
			break;
		case CR_GETCLIPPLANE_EXTEND_OPCODE:
			crUnpackExtendGetClipPlane(pState);
			break;
		case CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerInputParameterfvNV(pState);
			break;
		case CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerInputParameterivNV(pState);
			break;
		case CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerOutputParameterfvNV(pState);
			break;
		case CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerOutputParameterivNV(pState);
			break;
		case CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerStageParameterfvNV(pState);
			break;
		case CR_GETCOMPRESSEDTEXIMAGEARB_EXTEND_OPCODE:
			crUnpackExtendGetCompressedTexImageARB(pState);
			break;
		case CR_GETDOUBLEV_EXTEND_OPCODE:
			crUnpackExtendGetDoublev(pState);
			break;
		case CR_GETERROR_EXTEND_OPCODE:
			crUnpackExtendGetError(pState);
			break;
		case CR_GETFENCEIVNV_EXTEND_OPCODE:
			crUnpackExtendGetFenceivNV(pState);
			break;
		case CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetFinalCombinerInputParameterfvNV(pState);
			break;
		case CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE:
			crUnpackExtendGetFinalCombinerInputParameterivNV(pState);
			break;
		case CR_GETFLOATV_EXTEND_OPCODE:
			crUnpackExtendGetFloatv(pState);
			break;
		case CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE:
			crUnpackExtendGetFramebufferAttachmentParameterivEXT(pState);
			break;
		case CR_GETHANDLEARB_EXTEND_OPCODE:
			crUnpackExtendGetHandleARB(pState);
			break;
		case CR_GETINFOLOGARB_EXTEND_OPCODE:
			crUnpackExtendGetInfoLogARB(pState);
			break;
		case CR_GETINTEGERV_EXTEND_OPCODE:
			crUnpackExtendGetIntegerv(pState);
			break;
		case CR_GETLIGHTFV_EXTEND_OPCODE:
			crUnpackExtendGetLightfv(pState);
			break;
		case CR_GETLIGHTIV_EXTEND_OPCODE:
			crUnpackExtendGetLightiv(pState);
			break;
		case CR_GETMAPDV_EXTEND_OPCODE:
			crUnpackExtendGetMapdv(pState);
			break;
		case CR_GETMAPFV_EXTEND_OPCODE:
			crUnpackExtendGetMapfv(pState);
			break;
		case CR_GETMAPIV_EXTEND_OPCODE:
			crUnpackExtendGetMapiv(pState);
			break;
		case CR_GETMATERIALFV_EXTEND_OPCODE:
			crUnpackExtendGetMaterialfv(pState);
			break;
		case CR_GETMATERIALIV_EXTEND_OPCODE:
			crUnpackExtendGetMaterialiv(pState);
			break;
		case CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE:
			crUnpackExtendGetObjectParameterfvARB(pState);
			break;
		case CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE:
			crUnpackExtendGetObjectParameterivARB(pState);
			break;
		case CR_GETPIXELMAPFV_EXTEND_OPCODE:
			crUnpackExtendGetPixelMapfv(pState);
			break;
		case CR_GETPIXELMAPUIV_EXTEND_OPCODE:
			crUnpackExtendGetPixelMapuiv(pState);
			break;
		case CR_GETPIXELMAPUSV_EXTEND_OPCODE:
			crUnpackExtendGetPixelMapusv(pState);
			break;
		case CR_GETPOINTERV_EXTEND_OPCODE:
			crUnpackExtendGetPointerv(pState);
			break;
		case CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE:
			crUnpackExtendGetPolygonStipple(pState);
			break;
		case CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramEnvParameterdvARB(pState);
			break;
		case CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramEnvParameterfvARB(pState);
			break;
		case CR_GETPROGRAMINFOLOG_EXTEND_OPCODE:
			crUnpackExtendGetProgramInfoLog(pState);
			break;
		case CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramLocalParameterdvARB(pState);
			break;
		case CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramLocalParameterfvARB(pState);
			break;
		case CR_GETPROGRAMNAMEDPARAMETERDVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramNamedParameterdvNV(pState);
			break;
		case CR_GETPROGRAMNAMEDPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramNamedParameterfvNV(pState);
			break;
		case CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramParameterdvNV(pState);
			break;
		case CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramParameterfvNV(pState);
			break;
		case CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramStringARB(pState);
			break;
		case CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramStringNV(pState);
			break;
		case CR_GETPROGRAMIV_EXTEND_OPCODE:
			crUnpackExtendGetProgramiv(pState);
			break;
		case CR_GETPROGRAMIVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramivARB(pState);
			break;
		case CR_GETPROGRAMIVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramivNV(pState);
			break;
		case CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE:
			crUnpackExtendGetQueryObjectivARB(pState);
			break;
		case CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE:
			crUnpackExtendGetQueryObjectuivARB(pState);
			break;
		case CR_GETQUERYIVARB_EXTEND_OPCODE:
			crUnpackExtendGetQueryivARB(pState);
			break;
		case CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE:
			crUnpackExtendGetRenderbufferParameterivEXT(pState);
			break;
		case CR_GETSHADERINFOLOG_EXTEND_OPCODE:
			crUnpackExtendGetShaderInfoLog(pState);
			break;
		case CR_GETSHADERSOURCE_EXTEND_OPCODE:
			crUnpackExtendGetShaderSource(pState);
			break;
		case CR_GETSHADERIV_EXTEND_OPCODE:
			crUnpackExtendGetShaderiv(pState);
			break;
		case CR_GETSTRING_EXTEND_OPCODE:
			crUnpackExtendGetString(pState);
			break;
		case CR_GETTEXENVFV_EXTEND_OPCODE:
			crUnpackExtendGetTexEnvfv(pState);
			break;
		case CR_GETTEXENVIV_EXTEND_OPCODE:
			crUnpackExtendGetTexEnviv(pState);
			break;
		case CR_GETTEXGENDV_EXTEND_OPCODE:
			crUnpackExtendGetTexGendv(pState);
			break;
		case CR_GETTEXGENFV_EXTEND_OPCODE:
			crUnpackExtendGetTexGenfv(pState);
			break;
		case CR_GETTEXGENIV_EXTEND_OPCODE:
			crUnpackExtendGetTexGeniv(pState);
			break;
		case CR_GETTEXIMAGE_EXTEND_OPCODE:
			crUnpackExtendGetTexImage(pState);
			break;
		case CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE:
			crUnpackExtendGetTexLevelParameterfv(pState);
			break;
		case CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE:
			crUnpackExtendGetTexLevelParameteriv(pState);
			break;
		case CR_GETTEXPARAMETERFV_EXTEND_OPCODE:
			crUnpackExtendGetTexParameterfv(pState);
			break;
		case CR_GETTEXPARAMETERIV_EXTEND_OPCODE:
			crUnpackExtendGetTexParameteriv(pState);
			break;
		case CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE:
			crUnpackExtendGetTrackMatrixivNV(pState);
			break;
		case CR_GETUNIFORMLOCATION_EXTEND_OPCODE:
			crUnpackExtendGetUniformLocation(pState);
			break;
		case CR_GETUNIFORMFV_EXTEND_OPCODE:
			crUnpackExtendGetUniformfv(pState);
			break;
		case CR_GETUNIFORMIV_EXTEND_OPCODE:
			crUnpackExtendGetUniformiv(pState);
			break;
		case CR_GETUNIFORMSLOCATIONS_EXTEND_OPCODE:
			crUnpackExtendGetUniformsLocations(pState);
			break;
		case CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribPointervARB(pState);
			break;
		case CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribPointervNV(pState);
			break;
		case CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribdvARB(pState);
			break;
		case CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribdvNV(pState);
			break;
		case CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribfvARB(pState);
			break;
		case CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribfvNV(pState);
			break;
		case CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribivARB(pState);
			break;
		case CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribivNV(pState);
			break;
		case CR_HINT_EXTEND_OPCODE:
			crUnpackExtendHint(pState);
			break;
		case CR_INDEXPOINTER_EXTEND_OPCODE:
			crUnpackExtendIndexPointer(pState);
			break;
		case CR_INTERLEAVEDARRAYS_EXTEND_OPCODE:
			crUnpackExtendInterleavedArrays(pState);
			break;
		case CR_ISBUFFERARB_EXTEND_OPCODE:
			crUnpackExtendIsBufferARB(pState);
			break;
		case CR_ISENABLED_EXTEND_OPCODE:
			crUnpackExtendIsEnabled(pState);
			break;
		case CR_ISFENCENV_EXTEND_OPCODE:
			crUnpackExtendIsFenceNV(pState);
			break;
		case CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendIsFramebufferEXT(pState);
			break;
		case CR_ISLIST_EXTEND_OPCODE:
			crUnpackExtendIsList(pState);
			break;
		case CR_ISPROGRAM_EXTEND_OPCODE:
			crUnpackExtendIsProgram(pState);
			break;
		case CR_ISPROGRAMARB_EXTEND_OPCODE:
			crUnpackExtendIsProgramARB(pState);
			break;
		case CR_ISQUERYARB_EXTEND_OPCODE:
			crUnpackExtendIsQueryARB(pState);
			break;
		case CR_ISRENDERBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendIsRenderbufferEXT(pState);
			break;
		case CR_ISSHADER_EXTEND_OPCODE:
			crUnpackExtendIsShader(pState);
			break;
		case CR_ISTEXTURE_EXTEND_OPCODE:
			crUnpackExtendIsTexture(pState);
			break;
		case CR_LINKPROGRAM_EXTEND_OPCODE:
			crUnpackExtendLinkProgram(pState);
			break;
		case CR_LISTBASE_EXTEND_OPCODE:
			crUnpackExtendListBase(pState);
			break;
		case CR_LOADPROGRAMNV_EXTEND_OPCODE:
			crUnpackExtendLoadProgramNV(pState);
			break;
		case CR_LOADTRANSPOSEMATRIXDARB_EXTEND_OPCODE:
			crUnpackExtendLoadTransposeMatrixdARB(pState);
			break;
		case CR_LOADTRANSPOSEMATRIXFARB_EXTEND_OPCODE:
			crUnpackExtendLoadTransposeMatrixfARB(pState);
			break;
		case CR_LOCKARRAYSEXT_EXTEND_OPCODE:
			crUnpackExtendLockArraysEXT(pState);
			break;
		case CR_LOGICOP_EXTEND_OPCODE:
			crUnpackExtendLogicOp(pState);
			break;
		case CR_MAKECURRENT_EXTEND_OPCODE:
			crUnpackExtendMakeCurrent(pState);
			break;
		case CR_MULTTRANSPOSEMATRIXDARB_EXTEND_OPCODE:
			crUnpackExtendMultTransposeMatrixdARB(pState);
			break;
		case CR_MULTTRANSPOSEMATRIXFARB_EXTEND_OPCODE:
			crUnpackExtendMultTransposeMatrixfARB(pState);
			break;
		case CR_NEWLIST_EXTEND_OPCODE:
			crUnpackExtendNewList(pState);
			break;
		case CR_NORMALPOINTER_EXTEND_OPCODE:
			crUnpackExtendNormalPointer(pState);
			break;
		case CR_POINTPARAMETERFARB_EXTEND_OPCODE:
			crUnpackExtendPointParameterfARB(pState);
			break;
		case CR_POINTPARAMETERFVARB_EXTEND_OPCODE:
			crUnpackExtendPointParameterfvARB(pState);
			break;
		case CR_POINTPARAMETERI_EXTEND_OPCODE:
			crUnpackExtendPointParameteri(pState);
			break;
		case CR_POINTPARAMETERIV_EXTEND_OPCODE:
			crUnpackExtendPointParameteriv(pState);
			break;
		case CR_POPATTRIB_EXTEND_OPCODE:
			crUnpackExtendPopAttrib(pState);
			break;
		case CR_POPCLIENTATTRIB_EXTEND_OPCODE:
			crUnpackExtendPopClientAttrib(pState);
			break;
		case CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE:
			crUnpackExtendProgramEnvParameter4dARB(pState);
			break;
		case CR_PROGRAMENVPARAMETER4DVARB_EXTEND_OPCODE:
			crUnpackExtendProgramEnvParameter4dvARB(pState);
			break;
		case CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE:
			crUnpackExtendProgramEnvParameter4fARB(pState);
			break;
		case CR_PROGRAMENVPARAMETER4FVARB_EXTEND_OPCODE:
			crUnpackExtendProgramEnvParameter4fvARB(pState);
			break;
		case CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE:
			crUnpackExtendProgramLocalParameter4dARB(pState);
			break;
		case CR_PROGRAMLOCALPARAMETER4DVARB_EXTEND_OPCODE:
			crUnpackExtendProgramLocalParameter4dvARB(pState);
			break;
		case CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE:
			crUnpackExtendProgramLocalParameter4fARB(pState);
			break;
		case CR_PROGRAMLOCALPARAMETER4FVARB_EXTEND_OPCODE:
			crUnpackExtendProgramLocalParameter4fvARB(pState);
			break;
		case CR_PROGRAMNAMEDPARAMETER4DNV_EXTEND_OPCODE:
			crUnpackExtendProgramNamedParameter4dNV(pState);
			break;
		case CR_PROGRAMNAMEDPARAMETER4DVNV_EXTEND_OPCODE:
			crUnpackExtendProgramNamedParameter4dvNV(pState);
			break;
		case CR_PROGRAMNAMEDPARAMETER4FNV_EXTEND_OPCODE:
			crUnpackExtendProgramNamedParameter4fNV(pState);
			break;
		case CR_PROGRAMNAMEDPARAMETER4FVNV_EXTEND_OPCODE:
			crUnpackExtendProgramNamedParameter4fvNV(pState);
			break;
		case CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameter4dNV(pState);
			break;
		case CR_PROGRAMPARAMETER4DVNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameter4dvNV(pState);
			break;
		case CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameter4fNV(pState);
			break;
		case CR_PROGRAMPARAMETER4FVNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameter4fvNV(pState);
			break;
		case CR_PROGRAMPARAMETERS4DVNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameters4dvNV(pState);
			break;
		case CR_PROGRAMPARAMETERS4FVNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameters4fvNV(pState);
			break;
		case CR_PROGRAMSTRINGARB_EXTEND_OPCODE:
			crUnpackExtendProgramStringARB(pState);
			break;
		case CR_PUSHATTRIB_EXTEND_OPCODE:
			crUnpackExtendPushAttrib(pState);
			break;
		case CR_PUSHCLIENTATTRIB_EXTEND_OPCODE:
			crUnpackExtendPushClientAttrib(pState);
			break;
		case CR_READBUFFER_EXTEND_OPCODE:
			crUnpackExtendReadBuffer(pState);
			break;
		case CR_RENDERMODE_EXTEND_OPCODE:
			crUnpackExtendRenderMode(pState);
			break;
		case CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE:
			crUnpackExtendRenderbufferStorageEXT(pState);
			break;
		case CR_REQUESTRESIDENTPROGRAMSNV_EXTEND_OPCODE:
			crUnpackExtendRequestResidentProgramsNV(pState);
			break;
		case CR_SAMPLECOVERAGEARB_EXTEND_OPCODE:
			crUnpackExtendSampleCoverageARB(pState);
			break;
		case CR_SECONDARYCOLORPOINTEREXT_EXTEND_OPCODE:
			crUnpackExtendSecondaryColorPointerEXT(pState);
			break;
		case CR_SEMAPHORECREATECR_EXTEND_OPCODE:
			crUnpackExtendSemaphoreCreateCR(pState);
			break;
		case CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE:
			crUnpackExtendSemaphoreDestroyCR(pState);
			break;
		case CR_SEMAPHOREPCR_EXTEND_OPCODE:
			crUnpackExtendSemaphorePCR(pState);
			break;
		case CR_SEMAPHOREVCR_EXTEND_OPCODE:
			crUnpackExtendSemaphoreVCR(pState);
			break;
		case CR_SETFENCENV_EXTEND_OPCODE:
			crUnpackExtendSetFenceNV(pState);
			break;
		case CR_SHADERSOURCE_EXTEND_OPCODE:
			crUnpackExtendShaderSource(pState);
			break;
		case CR_STENCILFUNCSEPARATE_EXTEND_OPCODE:
			crUnpackExtendStencilFuncSeparate(pState);
			break;
		case CR_STENCILMASKSEPARATE_EXTEND_OPCODE:
			crUnpackExtendStencilMaskSeparate(pState);
			break;
		case CR_STENCILOPSEPARATE_EXTEND_OPCODE:
			crUnpackExtendStencilOpSeparate(pState);
			break;
		case CR_SWAPBUFFERS_EXTEND_OPCODE:
			crUnpackExtendSwapBuffers(pState);
			break;
		case CR_TESTFENCENV_EXTEND_OPCODE:
			crUnpackExtendTestFenceNV(pState);
			break;
		case CR_TEXCOORDPOINTER_EXTEND_OPCODE:
			crUnpackExtendTexCoordPointer(pState);
			break;
		case CR_TRACKMATRIXNV_EXTEND_OPCODE:
			crUnpackExtendTrackMatrixNV(pState);
			break;
		case CR_UNIFORM1F_EXTEND_OPCODE:
			crUnpackExtendUniform1f(pState);
			break;
		case CR_UNIFORM1FV_EXTEND_OPCODE:
			crUnpackExtendUniform1fv(pState);
			break;
		case CR_UNIFORM1I_EXTEND_OPCODE:
			crUnpackExtendUniform1i(pState);
			break;
		case CR_UNIFORM1IV_EXTEND_OPCODE:
			crUnpackExtendUniform1iv(pState);
			break;
		case CR_UNIFORM2F_EXTEND_OPCODE:
			crUnpackExtendUniform2f(pState);
			break;
		case CR_UNIFORM2FV_EXTEND_OPCODE:
			crUnpackExtendUniform2fv(pState);
			break;
		case CR_UNIFORM2I_EXTEND_OPCODE:
			crUnpackExtendUniform2i(pState);
			break;
		case CR_UNIFORM2IV_EXTEND_OPCODE:
			crUnpackExtendUniform2iv(pState);
			break;
		case CR_UNIFORM3F_EXTEND_OPCODE:
			crUnpackExtendUniform3f(pState);
			break;
		case CR_UNIFORM3FV_EXTEND_OPCODE:
			crUnpackExtendUniform3fv(pState);
			break;
		case CR_UNIFORM3I_EXTEND_OPCODE:
			crUnpackExtendUniform3i(pState);
			break;
		case CR_UNIFORM3IV_EXTEND_OPCODE:
			crUnpackExtendUniform3iv(pState);
			break;
		case CR_UNIFORM4F_EXTEND_OPCODE:
			crUnpackExtendUniform4f(pState);
			break;
		case CR_UNIFORM4FV_EXTEND_OPCODE:
			crUnpackExtendUniform4fv(pState);
			break;
		case CR_UNIFORM4I_EXTEND_OPCODE:
			crUnpackExtendUniform4i(pState);
			break;
		case CR_UNIFORM4IV_EXTEND_OPCODE:
			crUnpackExtendUniform4iv(pState);
			break;
		case CR_UNIFORMMATRIX2FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix2fv(pState);
			break;
		case CR_UNIFORMMATRIX2X3FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix2x3fv(pState);
			break;
		case CR_UNIFORMMATRIX2X4FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix2x4fv(pState);
			break;
		case CR_UNIFORMMATRIX3FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix3fv(pState);
			break;
		case CR_UNIFORMMATRIX3X2FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix3x2fv(pState);
			break;
		case CR_UNIFORMMATRIX3X4FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix3x4fv(pState);
			break;
		case CR_UNIFORMMATRIX4FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix4fv(pState);
			break;
		case CR_UNIFORMMATRIX4X2FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix4x2fv(pState);
			break;
		case CR_UNIFORMMATRIX4X3FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix4x3fv(pState);
			break;
		case CR_UNLOCKARRAYSEXT_EXTEND_OPCODE:
			crUnpackExtendUnlockArraysEXT(pState);
			break;
		case CR_USEPROGRAM_EXTEND_OPCODE:
			crUnpackExtendUseProgram(pState);
			break;
		case CR_VBOXTEXPRESENT_EXTEND_OPCODE:
			crUnpackExtendVBoxTexPresent(pState);
			break;
		case CR_VALIDATEPROGRAM_EXTEND_OPCODE:
			crUnpackExtendValidateProgram(pState);
			break;
		case CR_VERTEXARRAYRANGENV_EXTEND_OPCODE:
			crUnpackExtendVertexArrayRangeNV(pState);
			break;
		case CR_VERTEXATTRIBPOINTERARB_EXTEND_OPCODE:
			crUnpackExtendVertexAttribPointerARB(pState);
			break;
		case CR_VERTEXATTRIBPOINTERNV_EXTEND_OPCODE:
			crUnpackExtendVertexAttribPointerNV(pState);
			break;
		case CR_VERTEXPOINTER_EXTEND_OPCODE:
			crUnpackExtendVertexPointer(pState);
			break;
		case CR_WINDOWCREATE_EXTEND_OPCODE:
			crUnpackExtendWindowCreate(pState);
			break;
		case CR_WINDOWDESTROY_EXTEND_OPCODE:
			crUnpackExtendWindowDestroy(pState);
			break;
		case CR_WINDOWPOS2DARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2dARB(pState);
			break;
		case CR_WINDOWPOS2DVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2dvARB(pState);
			break;
		case CR_WINDOWPOS2FARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2fARB(pState);
			break;
		case CR_WINDOWPOS2FVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2fvARB(pState);
			break;
		case CR_WINDOWPOS2IARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2iARB(pState);
			break;
		case CR_WINDOWPOS2IVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2ivARB(pState);
			break;
		case CR_WINDOWPOS2SARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2sARB(pState);
			break;
		case CR_WINDOWPOS2SVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2svARB(pState);
			break;
		case CR_WINDOWPOS3DARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3dARB(pState);
			break;
		case CR_WINDOWPOS3DVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3dvARB(pState);
			break;
		case CR_WINDOWPOS3FARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3fARB(pState);
			break;
		case CR_WINDOWPOS3FVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3fvARB(pState);
			break;
		case CR_WINDOWPOS3IARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3iARB(pState);
			break;
		case CR_WINDOWPOS3IVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3ivARB(pState);
			break;
		case CR_WINDOWPOS3SARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3sARB(pState);
			break;
		case CR_WINDOWPOS3SVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3svARB(pState);
			break;
		case CR_WINDOWPOSITION_EXTEND_OPCODE:
			crUnpackExtendWindowPosition(pState);
			break;
		case CR_WINDOWSHOW_EXTEND_OPCODE:
			crUnpackExtendWindowShow(pState);
			break;
		case CR_WINDOWSIZE_EXTEND_OPCODE:
			crUnpackExtendWindowSize(pState);
			break;
		case CR_WINDOWVISIBLEREGION_EXTEND_OPCODE:
			crUnpackExtendWindowVisibleRegion(pState);
			break;
		case CR_WRITEBACK_EXTEND_OPCODE:
			crUnpackExtendWriteback(pState);
			break;
		case CR_ZPIXCR_EXTEND_OPCODE:
			crUnpackExtendZPixCR(pState);
			break;
       default:
            crError( "Unknown extended opcode: %d", (int) extend_opcode );
            break;
    }
    INCR_VAR_PTR(pState);
}
static void crUnpackExtendDbg(PCrUnpackerState pState)
{
	CHECK_BUFFER_SIZE_STATIC_LAST(pState, 4, GLenum);
	GLenum extend_opcode = READ_DATA(pState, 4, GLenum);

#ifdef CR_UNPACK_DEBUG_PREV_OPCODES
	g_VBoxDbgCrPrevExtendOpcode = extend_opcode;
#endif

	/*crDebug("Unpacking extended opcode \%d", extend_opcode);*/
	switch( extend_opcode )
	{
		case CR_ACCUM_EXTEND_OPCODE:
			crDebug("Unpack: CR_ACCUM_EXTEND_OPCODE");
			crUnpackExtendAccum(pState);
			break;
		case CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE");
			crUnpackExtendActiveStencilFaceEXT(pState);
			break;
		case CR_ACTIVETEXTUREARB_EXTEND_OPCODE:
			crUnpackExtendActiveTextureARB(pState);
			break;
		case CR_AREPROGRAMSRESIDENTNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_AREPROGRAMSRESIDENTNV_EXTEND_OPCODE");
			crUnpackExtendAreProgramsResidentNV(pState);
			break;
		case CR_ARETEXTURESRESIDENT_EXTEND_OPCODE:
			crDebug("Unpack: CR_ARETEXTURESRESIDENT_EXTEND_OPCODE");
			crUnpackExtendAreTexturesResident(pState);
			break;
		case CR_ATTACHSHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_ATTACHSHADER_EXTEND_OPCODE");
			crUnpackExtendAttachShader(pState);
			break;
		case CR_BARRIERCREATECR_EXTEND_OPCODE:
			crDebug("Unpack: CR_BARRIERCREATECR_EXTEND_OPCODE");
			crUnpackExtendBarrierCreateCR(pState);
			break;
		case CR_BARRIERDESTROYCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_BARRIERDESTROYCR_EXTEND_OPCODE");
			crUnpackExtendBarrierDestroyCR(pState);
			break;
		case CR_BARRIEREXECCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_BARRIEREXECCR_EXTEND_OPCODE");
			crUnpackExtendBarrierExecCR(pState);
			break;
		case CR_BEGINQUERYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BEGINQUERYARB_EXTEND_OPCODE");
			crUnpackExtendBeginQueryARB(pState);
			break;
		case CR_BINDATTRIBLOCATION_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDATTRIBLOCATION_EXTEND_OPCODE");
			crUnpackExtendBindAttribLocation(pState);
			break;
		case CR_BINDBUFFERARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDBUFFERARB_EXTEND_OPCODE");
			crUnpackExtendBindBufferARB(pState);
			break;
		case CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendBindFramebufferEXT(pState);
			break;
		case CR_BINDPROGRAMARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDPROGRAMARB_EXTEND_OPCODE");
			crUnpackExtendBindProgramARB(pState);
			break;
		case CR_BINDPROGRAMNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDPROGRAMNV_EXTEND_OPCODE");
			crUnpackExtendBindProgramNV(pState);
			break;
		case CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendBindRenderbufferEXT(pState);
			break;
		case CR_BLENDCOLOREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLENDCOLOREXT_EXTEND_OPCODE");
			crUnpackExtendBlendColorEXT(pState);
			break;
		case CR_BLENDEQUATIONEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLENDEQUATIONEXT_EXTEND_OPCODE");
			crUnpackExtendBlendEquationEXT(pState);
			break;
		case CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE");
			crUnpackExtendBlendEquationSeparate(pState);
			break;
		case CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE");
			crUnpackExtendBlendFuncSeparateEXT(pState);
			break;
		case CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendBlitFramebufferEXT(pState);
			break;
		case CR_BUFFERDATAARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BUFFERDATAARB_EXTEND_OPCODE");
			crUnpackExtendBufferDataARB(pState);
			break;
		case CR_BUFFERSUBDATAARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BUFFERSUBDATAARB_EXTEND_OPCODE");
			crUnpackExtendBufferSubDataARB(pState);
			break;
		case CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE");
			crUnpackExtendCheckFramebufferStatusEXT(pState);
			break;
		case CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE");
			crUnpackExtendChromiumParameterfCR(pState);
			break;
		case CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE:
			crDebug("Unpack: CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE");
			crUnpackExtendChromiumParameteriCR(pState);
			break;
		case CR_CHROMIUMPARAMETERVCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_CHROMIUMPARAMETERVCR_EXTEND_OPCODE");
			crUnpackExtendChromiumParametervCR(pState);
			break;
		case CR_CLEARACCUM_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARACCUM_EXTEND_OPCODE");
			crUnpackExtendClearAccum(pState);
			break;
		case CR_CLEARCOLOR_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARCOLOR_EXTEND_OPCODE");
			crUnpackExtendClearColor(pState);
			break;
		case CR_CLEARDEPTH_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARDEPTH_EXTEND_OPCODE");
			crUnpackExtendClearDepth(pState);
			break;
		case CR_CLEARINDEX_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARINDEX_EXTEND_OPCODE");
			crUnpackExtendClearIndex(pState);
			break;
		case CR_CLEARSTENCIL_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARSTENCIL_EXTEND_OPCODE");
			crUnpackExtendClearStencil(pState);
			break;
		case CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE");
			crUnpackExtendClientActiveTextureARB(pState);
			break;
		case CR_COLORPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_COLORPOINTER_EXTEND_OPCODE");
			crUnpackExtendColorPointer(pState);
			break;
		case CR_COMBINERINPUTNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERINPUTNV_EXTEND_OPCODE");
			crUnpackExtendCombinerInputNV(pState);
			break;
		case CR_COMBINEROUTPUTNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINEROUTPUTNV_EXTEND_OPCODE");
			crUnpackExtendCombinerOutputNV(pState);
			break;
		case CR_COMBINERPARAMETERFNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERPARAMETERFNV_EXTEND_OPCODE");
			crUnpackExtendCombinerParameterfNV(pState);
			break;
		case CR_COMBINERPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendCombinerParameterfvNV(pState);
			break;
		case CR_COMBINERPARAMETERINV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERPARAMETERINV_EXTEND_OPCODE");
			crUnpackExtendCombinerParameteriNV(pState);
			break;
		case CR_COMBINERPARAMETERIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERPARAMETERIVNV_EXTEND_OPCODE");
			crUnpackExtendCombinerParameterivNV(pState);
			break;
		case CR_COMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendCombinerStageParameterfvNV(pState);
			break;
		case CR_COMPILESHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPILESHADER_EXTEND_OPCODE");
			crUnpackExtendCompileShader(pState);
			break;
		case CR_COMPRESSEDTEXIMAGE1DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXIMAGE1DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexImage1DARB(pState);
			break;
		case CR_COMPRESSEDTEXIMAGE2DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXIMAGE2DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexImage2DARB(pState);
			break;
		case CR_COMPRESSEDTEXIMAGE3DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXIMAGE3DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexImage3DARB(pState);
			break;
		case CR_COMPRESSEDTEXSUBIMAGE1DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXSUBIMAGE1DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexSubImage1DARB(pState);
			break;
		case CR_COMPRESSEDTEXSUBIMAGE2DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXSUBIMAGE2DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexSubImage2DARB(pState);
			break;
		case CR_COMPRESSEDTEXSUBIMAGE3DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXSUBIMAGE3DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexSubImage3DARB(pState);
			break;
		case CR_CREATECONTEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_CREATECONTEXT_EXTEND_OPCODE");
			crUnpackExtendCreateContext(pState);
			break;
		case CR_CREATEPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_CREATEPROGRAM_EXTEND_OPCODE");
			crUnpackExtendCreateProgram(pState);
			break;
		case CR_CREATESHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_CREATESHADER_EXTEND_OPCODE");
			crUnpackExtendCreateShader(pState);
			break;
		case CR_DELETEBUFFERSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEBUFFERSARB_EXTEND_OPCODE");
			crUnpackExtendDeleteBuffersARB(pState);
			break;
		case CR_DELETEFENCESNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEFENCESNV_EXTEND_OPCODE");
			crUnpackExtendDeleteFencesNV(pState);
			break;
		case CR_DELETEFRAMEBUFFERSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEFRAMEBUFFERSEXT_EXTEND_OPCODE");
			crUnpackExtendDeleteFramebuffersEXT(pState);
			break;
		case CR_DELETELISTS_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETELISTS_EXTEND_OPCODE");
			crUnpackExtendDeleteLists(pState);
			break;
		case CR_DELETEOBJECTARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEOBJECTARB_EXTEND_OPCODE");
			crUnpackExtendDeleteObjectARB(pState);
			break;
		case CR_DELETEPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEPROGRAM_EXTEND_OPCODE");
			crUnpackExtendDeleteProgram(pState);
			break;
		case CR_DELETEPROGRAMSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEPROGRAMSARB_EXTEND_OPCODE");
			crUnpackExtendDeleteProgramsARB(pState);
			break;
		case CR_DELETEQUERIESARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEQUERIESARB_EXTEND_OPCODE");
			crUnpackExtendDeleteQueriesARB(pState);
			break;
		case CR_DELETERENDERBUFFERSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETERENDERBUFFERSEXT_EXTEND_OPCODE");
			crUnpackExtendDeleteRenderbuffersEXT(pState);
			break;
		case CR_DELETESHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETESHADER_EXTEND_OPCODE");
			crUnpackExtendDeleteShader(pState);
			break;
		case CR_DESTROYCONTEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_DESTROYCONTEXT_EXTEND_OPCODE");
			crUnpackExtendDestroyContext(pState);
			break;
		case CR_DETACHSHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_DETACHSHADER_EXTEND_OPCODE");
			crUnpackExtendDetachShader(pState);
			break;
		case CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE");
			crUnpackExtendDisableVertexAttribArrayARB(pState);
			break;
		case CR_DRAWBUFFER_EXTEND_OPCODE:
			crDebug("Unpack: CR_DRAWBUFFER_EXTEND_OPCODE");
			crUnpackExtendDrawBuffer(pState);
			break;
		case CR_DRAWBUFFERS_EXTEND_OPCODE:
			crDebug("Unpack: CR_DRAWBUFFERS_EXTEND_OPCODE");
			crUnpackExtendDrawBuffers(pState);
			break;
		case CR_DRAWELEMENTS_EXTEND_OPCODE:
			crDebug("Unpack: CR_DRAWELEMENTS_EXTEND_OPCODE");
			crUnpackExtendDrawElements(pState);
			break;
		case CR_DRAWRANGEELEMENTS_EXTEND_OPCODE:
			crDebug("Unpack: CR_DRAWRANGEELEMENTS_EXTEND_OPCODE");
			crUnpackExtendDrawRangeElements(pState);
			break;
		case CR_EDGEFLAGPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_EDGEFLAGPOINTER_EXTEND_OPCODE");
			crUnpackExtendEdgeFlagPointer(pState);
			break;
		case CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE");
			crUnpackExtendEnableVertexAttribArrayARB(pState);
			break;
		case CR_ENDLIST_EXTEND_OPCODE:
			crDebug("Unpack: CR_ENDLIST_EXTEND_OPCODE");
			crUnpackExtendEndList(pState);
			break;
		case CR_ENDQUERYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ENDQUERYARB_EXTEND_OPCODE");
			crUnpackExtendEndQueryARB(pState);
			break;
		case CR_EXECUTEPROGRAMNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_EXECUTEPROGRAMNV_EXTEND_OPCODE");
			crUnpackExtendExecuteProgramNV(pState);
			break;
		case CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE");
			crUnpackExtendFinalCombinerInputNV(pState);
			break;
		case CR_FINISHFENCENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_FINISHFENCENV_EXTEND_OPCODE");
			crUnpackExtendFinishFenceNV(pState);
			break;
		case CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE");
			crUnpackExtendFlushVertexArrayRangeNV(pState);
			break;
		case CR_FOGCOORDPOINTEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FOGCOORDPOINTEREXT_EXTEND_OPCODE");
			crUnpackExtendFogCoordPointerEXT(pState);
			break;
		case CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendFramebufferRenderbufferEXT(pState);
			break;
		case CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE");
			crUnpackExtendFramebufferTexture1DEXT(pState);
			break;
		case CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE");
			crUnpackExtendFramebufferTexture2DEXT(pState);
			break;
		case CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE");
			crUnpackExtendFramebufferTexture3DEXT(pState);
			break;
		case CR_GENBUFFERSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENBUFFERSARB_EXTEND_OPCODE");
			crUnpackExtendGenBuffersARB(pState);
			break;
		case CR_GENFENCESNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENFENCESNV_EXTEND_OPCODE");
			crUnpackExtendGenFencesNV(pState);
			break;
		case CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE");
			crUnpackExtendGenFramebuffersEXT(pState);
			break;
		case CR_GENLISTS_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENLISTS_EXTEND_OPCODE");
			crUnpackExtendGenLists(pState);
			break;
		case CR_GENPROGRAMSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENPROGRAMSARB_EXTEND_OPCODE");
			crUnpackExtendGenProgramsARB(pState);
			break;
		case CR_GENPROGRAMSNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENPROGRAMSNV_EXTEND_OPCODE");
			crUnpackExtendGenProgramsNV(pState);
			break;
		case CR_GENQUERIESARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENQUERIESARB_EXTEND_OPCODE");
			crUnpackExtendGenQueriesARB(pState);
			break;
		case CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE");
			crUnpackExtendGenRenderbuffersEXT(pState);
			break;
		case CR_GENTEXTURES_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENTEXTURES_EXTEND_OPCODE");
			crUnpackExtendGenTextures(pState);
			break;
		case CR_GENERATEMIPMAPEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENERATEMIPMAPEXT_EXTEND_OPCODE");
			crUnpackExtendGenerateMipmapEXT(pState);
			break;
		case CR_GETACTIVEATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETACTIVEATTRIB_EXTEND_OPCODE");
			crUnpackExtendGetActiveAttrib(pState);
			break;
		case CR_GETACTIVEUNIFORM_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETACTIVEUNIFORM_EXTEND_OPCODE");
			crUnpackExtendGetActiveUniform(pState);
			break;
		case CR_GETATTACHEDOBJECTSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETATTACHEDOBJECTSARB_EXTEND_OPCODE");
			crUnpackExtendGetAttachedObjectsARB(pState);
			break;
		case CR_GETATTACHEDSHADERS_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETATTACHEDSHADERS_EXTEND_OPCODE");
			crUnpackExtendGetAttachedShaders(pState);
			break;
		case CR_GETATTRIBLOCATION_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETATTRIBLOCATION_EXTEND_OPCODE");
			crUnpackExtendGetAttribLocation(pState);
			break;
		case CR_GETATTRIBSLOCATIONS_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETATTRIBSLOCATIONS_EXTEND_OPCODE");
			crUnpackExtendGetAttribsLocations(pState);
			break;
		case CR_GETBOOLEANV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETBOOLEANV_EXTEND_OPCODE");
			crUnpackExtendGetBooleanv(pState);
			break;
		case CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE");
			crUnpackExtendGetBufferParameterivARB(pState);
			break;
		case CR_GETBUFFERSUBDATAARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETBUFFERSUBDATAARB_EXTEND_OPCODE");
			crUnpackExtendGetBufferSubDataARB(pState);
			break;
		case CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE");
			crUnpackExtendGetChromiumParametervCR(pState);
			break;
		case CR_GETCLIPPLANE_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCLIPPLANE_EXTEND_OPCODE");
			crUnpackExtendGetClipPlane(pState);
			break;
		case CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerInputParameterfvNV(pState);
			break;
		case CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerInputParameterivNV(pState);
			break;
		case CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerOutputParameterfvNV(pState);
			break;
		case CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerOutputParameterivNV(pState);
			break;
		case CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerStageParameterfvNV(pState);
			break;
		case CR_GETCOMPRESSEDTEXIMAGEARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMPRESSEDTEXIMAGEARB_EXTEND_OPCODE");
			crUnpackExtendGetCompressedTexImageARB(pState);
			break;
		case CR_GETDOUBLEV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETDOUBLEV_EXTEND_OPCODE");
			crUnpackExtendGetDoublev(pState);
			break;
		case CR_GETERROR_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETERROR_EXTEND_OPCODE");
			crUnpackExtendGetError(pState);
			break;
		case CR_GETFENCEIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFENCEIVNV_EXTEND_OPCODE");
			crUnpackExtendGetFenceivNV(pState);
			break;
		case CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetFinalCombinerInputParameterfvNV(pState);
			break;
		case CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE");
			crUnpackExtendGetFinalCombinerInputParameterivNV(pState);
			break;
		case CR_GETFLOATV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFLOATV_EXTEND_OPCODE");
			crUnpackExtendGetFloatv(pState);
			break;
		case CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE");
			crUnpackExtendGetFramebufferAttachmentParameterivEXT(pState);
			break;
		case CR_GETHANDLEARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETHANDLEARB_EXTEND_OPCODE");
			crUnpackExtendGetHandleARB(pState);
			break;
		case CR_GETINFOLOGARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETINFOLOGARB_EXTEND_OPCODE");
			crUnpackExtendGetInfoLogARB(pState);
			break;
		case CR_GETINTEGERV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETINTEGERV_EXTEND_OPCODE");
			crUnpackExtendGetIntegerv(pState);
			break;
		case CR_GETLIGHTFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETLIGHTFV_EXTEND_OPCODE");
			crUnpackExtendGetLightfv(pState);
			break;
		case CR_GETLIGHTIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETLIGHTIV_EXTEND_OPCODE");
			crUnpackExtendGetLightiv(pState);
			break;
		case CR_GETMAPDV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMAPDV_EXTEND_OPCODE");
			crUnpackExtendGetMapdv(pState);
			break;
		case CR_GETMAPFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMAPFV_EXTEND_OPCODE");
			crUnpackExtendGetMapfv(pState);
			break;
		case CR_GETMAPIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMAPIV_EXTEND_OPCODE");
			crUnpackExtendGetMapiv(pState);
			break;
		case CR_GETMATERIALFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMATERIALFV_EXTEND_OPCODE");
			crUnpackExtendGetMaterialfv(pState);
			break;
		case CR_GETMATERIALIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMATERIALIV_EXTEND_OPCODE");
			crUnpackExtendGetMaterialiv(pState);
			break;
		case CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE");
			crUnpackExtendGetObjectParameterfvARB(pState);
			break;
		case CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE");
			crUnpackExtendGetObjectParameterivARB(pState);
			break;
		case CR_GETPIXELMAPFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPIXELMAPFV_EXTEND_OPCODE");
			crUnpackExtendGetPixelMapfv(pState);
			break;
		case CR_GETPIXELMAPUIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPIXELMAPUIV_EXTEND_OPCODE");
			crUnpackExtendGetPixelMapuiv(pState);
			break;
		case CR_GETPIXELMAPUSV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPIXELMAPUSV_EXTEND_OPCODE");
			crUnpackExtendGetPixelMapusv(pState);
			break;
		case CR_GETPOINTERV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPOINTERV_EXTEND_OPCODE");
			crUnpackExtendGetPointerv(pState);
			break;
		case CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE");
			crUnpackExtendGetPolygonStipple(pState);
			break;
		case CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramEnvParameterdvARB(pState);
			break;
		case CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramEnvParameterfvARB(pState);
			break;
		case CR_GETPROGRAMINFOLOG_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMINFOLOG_EXTEND_OPCODE");
			crUnpackExtendGetProgramInfoLog(pState);
			break;
		case CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramLocalParameterdvARB(pState);
			break;
		case CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramLocalParameterfvARB(pState);
			break;
		case CR_GETPROGRAMNAMEDPARAMETERDVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMNAMEDPARAMETERDVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramNamedParameterdvNV(pState);
			break;
		case CR_GETPROGRAMNAMEDPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMNAMEDPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramNamedParameterfvNV(pState);
			break;
		case CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramParameterdvNV(pState);
			break;
		case CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramParameterfvNV(pState);
			break;
		case CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramStringARB(pState);
			break;
		case CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramStringNV(pState);
			break;
		case CR_GETPROGRAMIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMIV_EXTEND_OPCODE");
			crUnpackExtendGetProgramiv(pState);
			break;
		case CR_GETPROGRAMIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMIVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramivARB(pState);
			break;
		case CR_GETPROGRAMIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMIVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramivNV(pState);
			break;
		case CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE");
			crUnpackExtendGetQueryObjectivARB(pState);
			break;
		case CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE");
			crUnpackExtendGetQueryObjectuivARB(pState);
			break;
		case CR_GETQUERYIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETQUERYIVARB_EXTEND_OPCODE");
			crUnpackExtendGetQueryivARB(pState);
			break;
		case CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE");
			crUnpackExtendGetRenderbufferParameterivEXT(pState);
			break;
		case CR_GETSHADERINFOLOG_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETSHADERINFOLOG_EXTEND_OPCODE");
			crUnpackExtendGetShaderInfoLog(pState);
			break;
		case CR_GETSHADERSOURCE_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETSHADERSOURCE_EXTEND_OPCODE");
			crUnpackExtendGetShaderSource(pState);
			break;
		case CR_GETSHADERIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETSHADERIV_EXTEND_OPCODE");
			crUnpackExtendGetShaderiv(pState);
			break;
		case CR_GETSTRING_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETSTRING_EXTEND_OPCODE");
			crUnpackExtendGetString(pState);
			break;
		case CR_GETTEXENVFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXENVFV_EXTEND_OPCODE");
			crUnpackExtendGetTexEnvfv(pState);
			break;
		case CR_GETTEXENVIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXENVIV_EXTEND_OPCODE");
			crUnpackExtendGetTexEnviv(pState);
			break;
		case CR_GETTEXGENDV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXGENDV_EXTEND_OPCODE");
			crUnpackExtendGetTexGendv(pState);
			break;
		case CR_GETTEXGENFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXGENFV_EXTEND_OPCODE");
			crUnpackExtendGetTexGenfv(pState);
			break;
		case CR_GETTEXGENIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXGENIV_EXTEND_OPCODE");
			crUnpackExtendGetTexGeniv(pState);
			break;
		case CR_GETTEXIMAGE_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXIMAGE_EXTEND_OPCODE");
			crUnpackExtendGetTexImage(pState);
			break;
		case CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE");
			crUnpackExtendGetTexLevelParameterfv(pState);
			break;
		case CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE");
			crUnpackExtendGetTexLevelParameteriv(pState);
			break;
		case CR_GETTEXPARAMETERFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXPARAMETERFV_EXTEND_OPCODE");
			crUnpackExtendGetTexParameterfv(pState);
			break;
		case CR_GETTEXPARAMETERIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXPARAMETERIV_EXTEND_OPCODE");
			crUnpackExtendGetTexParameteriv(pState);
			break;
		case CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE");
			crUnpackExtendGetTrackMatrixivNV(pState);
			break;
		case CR_GETUNIFORMLOCATION_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETUNIFORMLOCATION_EXTEND_OPCODE");
			crUnpackExtendGetUniformLocation(pState);
			break;
		case CR_GETUNIFORMFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETUNIFORMFV_EXTEND_OPCODE");
			crUnpackExtendGetUniformfv(pState);
			break;
		case CR_GETUNIFORMIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETUNIFORMIV_EXTEND_OPCODE");
			crUnpackExtendGetUniformiv(pState);
			break;
		case CR_GETUNIFORMSLOCATIONS_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETUNIFORMSLOCATIONS_EXTEND_OPCODE");
			crUnpackExtendGetUniformsLocations(pState);
			break;
		case CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribPointervARB(pState);
			break;
		case CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribPointervNV(pState);
			break;
		case CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribdvARB(pState);
			break;
		case CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribdvNV(pState);
			break;
		case CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribfvARB(pState);
			break;
		case CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribfvNV(pState);
			break;
		case CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribivARB(pState);
			break;
		case CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribivNV(pState);
			break;
		case CR_HINT_EXTEND_OPCODE:
			crDebug("Unpack: CR_HINT_EXTEND_OPCODE");
			crUnpackExtendHint(pState);
			break;
		case CR_INDEXPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_INDEXPOINTER_EXTEND_OPCODE");
			crUnpackExtendIndexPointer(pState);
			break;
		case CR_INTERLEAVEDARRAYS_EXTEND_OPCODE:
			crDebug("Unpack: CR_INTERLEAVEDARRAYS_EXTEND_OPCODE");
			crUnpackExtendInterleavedArrays(pState);
			break;
		case CR_ISBUFFERARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISBUFFERARB_EXTEND_OPCODE");
			crUnpackExtendIsBufferARB(pState);
			break;
		case CR_ISENABLED_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISENABLED_EXTEND_OPCODE");
			crUnpackExtendIsEnabled(pState);
			break;
		case CR_ISFENCENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISFENCENV_EXTEND_OPCODE");
			crUnpackExtendIsFenceNV(pState);
			break;
		case CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendIsFramebufferEXT(pState);
			break;
		case CR_ISLIST_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISLIST_EXTEND_OPCODE");
			crUnpackExtendIsList(pState);
			break;
		case CR_ISPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISPROGRAM_EXTEND_OPCODE");
			crUnpackExtendIsProgram(pState);
			break;
		case CR_ISPROGRAMARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISPROGRAMARB_EXTEND_OPCODE");
			crUnpackExtendIsProgramARB(pState);
			break;
		case CR_ISQUERYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISQUERYARB_EXTEND_OPCODE");
			crUnpackExtendIsQueryARB(pState);
			break;
		case CR_ISRENDERBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISRENDERBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendIsRenderbufferEXT(pState);
			break;
		case CR_ISSHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISSHADER_EXTEND_OPCODE");
			crUnpackExtendIsShader(pState);
			break;
		case CR_ISTEXTURE_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISTEXTURE_EXTEND_OPCODE");
			crUnpackExtendIsTexture(pState);
			break;
		case CR_LINKPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_LINKPROGRAM_EXTEND_OPCODE");
			crUnpackExtendLinkProgram(pState);
			break;
		case CR_LISTBASE_EXTEND_OPCODE:
			crDebug("Unpack: CR_LISTBASE_EXTEND_OPCODE");
			crUnpackExtendListBase(pState);
			break;
		case CR_LOADPROGRAMNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOADPROGRAMNV_EXTEND_OPCODE");
			crUnpackExtendLoadProgramNV(pState);
			break;
		case CR_LOADTRANSPOSEMATRIXDARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOADTRANSPOSEMATRIXDARB_EXTEND_OPCODE");
			crUnpackExtendLoadTransposeMatrixdARB(pState);
			break;
		case CR_LOADTRANSPOSEMATRIXFARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOADTRANSPOSEMATRIXFARB_EXTEND_OPCODE");
			crUnpackExtendLoadTransposeMatrixfARB(pState);
			break;
		case CR_LOCKARRAYSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOCKARRAYSEXT_EXTEND_OPCODE");
			crUnpackExtendLockArraysEXT(pState);
			break;
		case CR_LOGICOP_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOGICOP_EXTEND_OPCODE");
			crUnpackExtendLogicOp(pState);
			break;
		case CR_MAKECURRENT_EXTEND_OPCODE:
			crDebug("Unpack: CR_MAKECURRENT_EXTEND_OPCODE");
			crUnpackExtendMakeCurrent(pState);
			break;
		case CR_MULTTRANSPOSEMATRIXDARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_MULTTRANSPOSEMATRIXDARB_EXTEND_OPCODE");
			crUnpackExtendMultTransposeMatrixdARB(pState);
			break;
		case CR_MULTTRANSPOSEMATRIXFARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_MULTTRANSPOSEMATRIXFARB_EXTEND_OPCODE");
			crUnpackExtendMultTransposeMatrixfARB(pState);
			break;
		case CR_NEWLIST_EXTEND_OPCODE:
			crDebug("Unpack: CR_NEWLIST_EXTEND_OPCODE");
			crUnpackExtendNewList(pState);
			break;
		case CR_NORMALPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_NORMALPOINTER_EXTEND_OPCODE");
			crUnpackExtendNormalPointer(pState);
			break;
		case CR_POINTPARAMETERFARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_POINTPARAMETERFARB_EXTEND_OPCODE");
			crUnpackExtendPointParameterfARB(pState);
			break;
		case CR_POINTPARAMETERFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_POINTPARAMETERFVARB_EXTEND_OPCODE");
			crUnpackExtendPointParameterfvARB(pState);
			break;
		case CR_POINTPARAMETERI_EXTEND_OPCODE:
			crDebug("Unpack: CR_POINTPARAMETERI_EXTEND_OPCODE");
			crUnpackExtendPointParameteri(pState);
			break;
		case CR_POINTPARAMETERIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_POINTPARAMETERIV_EXTEND_OPCODE");
			crUnpackExtendPointParameteriv(pState);
			break;
		case CR_POPATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_POPATTRIB_EXTEND_OPCODE");
			crUnpackExtendPopAttrib(pState);
			break;
		case CR_POPCLIENTATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_POPCLIENTATTRIB_EXTEND_OPCODE");
			crUnpackExtendPopClientAttrib(pState);
			break;
		case CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE");
			crUnpackExtendProgramEnvParameter4dARB(pState);
			break;
		case CR_PROGRAMENVPARAMETER4DVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMENVPARAMETER4DVARB_EXTEND_OPCODE");
			crUnpackExtendProgramEnvParameter4dvARB(pState);
			break;
		case CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE");
			crUnpackExtendProgramEnvParameter4fARB(pState);
			break;
		case CR_PROGRAMENVPARAMETER4FVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMENVPARAMETER4FVARB_EXTEND_OPCODE");
			crUnpackExtendProgramEnvParameter4fvARB(pState);
			break;
		case CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE");
			crUnpackExtendProgramLocalParameter4dARB(pState);
			break;
		case CR_PROGRAMLOCALPARAMETER4DVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMLOCALPARAMETER4DVARB_EXTEND_OPCODE");
			crUnpackExtendProgramLocalParameter4dvARB(pState);
			break;
		case CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE");
			crUnpackExtendProgramLocalParameter4fARB(pState);
			break;
		case CR_PROGRAMLOCALPARAMETER4FVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMLOCALPARAMETER4FVARB_EXTEND_OPCODE");
			crUnpackExtendProgramLocalParameter4fvARB(pState);
			break;
		case CR_PROGRAMNAMEDPARAMETER4DNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMNAMEDPARAMETER4DNV_EXTEND_OPCODE");
			crUnpackExtendProgramNamedParameter4dNV(pState);
			break;
		case CR_PROGRAMNAMEDPARAMETER4DVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMNAMEDPARAMETER4DVNV_EXTEND_OPCODE");
			crUnpackExtendProgramNamedParameter4dvNV(pState);
			break;
		case CR_PROGRAMNAMEDPARAMETER4FNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMNAMEDPARAMETER4FNV_EXTEND_OPCODE");
			crUnpackExtendProgramNamedParameter4fNV(pState);
			break;
		case CR_PROGRAMNAMEDPARAMETER4FVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMNAMEDPARAMETER4FVNV_EXTEND_OPCODE");
			crUnpackExtendProgramNamedParameter4fvNV(pState);
			break;
		case CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameter4dNV(pState);
			break;
		case CR_PROGRAMPARAMETER4DVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETER4DVNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameter4dvNV(pState);
			break;
		case CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameter4fNV(pState);
			break;
		case CR_PROGRAMPARAMETER4FVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETER4FVNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameter4fvNV(pState);
			break;
		case CR_PROGRAMPARAMETERS4DVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETERS4DVNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameters4dvNV(pState);
			break;
		case CR_PROGRAMPARAMETERS4FVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETERS4FVNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameters4fvNV(pState);
			break;
		case CR_PROGRAMSTRINGARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMSTRINGARB_EXTEND_OPCODE");
			crUnpackExtendProgramStringARB(pState);
			break;
		case CR_PUSHATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PUSHATTRIB_EXTEND_OPCODE");
			crUnpackExtendPushAttrib(pState);
			break;
		case CR_PUSHCLIENTATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PUSHCLIENTATTRIB_EXTEND_OPCODE");
			crUnpackExtendPushClientAttrib(pState);
			break;
		case CR_READBUFFER_EXTEND_OPCODE:
			crDebug("Unpack: CR_READBUFFER_EXTEND_OPCODE");
			crUnpackExtendReadBuffer(pState);
			break;
		case CR_RENDERMODE_EXTEND_OPCODE:
			crDebug("Unpack: CR_RENDERMODE_EXTEND_OPCODE");
			crUnpackExtendRenderMode(pState);
			break;
		case CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE");
			crUnpackExtendRenderbufferStorageEXT(pState);
			break;
		case CR_REQUESTRESIDENTPROGRAMSNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_REQUESTRESIDENTPROGRAMSNV_EXTEND_OPCODE");
			crUnpackExtendRequestResidentProgramsNV(pState);
			break;
		case CR_SAMPLECOVERAGEARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_SAMPLECOVERAGEARB_EXTEND_OPCODE");
			crUnpackExtendSampleCoverageARB(pState);
			break;
		case CR_SECONDARYCOLORPOINTEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_SECONDARYCOLORPOINTEREXT_EXTEND_OPCODE");
			crUnpackExtendSecondaryColorPointerEXT(pState);
			break;
		case CR_SEMAPHORECREATECR_EXTEND_OPCODE:
			crDebug("Unpack: CR_SEMAPHORECREATECR_EXTEND_OPCODE");
			crUnpackExtendSemaphoreCreateCR(pState);
			break;
		case CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE");
			crUnpackExtendSemaphoreDestroyCR(pState);
			break;
		case CR_SEMAPHOREPCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_SEMAPHOREPCR_EXTEND_OPCODE");
			crUnpackExtendSemaphorePCR(pState);
			break;
		case CR_SEMAPHOREVCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_SEMAPHOREVCR_EXTEND_OPCODE");
			crUnpackExtendSemaphoreVCR(pState);
			break;
		case CR_SETFENCENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_SETFENCENV_EXTEND_OPCODE");
			crUnpackExtendSetFenceNV(pState);
			break;
		case CR_SHADERSOURCE_EXTEND_OPCODE:
			crDebug("Unpack: CR_SHADERSOURCE_EXTEND_OPCODE");
			crUnpackExtendShaderSource(pState);
			break;
		case CR_STENCILFUNCSEPARATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_STENCILFUNCSEPARATE_EXTEND_OPCODE");
			crUnpackExtendStencilFuncSeparate(pState);
			break;
		case CR_STENCILMASKSEPARATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_STENCILMASKSEPARATE_EXTEND_OPCODE");
			crUnpackExtendStencilMaskSeparate(pState);
			break;
		case CR_STENCILOPSEPARATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_STENCILOPSEPARATE_EXTEND_OPCODE");
			crUnpackExtendStencilOpSeparate(pState);
			break;
		case CR_SWAPBUFFERS_EXTEND_OPCODE:
			crDebug("Unpack: CR_SWAPBUFFERS_EXTEND_OPCODE");
			crUnpackExtendSwapBuffers(pState);
			break;
		case CR_TESTFENCENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_TESTFENCENV_EXTEND_OPCODE");
			crUnpackExtendTestFenceNV(pState);
			break;
		case CR_TEXCOORDPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_TEXCOORDPOINTER_EXTEND_OPCODE");
			crUnpackExtendTexCoordPointer(pState);
			break;
		case CR_TRACKMATRIXNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_TRACKMATRIXNV_EXTEND_OPCODE");
			crUnpackExtendTrackMatrixNV(pState);
			break;
		case CR_UNIFORM1F_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM1F_EXTEND_OPCODE");
			crUnpackExtendUniform1f(pState);
			break;
		case CR_UNIFORM1FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM1FV_EXTEND_OPCODE");
			crUnpackExtendUniform1fv(pState);
			break;
		case CR_UNIFORM1I_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM1I_EXTEND_OPCODE");
			crUnpackExtendUniform1i(pState);
			break;
		case CR_UNIFORM1IV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM1IV_EXTEND_OPCODE");
			crUnpackExtendUniform1iv(pState);
			break;
		case CR_UNIFORM2F_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM2F_EXTEND_OPCODE");
			crUnpackExtendUniform2f(pState);
			break;
		case CR_UNIFORM2FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM2FV_EXTEND_OPCODE");
			crUnpackExtendUniform2fv(pState);
			break;
		case CR_UNIFORM2I_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM2I_EXTEND_OPCODE");
			crUnpackExtendUniform2i(pState);
			break;
		case CR_UNIFORM2IV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM2IV_EXTEND_OPCODE");
			crUnpackExtendUniform2iv(pState);
			break;
		case CR_UNIFORM3F_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM3F_EXTEND_OPCODE");
			crUnpackExtendUniform3f(pState);
			break;
		case CR_UNIFORM3FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM3FV_EXTEND_OPCODE");
			crUnpackExtendUniform3fv(pState);
			break;
		case CR_UNIFORM3I_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM3I_EXTEND_OPCODE");
			crUnpackExtendUniform3i(pState);
			break;
		case CR_UNIFORM3IV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM3IV_EXTEND_OPCODE");
			crUnpackExtendUniform3iv(pState);
			break;
		case CR_UNIFORM4F_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM4F_EXTEND_OPCODE");
			crUnpackExtendUniform4f(pState);
			break;
		case CR_UNIFORM4FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM4FV_EXTEND_OPCODE");
			crUnpackExtendUniform4fv(pState);
			break;
		case CR_UNIFORM4I_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM4I_EXTEND_OPCODE");
			crUnpackExtendUniform4i(pState);
			break;
		case CR_UNIFORM4IV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM4IV_EXTEND_OPCODE");
			crUnpackExtendUniform4iv(pState);
			break;
		case CR_UNIFORMMATRIX2FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX2FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix2fv(pState);
			break;
		case CR_UNIFORMMATRIX2X3FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX2X3FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix2x3fv(pState);
			break;
		case CR_UNIFORMMATRIX2X4FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX2X4FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix2x4fv(pState);
			break;
		case CR_UNIFORMMATRIX3FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX3FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix3fv(pState);
			break;
		case CR_UNIFORMMATRIX3X2FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX3X2FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix3x2fv(pState);
			break;
		case CR_UNIFORMMATRIX3X4FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX3X4FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix3x4fv(pState);
			break;
		case CR_UNIFORMMATRIX4FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX4FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix4fv(pState);
			break;
		case CR_UNIFORMMATRIX4X2FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX4X2FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix4x2fv(pState);
			break;
		case CR_UNIFORMMATRIX4X3FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX4X3FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix4x3fv(pState);
			break;
		case CR_UNLOCKARRAYSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNLOCKARRAYSEXT_EXTEND_OPCODE");
			crUnpackExtendUnlockArraysEXT(pState);
			break;
		case CR_USEPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_USEPROGRAM_EXTEND_OPCODE");
			crUnpackExtendUseProgram(pState);
			break;
		case CR_VBOXTEXPRESENT_EXTEND_OPCODE:
			crDebug("Unpack: CR_VBOXTEXPRESENT_EXTEND_OPCODE");
			crUnpackExtendVBoxTexPresent(pState);
			break;
		case CR_VALIDATEPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_VALIDATEPROGRAM_EXTEND_OPCODE");
			crUnpackExtendValidateProgram(pState);
			break;
		case CR_VERTEXARRAYRANGENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_VERTEXARRAYRANGENV_EXTEND_OPCODE");
			crUnpackExtendVertexArrayRangeNV(pState);
			break;
		case CR_VERTEXATTRIBPOINTERARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_VERTEXATTRIBPOINTERARB_EXTEND_OPCODE");
			crUnpackExtendVertexAttribPointerARB(pState);
			break;
		case CR_VERTEXATTRIBPOINTERNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_VERTEXATTRIBPOINTERNV_EXTEND_OPCODE");
			crUnpackExtendVertexAttribPointerNV(pState);
			break;
		case CR_VERTEXPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_VERTEXPOINTER_EXTEND_OPCODE");
			crUnpackExtendVertexPointer(pState);
			break;
		case CR_WINDOWCREATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWCREATE_EXTEND_OPCODE");
			crUnpackExtendWindowCreate(pState);
			break;
		case CR_WINDOWDESTROY_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWDESTROY_EXTEND_OPCODE");
			crUnpackExtendWindowDestroy(pState);
			break;
		case CR_WINDOWPOS2DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2DARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2dARB(pState);
			break;
		case CR_WINDOWPOS2DVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2DVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2dvARB(pState);
			break;
		case CR_WINDOWPOS2FARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2FARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2fARB(pState);
			break;
		case CR_WINDOWPOS2FVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2FVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2fvARB(pState);
			break;
		case CR_WINDOWPOS2IARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2IARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2iARB(pState);
			break;
		case CR_WINDOWPOS2IVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2IVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2ivARB(pState);
			break;
		case CR_WINDOWPOS2SARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2SARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2sARB(pState);
			break;
		case CR_WINDOWPOS2SVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2SVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2svARB(pState);
			break;
		case CR_WINDOWPOS3DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3DARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3dARB(pState);
			break;
		case CR_WINDOWPOS3DVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3DVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3dvARB(pState);
			break;
		case CR_WINDOWPOS3FARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3FARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3fARB(pState);
			break;
		case CR_WINDOWPOS3FVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3FVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3fvARB(pState);
			break;
		case CR_WINDOWPOS3IARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3IARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3iARB(pState);
			break;
		case CR_WINDOWPOS3IVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3IVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3ivARB(pState);
			break;
		case CR_WINDOWPOS3SARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3SARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3sARB(pState);
			break;
		case CR_WINDOWPOS3SVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3SVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3svARB(pState);
			break;
		case CR_WINDOWPOSITION_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOSITION_EXTEND_OPCODE");
			crUnpackExtendWindowPosition(pState);
			break;
		case CR_WINDOWSHOW_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWSHOW_EXTEND_OPCODE");
			crUnpackExtendWindowShow(pState);
			break;
		case CR_WINDOWSIZE_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWSIZE_EXTEND_OPCODE");
			crUnpackExtendWindowSize(pState);
			break;
		case CR_WINDOWVISIBLEREGION_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWVISIBLEREGION_EXTEND_OPCODE");
			crUnpackExtendWindowVisibleRegion(pState);
			break;
		case CR_WRITEBACK_EXTEND_OPCODE:
			crDebug("Unpack: CR_WRITEBACK_EXTEND_OPCODE");
			crUnpackExtendWriteback(pState);
			break;
		case CR_ZPIXCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_ZPIXCR_EXTEND_OPCODE");
			crUnpackExtendZPixCR(pState);
			break;
       default:
            crError( "Unknown extended opcode: %d", (int) extend_opcode );
            break;
    }
    INCR_VAR_PTR(pState);
}
